
#include "wx/wx.h"
#include "wx/sizer.h"
#include "wx/dialog.h"
#include "wx/button.h"
#include "wx/stattext.h"
#include "wx/checkbox.h"

//#######################################################
// CheckBox  mF dialog
//#######################################################

class CB1_YesNo_DLG : public wxDialog
{
    wxStaticText   * m_Msg_Ctrl ;
    wxButton       * m_Btn_Yes ;
    wxButton       * m_Btn_No  ;
    wxCheckBox     * m_CKBOXs[6]  ;

  public :

    CB1_YesNo_DLG( wxWindow * parent,
                       int        wid,
                       const wxString & title,
                       const wxString & msg,
                       const wxChar   * txt_CkBoxs[]
                 );
    void OnBtnYesNo( wxCommandEvent & event );

    int  Get_CheckBox_State( int Is_Checked_L[] ) const ;

    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE( CB1_YesNo_DLG, wxDialog )
    EVT_BUTTON( wxID_YES, CB1_YesNo_DLG::OnBtnYesNo )
    EVT_BUTTON( wxID_NO , CB1_YesNo_DLG::OnBtnYesNo )
END_EVENT_TABLE()

//*****************************************************************************
//
//*****************************************************************************

// Define my frame constructor
CB1_YesNo_DLG::CB1_YesNo_DLG
( 
    wxWindow * parent, 
    int        wid,
    const wxString & title,
    const wxString & msg,
    const wxChar   * txt_CkBoxs[]
)  : wxDialog( parent, wid, title,
                 wxDefaultPosition, wxDefaultSize )
{
    wxBoxSizer *sizerTop = new wxBoxSizer( wxVERTICAL );
    wxBoxSizer *sizer2nd = new wxBoxSizer( wxHORIZONTAL );
    wxBoxSizer *sizer3rd = new wxBoxSizer( wxVERTICAL );

    m_Msg_Ctrl  = new wxStaticText( this, wxID_ANY, msg );
    m_Btn_Yes   = new wxButton( this, wxID_YES, wxT("Yes") );
    m_Btn_No    = new wxButton( this, wxID_NO , wxT("No") );
    m_CKBOXs[0] = new wxCheckBox( this, wxID_YES , txt_CkBoxs[0] );
    m_CKBOXs[1] = new wxCheckBox( this, wxID_YES , txt_CkBoxs[1] );

    sizerTop->Add( m_Msg_Ctrl,
                    wxSizerFlags().Align(wxALIGN_RIGHT).Border(wxALL & ~wxBOTTOM, 5));
    sizer2nd->Add( m_Btn_Yes,
                    wxSizerFlags().Align(wxALIGN_LEFT).Border(wxALL & ~wxBOTTOM, 5));
    sizer2nd->Add( m_Btn_No,
                    wxSizerFlags().Align(wxALIGN_LEFT).Border(wxALL & ~wxBOTTOM, 5));
    sizer3rd->Add( m_CKBOXs[0],
                    wxSizerFlags().Align(wxALIGN_LEFT).Border(wxALL & ~wxBOTTOM, 5));
    sizer3rd->Add( m_CKBOXs[1],
                    wxSizerFlags().Align(wxALIGN_LEFT).Border(wxALL & ~wxBOTTOM, 5));

    sizerTop->Add( sizer2nd,
                    wxSizerFlags().Align(wxALIGN_LEFT).Border(wxALL & ~wxBOTTOM, 5));
    sizerTop->Add( sizer3rd,
                    wxSizerFlags().Align(wxALIGN_LEFT).Border(wxALL & ~wxBOTTOM, 5));

    SetSizer( sizerTop );

  // don't allow frame to get smaller than what the sizers tell it and also set
  // the initial size as calculated by the sizers
    sizerTop->SetSizeHints( this );
}

//*****************************************************************************
//
//*****************************************************************************

void 
CB1_YesNo_DLG::OnBtnYesNo( wxCommandEvent & event )
{
    EndModal( event.GetId() ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
CB1_YesNo_DLG::Get_CheckBox_State( int Is_Checked_L[] ) const
{
    Is_Checked_L[0] = m_CKBOXs[0]->IsChecked() ;
    Is_Checked_L[1] = m_CKBOXs[1]->IsChecked() ;

    return( 2 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
Show_CB1_YesNo_Dlg
(  
    wxWindow * parent,
    const wxString & title,
    const wxString & msg,
    const wxChar   * txt_CkBox_L[],
    int              Is_Checked_L[]   //out
)
{
    int  reslt ;

    CB1_YesNo_DLG  dlg( parent, wxID_ANY, title, msg, txt_CkBox_L ) ;
    dlg.Centre() ;

        ::wxLogDebug( wxT("Show_CB1_YesNo_Dlg(): dlg:id=%d"), dlg.GetId() );

    reslt = dlg.ShowModal() ;

    dlg.Get_CheckBox_State( Is_Checked_L ) ;

    return( reslt ) ;
}
