#include  "wx/wx.h"
#include  "wx/filename.h"
#include  "DualTree_Ctl.h"

//*****************************************************************************
//
//*****************************************************************************

DualTreeCtl_DATA::DualTreeCtl_DATA
(
    const DualTreeBASE_BODY * pBody,
    DualTreeBASE_ItemNODE * pMother, 
    int   which, 
    long  sibl_Order, 
    const wxString & name 
)  : DualTreeBASE_ItemDATA( pBody ), DualTreeCtl_ITEM()
{
    DualTreeCtl_ITEM * pItemCtl ;

    Init_Base( pMother, which, sibl_Order, name ) ;

    i_State         = DualTreeCtl_ITEM::st_BACKUP_OPT ;
    i_pItemBase     = (DualTreeBASE_ITEM *) this ;

    m_Is_Valid_L[ 0 ] = 0 ;//Set_TStamp()  Valid ɂȂ
    m_Is_Valid_L[ 1 ] = 0 ;

    pItemCtl = (DualTreeCtl_ITEM *) this ;
    m_pCustomData = (void *) pItemCtl ;
        //::wxLogDebug( "m_pCustomData = %p", m_pCustomData ) ;

    // Set_TStamp() ĂԎ́AeNodepointer Ǝ̖Oset Ă鎖
    if( which >= 2 )
    {
        pItemCtl->Set_TStamp( 0 ) ;
        pItemCtl->Set_TStamp( 1 ) ;
    }
    else
    {
        pItemCtl->Set_TStamp( which ) ;
    }
}

//*****************************************************************************
//
//*****************************************************************************
  
DualTreeCtl_ITEM::DualTreeCtl_ITEM()
{
    i_pItemBase = 0 ;
}

//*****************************************************************************
//
//*****************************************************************************
  
DualTreeCtl_ITEM::~DualTreeCtl_ITEM()
{
    i_pItemBase = 0 ;
}

//*****************************************************************************
//obNAbv̑ΏۂǂԂ
//
//*****************************************************************************

int     
DualTreeCtl_ITEM::Backup_Option() const
{
    long  ind = ( i_State & st_BACKUP_OPT ) / st_BACKUP_OPT ;

    return( (int)ind ) ;
}

//*****************************************************************************
//Backup_Option() Ɠ@\
//   AÅ֐́A[g炽ǂāAobNAbv̑Ώۂǂׂ
//*****************************************************************************

bool     
DualTreeCtl_ITEM::Is_Backup_Target() const
{
    DualTreeCtl_NODE * pMother ;
    bool  bRet ;

    bRet = false ;//default : backup ֎~

    long  flg = i_State & DualTreeCtl_DATA::st_BACKUP_OPT ;

    if( flg )
    {      //backup ΏۂłAĐȅԂɏ]
        pMother = (DualTreeCtl_NODE *) i_pItemBase->m_pMother_L[ 0 ] ;
        if( pMother == 0 )
            pMother = (DualTreeCtl_NODE *) i_pItemBase->m_pMother_L[ 1 ] ;

        if( pMother )
            bRet = pMother->Is_Backup_Target() ;
        else
            bRet = true ;
    }
            //::wxLogDebug( "Is_Backup_Target() flg= %ld, bRet= %d", flg, bRet );
    return( bRet );
}

bool     
DualTreeCtl_ITEM::Is_Hidden()  const
{
    return( ( i_State & DualTreeCtl_ITEM::st_HIDDEN ) != 0 ) ;
}

int     
DualTreeCtl_ITEM::Is_Expanded()  const
{
    return( ( i_State & DualTreeCtl_ITEM::st_EXPANDED_M ) / DualTreeCtl_ITEM::st_EXPANDED ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
DualTreeCtl_ITEM::Set_Backup_Option( int opt )
{
    long opt_Old, opt_New ;

    opt_Old = ( i_State & st_BACKUP_OPT ) / st_BACKUP_OPT ;

    opt_New = opt & st_BACKUP_OPT ;

    i_State &= ~st_BACKUP_OPT ;
    i_State |= opt_New ;

    return( (int) opt_Old ) ;
}

//*****************************************************************************
//  full-path 𓾂
////    Node(Folder) ̎AŌ '/' 
//      *** g  root łȂ
//*****************************************************************************

wxString 
DualTreeCtl_ITEM::Get_Full_Path( int which ) const
{
    wxString  path ;
    const DualTreeBASE_ITEM * pItem ;

    path  = i_pItemBase->m_Name_L[ which ] ;

    if( i_pItemBase->Is_Node() )
        path += wxT("/") ;      //add the letter '/' to the tail

    pItem = i_pItemBase->m_pMother_L[ which ] ;

    for( ; pItem ; pItem = pItem->m_pMother_L[ which ] )
    {
        path = pItem->m_Name_L[ which ] + wxT("/") + path ;
    }

    wxFileName wFnam( path )  ;

    return( wFnam.GetFullPath() ) ;
}

//*****************************************************************************
//  Relative-path 𓾂
////    Node(Folder) ̎AŌ '/' 
//      *** g  root łȂ
//*****************************************************************************

wxString 
DualTreeCtl_ITEM::Get_Relative_Path( int which ) const
{
    wxString  path, s ;
    const DualTreeBASE_ITEM * pItem ;
    const DualTreeBASE_ITEM * pItem_M ;

    path  = i_pItemBase->m_Name_L[ which ] ;

    if( i_pItemBase->Is_Node() )
        path += wxT("/") ;      //add the letter '/' to the tail

    pItem = i_pItemBase->m_pMother_L[ which ] ;

    for( ; ; pItem = pItem_M  )
    {
        pItem_M = pItem->m_pMother_L[ which ] ;
        if( pItem_M == 0 )      break ;//(pItem) mother ȂA܂Atop-node Ȃ break

        path = pItem->m_Name_L[ which ] + wxT("/") + path ;
    }
                //::wxLogDebug( wxT("path=<%s>"), path );
    wxFileName wFnam( path )  ;
    s = wxT(">") + wFnam.GetFullPath() ;

    return( s ) ;
}

//*****************************************************************************
//  update time-stamp set 
//*****************************************************************************

int 
DualTreeCtl_ITEM::Set_TStamp( int which )
{
        bool      b_IsOk;
        wxString  path = Get_Full_Path( which ) ;
                //::wxLogDebug( wxT("DualTreeCtl_ITEM::Set_TStamp( %d ) : path =[%s]"), which, path );

    wxFileName wFnam( path );

    b_IsOk = wFnam.GetTimes( 0, & i_Upd_Date_L[ which ], 0 ) ;

    if( ! b_IsOk )
    {
        i_pItemBase->m_Is_Valid_L[ which ] = -1 ;
                   //::wxLogDebug( wxT("DualTreeCtl_ITEM::Set_TStamp() : Err") );

        return( 1 ) ;
    }

    if( i_pItemBase->Is_Node() )
    {
        i_Data_Size_L[ which ] = wxInvalidSize ;
    }
    else
    {
        i_Data_Size_L[ which ] = wFnam.GetSize() ;
    }

    i_pItemBase->m_Is_Valid_L[ which ] = 1 ;
                   //::wxLogDebug( wxT("DualTreeCtl_ITEM::Set_TStamp() : i_Upd_Date_L[%d]= %s"), which, i_Upd_Date_L[which].Format() );

    return( 0 ) ;
}

//*****************************************************************************
//  00 ; Modification-time, size  Sɓ
//  11 : destination Â
//  10 ; source Â
//  01 : Modification-time w̕(sec_Dead_Band)œA(mɂ͐Ȃ)
//                          A size 
//  02 : Modification-time Asize قȂ
// -10 : source       File ݂Ȃ
// -11 : destination  File ݂Ȃ
//  -1 : source  File̎Asize ȂA
//  -2 : destination  File̎Asize ȂA
//*****************************************************************************

DualTreeCtl_ITEM::Compare_TStamp
(
    time_t sec_Dead_Band    //[sec] r s band 
) const
{
    wxTimeSpan band ;   //band = 0 ;

    int result = 0 ;

    if( i_pItemBase->m_Is_Valid_L[ 0 ] != 1 )     goto  Exit_M10 ;
    if( i_pItemBase->m_Is_Valid_L[ 1 ] != 1 )     goto  Exit_M11 ;

   //={ /10/band l߂
    if( i_Data_Size_L[0] == i_Data_Size_L[1] )
    {      //size v̎Aband = sec_Dead_Band
        band = wxTimeSpan( 0, 0, sec_Dead_Band, 0 )  ;
    }
   //}= /10/

    if     ( i_Upd_Date_L[1].Add( band ) < i_Upd_Date_L[0] )
    {
        result = 11 ;
    }
    else if( i_Upd_Date_L[0].Add( band ) < i_Upd_Date_L[1] )
    {
        result = 10 ;
    }
    else
    {     //镝(band)ȓŁAXV
        if( i_Data_Size_L[0] == i_Data_Size_L[1] )
        {          //size 
            result = 01 ;

            if( i_Upd_Date_L[0] == i_Upd_Date_L[1] )
            {
                result = 0 ;
            }
        }
        else
        {          //size Ȃ
            result = 02 ;
        }
    }

 EXIT :
        //::wxLogDebug( wxT("DualTreeCtl_ITEM::Compare_TStamp(%ld) [%s]: tick=(%ld, %ld) -->%d"),
        //                sec_Dead_Band, i_pItemBase->m_Name_L[0], i_Upd_Date_L[0].GetTicks(), i_Upd_Date_L[1].GetTicks(), result );
    return( result ) ;

 Exit_M10 : result = -10 ; goto EXIT ; 
 Exit_M11 : result = -11 ; goto EXIT ;  
}

//*****************************************************************************
//
//*****************************************************************************
DualTreeCtl_ROOT::DualTreeCtl_ROOT()
    : DualTreeCtl_NODE( (DualTreeBASE_BODY *)this ), DualTreeBASE_BODY()
{
    m_DrawInf_Cursor.m_pItemBase = 0 ;
    i_State =  DualTreeCtl_ITEM::st_EXPANDED_M
             | DualTreeCtl_ITEM::st_BACKUP_OPT ;
}

//*****************************************************************************
//
//*****************************************************************************
//?-1/DualTreeCtl_ROOT::DualTreeCtl_ROOT( DualTreeBASE_ItemNODE * pRoot_Node )
//?-1/    : DualTreeBASE_BODY( pRoot_Node )
//?-1/{
//?-1/    m_DrawInf_Cursor.pItemBase = 0 ;
//?-1/}

//*****************************************************************************
//
//*****************************************************************************
//virtual

DualTreeCtl_ROOT::~DualTreeCtl_ROOT()
{
    //::wxLogDebug( "DualTreeCtl_ROOT::~DualTreeCtl_ROOT()" );
}

//*****************************************************************************
//
//*****************************************************************************
//virtual 
int
DualTreeCtl_ROOT::Set_Item
(
    DualTreeBASE_ITEM * pItem, 
    int which, 
    int flag        //= 0 폜()A= 1 
)
{
        DualTreeCtl_ITEM * pItemCtl ;

    pItemCtl = (DualTreeCtl_ITEM *) pItem->m_pCustomData ;

    if( flag == 0 )
    {      //鎞
        pItem->m_Is_Valid_L[ which ] = 0 ;
        pItem->m_pMother_L [ which ] = 0 ;
        if( pItem->Is_Node() )
            ((DualTreeCtl_NODE *)pItem)->m_Flag_Diff = -1 ;
    }
    else
    {      //
        pItemCtl->Set_TStamp( which ) ;

            //if( pItem->Is_Node() )
                //::wxLogDebug( wxT("DualTreeCtl_ROOT::Set_Item():diff=%ld"),
                //                ((DualTreeCtl_NODE *)pItem)->m_Flag_Diff ) ;
    }

    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************
//virtual
DualTreeBASE_ITEM * 
DualTreeCtl_ROOT::Create_Item
(
    int                   is_Node,
    DualTreeBASE_ItemNODE * pMother,
    int                   which, 
    const wxString &      name
)
{
        DualTreeBASE_ITEM * pItem ;

    if( is_Node )
    {
        pItem = (DualTreeBASE_ITEM *) new DualTreeCtl_NODE( this, pMother, which, 0, name );
    }
    else
    {
        pItem = (DualTreeBASE_ITEM *) new DualTreeCtl_DATA( this, pMother, which, 0, name );
    }
        //::wxLogDebug( wxT("DualTreeCtl_ROOT::Create_Item() --> %p\n"), pItem ) ;

    return( pItem ) ;
}
