#include  <stdlib.h>
#include  "wx/wx.h"
#include  "wx/filename.h"
#include  "DualTree_Ctl.h"
/*
#include  "equal.xpm"
#include  "q_equal.xpm"
#include  "left_dir.xpm"
#include  "right_dir.xpm"
#include  "Checked.xpm"
#include  "Check_Go.xpm"
#include  "Check_NoGo.xpm"
#include  "Check_Undef.xpm"
#include  "Check_Inhibit.xpm"
#include  "diff_ind_0.xpm"
#include  "diff_ind_1.xpm"
#include  "empty.xpm"
*/
//--

extern time_t   g_FileTime_DeadBand ;

//-------------------------------------
static int s_Radius_inCirc = 2 ;

//--
/*
*/

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::Draw_Item
(
    const Item_DrawINFO & itm_DrawInf
)
{
    if( itm_DrawInf.m_pItemBase == 0 )
        return ;

    if( itm_DrawInf.m_pItemBase->Is_Node() )
        Draw_Node_Item( itm_DrawInf );
    else
        Draw_Data_Item( itm_DrawInf );
}

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::Draw_Node_Item
(
    const Item_DrawINFO & itm_DrawInf
)
{
        DualTreeCtl_NODE * pNod ;

        int     x, y, x0, y0, dx, w0, h0, w, h, ix ;
        int     yLeg, w_Cli, h_Cli ;
        short   flg_toDrawName = itm_DrawInf.m_f_Draw_Name ;

        DualTreeCtl_NODE * pNod_Cursor ;
        Item_DrawINFO * pDrawInf_Cursor ;
///        wxBrush  * pBrush ;
        wxRect rect_SelBtn ;  //
        wxPen  pen ;
        wxBitmap * bmp ;

        wxPoint zPos   = itm_DrawInf.m_position ;
        wxPoint zPos_M = itm_DrawInf.m_position ;

        zPos_M.x -= m_Offset_X ;

    pNod = (DualTreeCtl_NODE *)itm_DrawInf.m_pItemBase ;

    dx   = m_X_Siz_Item_L[0] / 4 ;
    x0   = zPos.x ;
    y0   = zPos.y  ;
    w0   = m_X_Siz_Item_L[0] ;
    h0   = m_Y_Siz_Item ;
//    h0   = Height_Item( itm_DrawInf ) ;

    GetClientSize( & w_Cli, & h_Cli ) ;

    //={ erase 
    m_pDC->SetPen( *wxWHITE_PEN ) ;
    m_pDC->SetBrush( m_Brush_Default ) ;
 
    m_pDC->DrawRectangle( x0 - 1, y0 - 1, w_Cli, h0 + 2 ) ;
    //}= erase

    //={ selected state
    if( pNod->i_State & DualTreeCtl_ITEM::st_SELECTED )
    {         //selected marker drawing
        wxPen pen = * wxLIGHT_GREY_PEN ;
        pen.SetStyle( wxDOT ) ;
        m_pDC->SetPen( pen ) ;
        m_pDC->SetBrush( m_Brush_Selected ) ;
 
        m_pDC->DrawRectangle( x0 - 1, y0, w_Cli, h0 ) ;
    }

    //={ cursor mark check
    pNod_Cursor  = 0 ;
    pDrawInf_Cursor = & ((DualTreeCtl_ROOT *)pNod->m_pMyBody)->m_DrawInf_Cursor ;

    if( pDrawInf_Cursor->m_pItemBase == (DualTreeBASE_ITEM *) pNod )
    {        //I am at cursor position. draw 
        m_pDC->SetPen( * wxLIGHT_GREY_PEN ) ;
        m_pDC->SetBrush( * wxTRANSPARENT_BRUSH ) ;
        m_pDC->DrawRectangle( x0 - 1, y0 - 1, w_Cli, h0 + 2 ) ;
    }
    //}= /

    //={ draw main symbol

    pen = m_Pen_Default ;
    if( ( pNod->m_Is_Valid_L[ 0 ] == -1 )  ||  ( pNod->m_Is_Valid_L[ 1 ] == -1 ) )
        pen.SetStyle( wxDOT ) ;

    m_pDC->SetPen( pen );
    m_pDC->SetBrush( m_Brush_Node ) ;

    m_pDC->DrawRoundedRectangle( x0, y0, w0, h0, 2 ) ;

    // draw Node(folder)-Name  (left,right)
    Draw_Item_Text( pNod, flg_toDrawName, x0, y0, w0, h0 ) ;

    //
    Get_Chk_Btn_Rect( wxRect( x0, y0, w0, h0 ), & rect_SelBtn );

    // draw Bacup-Target Btn
    if( pNod->m_Is_Valid_L[ 0 ] )
        Draw_Backup_Option( pNod, rect_SelBtn ) ;

  //={ /draw difference indicator

    x = rect_SelBtn.x + rect_SelBtn.width + 1;

    bmp = & m_Bmp_Node_Diff_Ind[ 0 ] ;

    if( pNod->m_Flag_Diff >= 0 )
    {
        if( pNod->m_Flag_Diff > 0 )
        {
            bmp = & m_Bmp_Node_Diff_Ind[ 1 ] ;
        }
        h = bmp->GetHeight() ;

        m_pDC->DrawBitmap( * bmp, x, y0 + (h0 - h)/2, false ); 
    }

    w = bmp->GetWidth() ;

  //}= /draw difference

  //{= /draw Expand Btn
    x = x + w  ;
    w = x0 + w0 - x - 2;
    w = h0 - 2 ;

    ix  = pNod->Is_Expanded() ;
        //::wxLogDebug( wxT("Draw_Node_Item(%s) ix= %d"), pNod->m_Name_L[0], ix ) ;
    bmp = & m_Bmp_Node_Expanded[ ix ] ;

    m_pDC->DrawBitmap( *bmp, x, y0 + 1 );

//    m_pDC->SetPen( m_Pen_Default ) ;
//    m_pDC->SetBrush( * wxBLUE_BRUSH ) ;
//
//    if( pNod->Is_Expanded_View() )
//    {
//        m_pDC->DrawEllipticArc( x, rect_SelBtn.y, w, rect_SelBtn.height - 2, 
//                                30.0, 210.0 ) ;
//        m_pDC->DrawEllipticArc( x, rect_SelBtn.y + 2, w, rect_SelBtn.height - 2, 
//                                150.0, 330.0 ) ;
//    }
//    else
//    {
//        m_pDC->DrawEllipse( x, rect_SelBtn.y, w, rect_SelBtn.height ); 
///        m_pDC->DrawEllipticArc( x, wr.y, w, wr.height, 
///                                0.0, 180.0 ) ;
///        m_pDC->DrawEllipticArc( x, wr.y, w, wr.height, 
///                                -180.0, -0.0 ) ;
//    }
  //}= end - draw Expand Btn

    Draw_Item_Arms( pNod, zPos_M, x0, y0, w0, h0 );

    //={ 200/ draw Legs(left,right) of the Node

    m_pDC->SetPen( m_Pen_Default );

    y    = y0 + Height_Item( itm_DrawInf ) ;
    yLeg = y + m_Ys_Inter_Item ;

    m_pDC->SetBrush( m_Brush_Fill ) ;

    //-{210/ left (A side)
    x = X_Left_Leg( zPos ) ;

//    m_pDC->SetPen( m_Pen_Default );
//    m_pDC->DrawRectangle( x - 1, y - 1, 3, 3 ) ;

    m_pDC->SetPen( m_Pen_Default );
    m_pDC->DrawLine( x, y, x, yLeg ) ;
    //-}210/

    //-{220/ right (B side)
    x = X_Right_Leg( zPos ) ;

//    m_pDC->SetPen( m_Pen_Default );
//    m_pDC->DrawRectangle( x - 1, y - 1, 3, 3 ) ;

    m_pDC->SetPen( m_Pen_Default );
    m_pDC->DrawLine( x, y, x, yLeg ) ;
    //-}220
    //-}200/
}

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::Draw_Data_Item
(
    const Item_DrawINFO & itm_DrawInf
)
{
        DualTreeCtl_DATA * pDat ;

        int     x0, y0, w0, h0, y_Nam_C ;
        short   flg_toDrawName = itm_DrawInf.m_f_Draw_Name ;
        int     w_Cli, h_Cli, ret ;
        wxRect   rect_SelBtn ;
///        wxBrush  * pBrush ;
        wxPen    pen ;
        wxBitmap * sym ;
        wxFont   font ;

        Item_DrawINFO * pDrawInf_Cursor ;

        wxPoint zPos   = itm_DrawInf.m_position ;
        wxPoint zPos_M = itm_DrawInf.m_position ;

        zPos_M.x -= m_Offset_X ;

    pDat = (DualTreeCtl_DATA *)itm_DrawInf.m_pItemBase ;

    //={ decide symbol-height  (left,right)

    y_Nam_C = 0 ;

    x0   = zPos.x ;
    y0   = zPos.y  ;
    w0   = m_X_Siz_Item_L[1] ;

    h0   = m_Y_Siz_Item ;
//    h0   = Height_Item( itm_DrawInf ) ;
                   //::wxLogDebug( "m_View= (%d, %d), y=(%d,%d)", m_Y1_View, m_Y2_View, y0, y0 + h0 );

    GetClientSize( & w_Cli, & h_Cli ) ;

    //={ erase 
    m_pDC->SetPen( *wxWHITE_PEN ) ;
    m_pDC->SetBrush( m_Brush_Default ) ;
 
    m_pDC->DrawRectangle( x0 - 1, y0 - 1, w_Cli, h0 + 2 ) ;
    //}= erase

    //={ selected state
    if( pDat->i_State & DualTreeCtl_ITEM::st_SELECTED )
    {
        wxPen pen = * wxLIGHT_GREY_PEN ;
        pen.SetStyle( wxDOT ) ;
        m_pDC->SetPen( pen ) ;
        m_pDC->SetBrush( m_Brush_Selected ) ;
 
        m_pDC->DrawRectangle( 0, y0, w_Cli, h0 ) ;
    }
    //}=

    //={ cursor mark check
    pDrawInf_Cursor = & ((DualTreeCtl_ROOT *)pDat->m_pMyBody)->m_DrawInf_Cursor ;

    if( pDrawInf_Cursor->m_pItemBase == (DualTreeBASE_ITEM *) pDat )
    {        //I am at cursor position. draw 
        m_pDC->SetPen( * wxLIGHT_GREY_PEN ) ;
        m_pDC->SetBrush( * wxTRANSPARENT_BRUSH ) ;
        m_pDC->DrawRectangle( x0 - 1, y0 - 1, w_Cli, h0 + 2 ) ;
    }
    //}= /

    //={ draw symbol Frame
    m_pDC->SetBrush( m_Brush_Default ) ;

    pen = m_Pen_Default ;
    if( ( pDat->m_Is_Valid_L[ 0 ] == -1 ) || ( pDat->m_Is_Valid_L[ 1 ] == -1 ) )
        pen.SetStyle( wxDOT ) ;

    m_pDC->SetPen( pen );
    m_pDC->SetClippingRegion( x0, y0, w0, h0 ) ;
    m_pDC->DrawRoundedRectangle( x0, y0, w0 + 4, h0, 4 ) ;
    m_pDC->DrawRoundedRectangle( x0 + w0 - 4, y0, w0, h0, 4 ) ;
    m_pDC->DestroyClippingRegion() ;
    //}= 

    // draw Data(file)-Name  (left,right)
    Draw_Item_Text( pDat, flg_toDrawName, x0, y0, w0, h0 ) ;

    //
    Get_Chk_Btn_Rect( wxRect( x0, y0, w0, h0 ), & rect_SelBtn );

    // draw Bacup-Target Btn
    if( pDat->m_Is_Valid_L[ 0 ] )
        Draw_Backup_Option( pDat, rect_SelBtn ) ;

  //={  data size time-stamp ȑ\

    ret = pDat->Compare_TStamp( g_FileTime_DeadBand ) ;

    if( ret >= 0 )
    {
        if( ret == 1 )
            sym = & m_Bmp_N_Equal_Symb; //nearly equal. band 
        else if( ret == 2 )
            sym = & m_Bmp_Q_Equal_Symb;
        else if( ret == 10 )
            sym= & m_Bmp_Left_Dir_Symb ;//source Â
        else if( ret == 11 )
            sym= & m_Bmp_Right_Dir_Symb ;//destination Â
        else
            sym = & m_Bmp_Equal_Symb; //ret == 0 :completely the same

        m_pDC->DrawBitmap( * sym, rect_SelBtn.GetRight() + 2, y0 + 1, false ) ;
    }

  //}= data size time-stamp ȑ

    Draw_Item_Arms( pDat, zPos_M, x0, y0, w0, h0 ) ;
}

//*****************************************************************************
// draw Item text
//*****************************************************************************

void
DualTree_CTL::Draw_Item_Text
(
    const DualTreeBASE_ITEM * pItemBase,
    int flg_toDrawName,
    int x0, int y0, int w0, int h0
) const
{
    
    int x, y ;

    x = x0 + w0 + 5 ;
    y = y0  ;

    if( flg_toDrawName == 1 )
    {
        m_pDC->DrawText( pItemBase->m_Name_L[0].c_str(), x, y ) ;
    }
    else if( flg_toDrawName == 2 )
    {
        m_pDC->DrawText( pItemBase->m_Name_L[1].c_str(), x, y ) ;
    }
    else if( flg_toDrawName == 3 )
    {
        y = y0 - 5 ;
        m_pDC->DrawText( pItemBase->m_Name_L[0].c_str(), x, y ) ;

        y = y0 + 6 ;
        m_pDC->DrawText( pItemBase->m_Name_L[1].c_str(), x, y ) ;
    }
}

//*****************************************************************************
// draw Bacup-Target Btn
//*****************************************************************************

void
DualTree_CTL::Draw_Backup_Option
(
    const DualTreeCtl_ITEM * pItem,
    const wxRect & btnRect
) const
{
        wxRect  wr ;
        int  ind ;
///        wxBrush * pBrush ;
        wxBitmap * bmp ;

///    pBrush = (wxBrush *) & m_Brush_BkupTarget_F ;//backup ͐eNode ɏ]

    ind  = pItem->Backup_Option() ;
    if( ind == 1 )
    {   //backup ͐em[hɏ]
        if( pItem->Is_Backup_Target() )
            bmp = (wxBitmap *) & m_Bmp_Backup_Chked ;
        else
            bmp = (wxBitmap *) & m_Bmp_Backup_NoGo ;
    }  
    else
    {      //backup ΏۂłȂ
///        pBrush = (wxBrush *) & m_Brush_Default ;
        bmp = (wxBitmap *) & m_Bmp_EmptySpace ;
    }

    wr = btnRect ;
    wr.Inflate( -2, -2 ) ;

    m_pDC->SetClippingRegion( wr ) ;
    m_pDC->DrawBitmap( *bmp, wr.x, wr.y, false ) ;

    m_pDC->DestroyClippingRegion();

//    m_pDC->SetBrush( * pBrush ) ;
    m_pDC->SetBrush( * wxTRANSPARENT_BRUSH ) ;
    m_pDC->SetPen( m_Pen_Default ) ;

    m_pDC->DrawRectangle( btnRect.x, btnRect.y, 
                          btnRect.width, btnRect.height ) ;
}

//*****************************************************************************
// draw Item arms
//*****************************************************************************

void
DualTree_CTL::Draw_Item_Arms
(
    const DualTreeCtl_ITEM * pItem,
    const wxPoint & zPos_M,     //eNode ʒu
    int  x0, int y0, int w0, int h0 
)  const
{
    wxPen  pen ;
    int  iRight, y_Lev, x ;
    //={ A-side(upper) line & terminal

    iRight = x0 ;
    y_Lev  = y0 + h0 / 3 ;

    m_pDC->SetBrush( m_Brush_Fill ) ;

    if( pItem->i_pItemBase->m_Is_Valid_L[ 0 ] )
    {       //A-side(upper) `
        x  = X_Left_Leg( zPos_M ) ;

        m_pDC->SetPen( m_Pen_Default );

        m_pDC->DrawRectangle( x - 1, y_Lev - 1, 3, 3 ) ;

        pen = m_Pen_Default ;
        if( pItem->i_pItemBase->m_Is_Valid_L[ 0 ] ==  -1 )
            pen = * wxGREY_PEN ;

        m_pDC->SetPen( pen );

        m_pDC->DrawLine( x, y_Lev, iRight, y_Lev ) ;
    }

    //A item box ͓̓_`. A-side(upper) 
    m_pDC->SetPen( m_Pen_Default );
	m_pDC->DrawCircle( iRight, y_Lev, s_Radius_inCirc ) ;
    //}= A-side

    //={ B-side(lower) line & terminal
    y_Lev = y0 + h0 * 2 / 3 ;

    if( pItem->i_pItemBase->m_Is_Valid_L[ 1 ] )
    {       //B-side(lower) `
        x  = X_Right_Leg( zPos_M ) ;

        m_pDC->SetPen( m_Pen_Default );
        m_pDC->DrawRectangle( x - 1, y_Lev - 1, 3, 3 ) ;

        pen = m_Pen_Default ;
        if( pItem->i_pItemBase->m_Is_Valid_L[ 1 ] == -1 )
            pen = * wxGREY_PEN ;
        m_pDC->SetPen( pen );

        m_pDC->DrawLine( x, y_Lev, iRight, y_Lev ) ;

    }
    //item box ͓̓_`. B-side(upper)
    m_pDC->SetPen( m_Pen_Default );
	m_pDC->DrawCircle( iRight, y_Lev, s_Radius_inCirc ) ;
    //}= B-side
}
