#include  <stdlib.h>
#include  "wx/wx.h"
#include  "wx/filename.h"
#include  "wx/app.h"
#include  "Backup_Diff.h"
#include  "DualTree_Ctl.h"
#include  "TopFrame.h"
#include  "Proc_Space.h"

extern MyApp & wxGetApp() ;

//*****************************************************************************
//
//*****************************************************************************

DualTreeCtl_NODE::DualTreeCtl_NODE
(
    const DualTreeBASE_BODY * pBody,
    DualTreeBASE_ItemNODE * pMother, 
    int   which, 
    long  sibl_Order, 
    const wxString & name 
)  : DualTreeBASE_ItemNODE( pBody ), DualTreeCtl_ITEM()
{
    DualTreeCtl_ITEM * pItemCtl ;

    Init_Base( pMother, which, sibl_Order, name ) ;
    i_State     = DualTreeCtl_ITEM::st_BACKUP_OPT ;
    i_pItemBase = this ;

    m_Is_Valid_L[ 0 ] = 0 ;
    m_Is_Valid_L[ 1 ] = 0 ;

    pItemCtl = (DualTreeCtl_ITEM *) this ;
    m_pCustomData = (void *) pItemCtl ;
        //::wxLogDebug( "m_pCustomData = %p", m_pCustomData ) ;

    m_Flag_Diff = -1 ;

    if( which < 0 )   return ;

    if( which >= 2 )
    {
        pItemCtl->Set_TStamp( 0 ) ;
        pItemCtl->Set_TStamp( 1 ) ;
    }
    else
    {
        pItemCtl->Set_TStamp( which ) ;
    }
}

//*****************************************************************************
//
//*****************************************************************************

DualTreeCtl_NODE::~DualTreeCtl_NODE()
{
    i_pItemBase = 0 ;
}

//*****************************************************************************
//
//*****************************************************************************

int
DualTreeCtl_NODE::Reset_Diff_Flag()
{
    DualTreeCtl_NODE * pNod ;
    int   i ;

    m_Flag_Diff = -1 ;

    for( i = 0 ; i < m_Count_Children ; i ++ )
    {
        pNod = (DualTreeCtl_NODE *) Item_Ptr( i ) ;

        if( ! pNod->Is_Node() )  continue ;

        pNod->Reset_Diff_Flag() ;
    }

    return( 0 ) ;
}
//*****************************************************************************
//  result < 0 --> fatal error returned from Add_Child_Node()
//  result = 1 --> directory not exists
//*****************************************************************************

int  
DualTreeCtl_NODE::Set_BackupOpt_Children
(
    int  opt 
)
{
        int  i, cnt ;
        DualTreeBASE_ITEM * pItemBase ;
        DualTreeCtl_ITEM * pItem ;
        DualTreeCtl_NODE * pNode ;

    cnt = 0 ;

    for( i = 0 ; i < m_Count_Children ; i ++ )
    {
        pItemBase = Item_Ptr( i ) ;

        pItem = (DualTreeCtl_ITEM *) pItemBase->m_pCustomData ;

        cnt ++ ;

        pItem->Set_Backup_Option( opt ) ;

        if( ! pItemBase->Is_Node() )  continue ;

        pNode = (DualTreeCtl_NODE *) pItemBase ;

        if( pNode->Is_Expanded() < 3 ) continue ;

        cnt += pNode->Set_BackupOpt_Children( opt ) ;
    }

    return( cnt );
}

//*****************************************************************************
//
//*****************************************************************************

long  
DualTreeCtl_NODE::Count_Specific_State
(
    long mask, 
    long value 
)  const
{
        int   i ;
        long  cnt ;
        DualTreeBASE_ITEM * pItemBase ;
        DualTreeCtl_ITEM  * pItem ;
//        DualTreeCtl_NODE  * pNode ;

    value &= mask ;
    cnt    = 0 ;

    for( i = 0 ; i < m_Count_Children ; i ++ )
    {
        pItemBase = Item_Ptr( i ) ;

        pItem = (DualTreeCtl_ITEM *) pItemBase->m_pCustomData ;

        if( (pItem->i_State & mask) == value )  cnt ++ ;

        if( ! pItemBase->Is_Node() )  continue ;

        cnt += ((DualTreeCtl_NODE *)pItem)->Count_Specific_State( mask, value ) ;
    }

    return( cnt ) ;
}

//*****************************************************************************
//
//*****************************************************************************

void  
DualTreeCtl_NODE::Set_State_All
(
    long mask, 
    long value 
)
{
        int  i ;
        DualTreeBASE_ITEM * pItemBase ;
        DualTreeCtl_ITEM  * pItem ;
//        DualTreeCtl_NODE  * pNode ;

    value &= mask ;

    for( i = 0 ; i < m_Count_Children ; i ++ )
    {
        pItemBase = Item_Ptr( i ) ;

        pItem = (DualTreeCtl_ITEM *) pItemBase->m_pCustomData ;

        pItem->i_State &= ~mask  ;
        pItem->i_State |= value ;

        if( ! pItemBase->Is_Node() )  continue ;

        ((DualTreeCtl_NODE *)pItem)->Set_State_All( mask, value ) ;
    }
}

//*****************************************************************************
// (this) (=Foloder) ̉ children  load ĊJ
//*****************************************************************************

int  
DualTreeCtl_NODE::Begin_Load_Children
(
    DTree_SORT & dTree_Sort,
    int which 
)
{
    int ret ;

    Proc_SPACE prc( (TopFRAME *)::wxGetApp().GetTopWindow(), which ) ;

    ret = prc.Load_Children( this ) ;

    Sort_Children( dTree_Sort );

///    Refresh() ;
    
    return( ret ) ;
}

//*****************************************************************************
//  Refer_Other() Ŏgp֐
//*****************************************************************************

static
int
S_Compare( void * e1, void * e2 )
{
    int k1, k2, ret ;

    DualTreeBASE_ITEM * pItem_1 = * (DualTreeBASE_ITEM **) e1;
    DualTreeBASE_ITEM * pItem_2 = * (DualTreeBASE_ITEM **) e2;

    k1 = k2 = 0 ;

    if( pItem_1->Is_Node() )
        k1 = 1 ;   //pItem_1 ̏ʂ
    if( pItem_2->Is_Node() )
        k2 = 1 ;   //pItem_2 ̏ʂ
    if( k1 != k2 )   return( k2 - k1 ) ;

    ret = pItem_1->m_Name_L[ 0 ].Cmp( pItem_2->m_Name_L[0] ) ;

    return( ret ) ;
}

//#############################################################################
//
//#############################################################################

class Child_VECT : public D_VECTOR
{
  public :

    Child_VECT();
    //virtual 
    int Compare( void * e1, void * e2 );
};

//*****************************************************************************
//
//*****************************************************************************

Child_VECT::Child_VECT()
  : D_VECTOR()
{
}

//*****************************************************************************
//
//*****************************************************************************

int
Child_VECT::Compare( void * e1, void * e2 )
{
    return ::S_Compare( e1, e2 ) ;
}

//*****************************************************************************
// Qside tree( nodeOther ) ɓ filefolder 
//   state copy 
//*****************************************************************************

int  
DualTreeCtl_NODE::Refer_Other
(
    DTree_SORT & dTree_Sort,
    const DualTreeCtl_NODE & nodeOther 
) 
{
    DualTreeBASE_ITEM ** pItem, ** pItem_R ;
    DualTreeCtl_NODE * pNod, * pNod_R ;
    DualTreeCtl_DATA * pDat, * pDat_R ;

    Child_VECT  array ;
    int   ret, ret_1, ret_2 ;
    long  idx, idx_R ;

    if( m_Count_Children <= 0 )  return( 0 ) ;

        ::wxLogDebug( wxT("%p->DualTreeCtl_NODE::Refer_Other(%p)\n"), this, & nodeOther );
        ::wxLogDebug( wxT("  m_Count_Children=%ld, %ld\n"), m_Count_Children, nodeOther.m_Count_Children );

    pItem   = (DualTreeBASE_ITEM **) new myDualTree_ItemBasePTR [ m_Count_Children ] ;
    pItem_R = (DualTreeBASE_ITEM **) new myDualTree_ItemBasePTR [ nodeOther.m_Count_Children ] ;

    memcpy( pItem, m_ChildPtr_Arry, m_Count_Children * sizeof( myDualTree_ItemBasePTR ) ) ;
    memcpy( pItem_R, nodeOther.m_ChildPtr_Arry, nodeOther.m_Count_Children * sizeof( myDualTree_ItemBasePTR ) ) ;
        //::wxLogDebug( wxT("0: cnt=%d, (%p,%p,%p),(%p,%p,%p)\n"), m_Count_Children, m_ChildPtr_Arry[0],
        //                m_ChildPtr_Arry[1],m_ChildPtr_Arry[2], pItem[0],pItem[1], pItem[2] );
    array.Sort( pItem, sizeof( m_ChildPtr_Arry[0] ), m_Count_Children ) ;
    array.Sort( pItem_R, sizeof( m_ChildPtr_Arry[0] ), nodeOther.m_Count_Children ) ;
        //::wxLogDebug( wxT("1: cnt=%d, (%p,%p,%p),(%p,%p,%p)\n"), m_Count_Children, m_ChildPtr_Arry[0],
        //                m_ChildPtr_Arry[1],m_ChildPtr_Arry[2], pItem[0],pItem[1], pItem[2] );
    idx     = 0 ;
    idx_R   = 0 ;

    for( ; ; )
    {
        if( idx >= m_Count_Children )  break ;
        if( idx_R >= nodeOther.m_Count_Children )  break ;

        ret = ::S_Compare( & pItem[ idx ], & pItem_R[ idx_R ] ) ;
               //::wxLogDebug( wxT("idx=%d, idx_R=%d,  S_Compare() --> %d\n"), idx, idx_R, ret ) ;
        if( ret > 0 )
        {     //
            idx ++ ;

            continue ;
        }

        if(  ret < 0 )
        {
            idx_R ++ ;

            continue ;
        }

        //pItem[ idx ]@== pItem_R[ idx_R ] case 

//        if( pItem[ idx ]->i_pItemBase->Is_Node() )
        if( pItem[ idx ]->Is_Node() )
        {
            pNod   = (DualTreeCtl_NODE *) pItem[ idx ] ;
            pNod_R = (DualTreeCtl_NODE *) pItem_R[ idx_R ] ;

            pNod->i_State = pNod_R->i_State ; //& ~DualTreeCtl_ITEM::st_EXPANDED_M ;

            if( pNod_R->m_State_Load_L[ 0 ] == 1 )
            {
                ret_1 = pNod->Begin_Load_Children( dTree_Sort, 0 );
                ret_2 = pNod->Begin_Load_Children( dTree_Sort, 1 );

                pNod->Refer_Other( dTree_Sort, * pNod_R ) ;
            }
        }
        else
        {
            pDat   = (DualTreeCtl_DATA *) pItem[ idx ] ;
            pDat_R = (DualTreeCtl_DATA *) pItem_R[ idx_R ] ;

            pDat->i_State = pDat_R->i_State ;
        }

        idx ++ ;
        idx_R ++ ;
    }
               ::wxLogDebug( wxT(" Refer_Other() Exit : idx=%d, idx_R=%d\n"), idx, idx_R ) ;

    delete[] pItem ;
    delete[] pItem_R ;

    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
DualTreeCtl_NODE::Sort_Children( DTree_SORT & dTree_Sort )
{
    DualTreeBASE_ITEM * pIBase ;

    int  ii ;

            for( ii = 0 ; ii < m_Count_Children ; ii ++ ) ::wxLogDebug( wxT("old =%p  isNode=%d\n"), m_ChildPtr_Arry[ ii ], m_ChildPtr_Arry[ ii ]->Is_Node() );
    // children  sort
    dTree_Sort.Sort( m_ChildPtr_Arry, sizeof(DualTreeBASE_ITEM *),
                                              m_Count_Children );
            for( ii = 0 ; ii < m_Count_Children ; ii ++ ) ::wxLogDebug( wxT("new =%p  isNode=%d\n"), m_ChildPtr_Arry[ ii ], m_ChildPtr_Arry[ ii ]->Is_Node() );

    //children ̒ Node(Folder) ΁A Child-Node Sort
    for( ii = 0 ; ii < m_Count_Children ; ii ++ )
    {
        pIBase = m_ChildPtr_Arry[ ii ] ;

        if( ! pIBase->Is_Node() )  continue ;

        ((DualTreeCtl_NODE *) pIBase)->Sort_Children( dTree_Sort ) ;
    }

    return( 0 ) ;
}
