#include  "wx/wx.h"
#include  "wx/filename.h"
#include  "DualTree_Ctl.h"


//*****************************************************************************
//
//*****************************************************************************

DTree_SORT::DTree_SORT
( 
)  : D_VECTOR()
{
    short i ;

    m_Cnt_Priority = 6 ;

    for( i = 0 ; i < m_Cnt_Priority ; i ++ )
        m_Priority_Lst[ i ] = i + 1 ;
}

//*****************************************************************************
//
//*****************************************************************************

void
DTree_SORT::Set_Priority( const short sort_Priority_Lst[] )
{
    short i, j, x, xa ;

    short  check_Lst[8] ;//for doubled priority check 

    for( i = 0 ; i < m_Cnt_Priority ; i ++ )
        check_Lst[ i ] = 0 ;

    j = 0 ;

    for( i = 0 ; i < m_Cnt_Priority ; i ++ )
    {
        x  = sort_Priority_Lst[ i ] ;
        xa = abs( x );

        if( xa < 1  ||  6 < xa )  continue ;  // must. 1 <= x <= 6

        if( check_Lst[ xa - 1 ] )  continue ; // priority doubled

        check_Lst[ xa - 1 ] = 1 ;

        m_Priority_Lst[ j ++ ] = x ;
    }

    if( j != m_Cnt_Priority )
    {
        for( i = 0 ; i < m_Cnt_Priority ; i ++ )
            m_Priority_Lst[ i ] = i + 1 ;
    }
}

//*****************************************************************************
//
//*****************************************************************************

void
DTree_SORT::Reverse_Priority()
{
        short i;

    for( i = 0 ; i < m_Cnt_Priority ; i ++ )
        m_Priority_Lst[ i ] = - m_Priority_Lst[ i ] ;
}

//*****************************************************************************
//  idx ʒũf[^Aidx_New ̈ʒuɈړđ}
//*****************************************************************************

void
DTree_SORT::Move_Priority( int idx_New, int idx ) 
{
    short  sav, i, cnt ;
        short * p = m_Priority_Lst ;
       ::wxLogDebug( wxT("Move_Sort_Priority( %d, %d) Start: %hd,%hd,%hd,%hd,%hd,%hd"),
                                       idx, idx_New, p[0],p[1],p[2],p[3],p[4],p[5] );

    if( idx_New == idx )   return ;

    sav = m_Priority_Lst[ idx ] ;

  //={ idx ʒũf[^OāAOɋl߂
    cnt = 0 ;
    for( i = 0 ; i < m_Cnt_Priority ; i ++ )
    {
        if( i == idx ) continue ;

        m_Priority_Lst[ cnt ] =  m_Priority_Lst[ i ] ;
        cnt ++  ;
    }
       ::wxLogDebug( wxT("Move_Sort_Priority() 100: cnt=%hd :  %hd,%hd,%hd,%hd,%hd,%hd"),
                                      cnt, p[0],p[1],p[2],p[3],p[4],p[5] );

  //={ idx_New ʒuɋ󂫂(Ō1Âړ)

    for( i = cnt - 1 ; i >= idx_New ; i -- )
    {
        m_Priority_Lst[ i + 1 ] =  m_Priority_Lst[ i ] ;
    }

    m_Priority_Lst[ idx_New ] = sav ;

       ::wxLogDebug( wxT("Move_Sort_Priority() End: %hd,%hd,%hd,%hd,%hd,%hd"),
                                         p[0],p[1],p[2],p[3],p[4],p[5] );
}

//*****************************************************************************
//  ʔ֐
//*****************************************************************************

int
DTree_SORT::Compare( void * e1, void * e2 )
{
    DualTreeBASE_ITEM * pItem_1 = * (DualTreeBASE_ITEM **) e1;
    DualTreeBASE_ITEM * pItem_2 = * (DualTreeBASE_ITEM **) e2;
    DualTreeCtl_ITEM * pItemCtl_1 = (DualTreeCtl_ITEM *) pItem_1->m_pCustomData ;
    DualTreeCtl_ITEM * pItemCtl_2 = (DualTreeCtl_ITEM *) pItem_2->m_pCustomData ;

    int  sort_typ = 0;
    int  ii, ret ;
    int  k1 = 0, k2 = 0 ;// k1, k2 ́AlAɂȂ
    wxString    nam1, nam2 ;
    wxFileName  fn1 , fn2  ;
    wxDateTime  date_1, date_2 ;
    wxULongLong dsiz_1, dsiz_2 ;

    for( ii = 0 ; ii < m_Cnt_Priority ; ii ++ )
    {         // ʍo܂ŁAeX̑ɂAʔr
        k1 = 0 ; k2 = 0 ;
        sort_typ = m_Priority_Lst[ ii ] ;
        //
        switch( abs( sort_typ ) )
        {
            case  1 :  //file / folder order
                if( pItem_1->Is_Node() )
                    k1 = 1 ;   //pItem_1 ̏ʂ
                if( pItem_2->Is_Node() )
                    k2 = 1 ;   //pItem_2 ̏ʂ
                break ;

            case  2 :  //source / destination order
                if( pItem_1->m_Is_Valid_L[0] )
                    k1 = 2 ;
                if( pItem_1->m_Is_Valid_L[1] )
                    k1 += 1 ;

                if( pItem_2->m_Is_Valid_L[0] )
                    k2 = 2 ;
                if( pItem_2->m_Is_Valid_L[1] )
                    k2 += 1 ;
                break ;

            case  3 :  //name
                nam1 = pItem_1->m_Name_L[ 0 ];
                if( nam1.IsEmpty() )
                    nam1 = pItem_1->m_Name_L[ 1 ];
                nam2 = pItem_2->m_Name_L[ 0 ];
                if( nam2.IsEmpty() )
                    nam2 = pItem_2->m_Name_L[ 1 ];
 
                nam1.MakeUpper() ;
                nam2.MakeUpper() ;
               
                // ȌʂɂẮAk1, k2 ͏傫
                if( nam1 < nam2 )
                {
                    k1 = 1; //nam1 
                }
                else if( nam1 > nam2 )
                {
                    k2 = 1;
                }
                    //::wxLogDebug( wxT("Compare() : nam =(<%s>, <%s>),  k=(%d, %d)"), nam1, nam2, k1, k2 );
                break ;

             case  4 :  //file-type
                nam1 = pItem_1->m_Name_L[ 0 ];
                if( nam1.IsEmpty() )
                    nam1 = pItem_1->m_Name_L[ 1 ];
                nam2 = pItem_2->m_Name_L[ 0 ];
                if( nam2.IsEmpty() )
                    nam2 = pItem_2->m_Name_L[ 1 ];
                fn1.Assign( nam1 ) ;
                fn2.Assign( nam2 ) ;
                nam1 = fn1.GetExt() ;
                nam2 = fn2.GetExt() ;
                nam1.MakeUpper() ;
                nam2.MakeUpper() ;
                // ȌʂɂẮAk1, k2 ͏傫
                if( nam1 < nam2 )
                {
                    k1 = 1;  //nam1 
                }
                else if( nam1 > nam2 )
                {
                    k2 = 1;
                }
                break ;

             case  5 :  //time stamp
                date_1 = pItemCtl_1->i_Upd_Date_L[ 0 ] ;
                if( pItem_1->m_Is_Valid_L[ 0 ] == 0 ) 
                    date_1 = pItemCtl_1->i_Upd_Date_L[ 1 ] ;

                date_2 = pItemCtl_2->i_Upd_Date_L[ 0 ] ;
                if( pItem_2->m_Is_Valid_L[ 0 ] == 0 ) 
                    date_2 = pItemCtl_2->i_Upd_Date_L[ 1 ] ;

                if( date_1 > date_2 )
                {
                    k1 = 1;
                }
                else if( date_1 < date_1 )
                {
                    k2 = 1;
                }
                break ;

            case  6 :  //size
                if( pItem_1->Is_Node() )  break ;
                if( pItem_2->Is_Node() )  break ;

                dsiz_1 = pItemCtl_1->i_Data_Size_L[0] ;
                if( dsiz_1 == wxInvalidSize )
                    dsiz_1 = pItemCtl_1->i_Data_Size_L[1] ;

                dsiz_2 = pItemCtl_2->i_Data_Size_L[0] ;
                if( dsiz_2 == wxInvalidSize )
                    dsiz_2 = pItemCtl_2->i_Data_Size_L[1] ;
                if( dsiz_1 > dsiz_2 )
                    k1 = 1;
                else if( dsiz_1 < dsiz_2 )
                    k2 = 1 ;
                break ;
        }

        if( k1 != k2 ) break ;//ʍꂽ̂ compare end
    }

    ret = k2 - k1 ; //̒l( k2 > k1 )ԂƁAe2  e1 OɂȂA

    if( sort_typ < 0 )  //
    {          //
        ret = - ret ;
    }
        ::wxLogDebug( wxT("DTree_SORT::Compare( %p, %p ) --> %d"), pItem_1, pItem_2, ret ) ;

    return( ret ) ;
}

//*****************************************************************************
//
//*****************************************************************************

//DualTree_CTL::Sort_All()
//{
//    Sort_Node_Children( m_pRoot_Node );
//}

