#include  <memory.h>
#include  "D_Vector.h"

//*****************************************************************************
//
//*****************************************************************************

D_VECTOR::D_VECTOR()
{
    dv_Vector = 0 ;
    dv_ElmSiz = 0 ;
    dv_Count  = 0 ;

    dv_WkVar  = dv_WkVar_O ;

    dv_WkVar_A = 0 ;
}

//*****************************************************************************
//
//*****************************************************************************

D_VECTOR::D_VECTOR( const void * vectPtr, int elmSiz, long cnt )
{
    dv_WkVar_A = 0 ;

    Set( vectPtr, elmSiz, cnt );
}

//*****************************************************************************
//
//*****************************************************************************

D_VECTOR::~D_VECTOR()
{
    if( dv_WkVar_A )
        delete[] dv_WkVar_A ;
}

//*****************************************************************************
//
//*****************************************************************************

int
D_VECTOR::Set( const void * vectPtr, int elmSiz, long cnt )
{
    int  reslt ;

    reslt = 0 ;

    dv_Vector = (char *) vectPtr ;
    dv_ElmSiz = (short) elmSiz ;
    dv_Count  = cnt ;

    if( dv_WkVar_A )
        delete[] dv_WkVar_A ;

    dv_WkVar_A = 0 ;

    if( elmSiz > 254 )
    {
        dv_WkVar_A  = new char[ elmSiz + 2 ];
        dv_WkVar  = dv_WkVar_A ;

        if( dv_WkVar == 0 )
            reslt = 1 ; 
    }

    return( reslt ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
D_VECTOR::Sort
(
    const void * vectPtr, 
    int elmSiz, long cnt 
)
{
        int  ret ;

    ret = Set( vectPtr, elmSiz, cnt ) ;

    if( ret )   return( ret ) ;

    Sort() ;

    return( 0 ) ;
}

#if 1    //100
//*****************************************************************************
// z dv_Vector[]  <l> ׂ̏ ascendant-order 
//
//u@
//    
//*****************************************************************************

int
D_VECTOR::Sort()
{
    int i, ii, ret ;

    for( ii = 1 ; ii < dv_Count ; ii ++ )
    {
        // dv_Vector[ii] vf  dv_Vector[i=0,ii-1] zɒǉ
        //    dv_Vector[i=0,ii] z 𐳂ɂB(납AvfSwapJԂ)
        //   ƂƂ dv_Vector[i=0,ii-1] z ͐ɂƂ

        for( i = ii ; i > 0 ; i -- )
        {
            ret = Compare( (void *) & dv_Vector[ (i-1) * dv_ElmSiz ],
                           (void *) & dv_Vector[  i    * dv_ElmSiz ] ) ;
            if( ret <= 0 )
            {
                break ;// ȏSwap͕KvȂ
            }

            //swap [i-1] item with [i]
            memcpy( dv_WkVar, & dv_Vector[ i * dv_ElmSiz ], dv_ElmSiz ) ;
            memcpy( & dv_Vector[  i    * dv_ElmSiz ], & dv_Vector[ (i-1) * dv_ElmSiz ], dv_ElmSiz ) ;
            memcpy( & dv_Vector[ (i-1) * dv_ElmSiz ], dv_WkVar, dv_ElmSiz ) ;
        }
    }

    return( 0 ) ;
}

#else     //100 complete. but not preferable. this is cpu wasteful

//*****************************************************************************
// z dv_Vector[]  <l> ׂ̏ ascendant-order 
//     Algorithm  too primitive
//*****************************************************************************

//int
//D_VECTOR::Sort()
//{
//    int i, ii, min, ret ;

//    for( ii = 0 ; ii < dv_Count - 1 ; ii ++ )
//    {
        //  ii ȍ~̒ň ̂T
//       min = ii ;
//        for( i = ii + 1 ; i < dv_Count ; i ++ )
//        {
//            ret = Compare( (void *) & dv_Vector[ i   * dv_ElmSiz ],
//                           (void *) & dv_Vector[ min * dv_ElmSiz ] ) ;
//            if( ret < 0 )
//                min = i ;
//        }

//        if( min == ii )  continue;// ii is Minimum item

        //swap ii-item with min-item
 
//        memcpy( dv_WkVar, & dv_Vector[ ii * dv_ElmSiz ], dv_ElmSiz ) ;
//        memcpy( & dv_Vector[ ii  * dv_ElmSiz ], & dv_Vector[ min * dv_ElmSiz ], dv_ElmSiz ) ;
//        memcpy( & dv_Vector[ min * dv_ElmSiz ], dv_WkVar, dv_ElmSiz ) ;
//    }

//    return( 0 ) ;
//}

#endif  //100


#if 0   //200 imcomplete. not preferable

//*****************************************************************************
//Q@, ċAIĂяoɂ Sort --> Sorting.txt Q
//    ̕@́Acnt TCY  Ɨpobt@Kv
//*****************************************************************************

//int
//D_VECTOR::Sort_T( char * vectPtr, long cnt )
//{
//    int  n1, n2 ;

//    n1 = cnt / 2 ;
//    n2 = cnt - n1 ;

//    if( n1 > 1 )
//        Sort_T( (void *) & dv_Vector[ 0 ], n1 ) ;

//    if( n2 > 1 )
//        Sort_T( (void *) & dv_Vector[ n1 * dv_ElmSiz ], n2 ) ;

//    i1 = 0 ;
//    i2 = n1 ;
    
//    for( ; ; )
//    {
//        ret = Compare( (void *) & dv_Vector[ i1 * dv_ElmSiz ],
//                       (void *) & dv_Vector[ i2 * dv_ElmSiz ] ) ;
//        if( ret == 0 )
//}
#endif  //200

#if 0   //300  imcomplete. not preferable
//*****************************************************************************
//Q@ɂ Sort --> Sorting.txt Q
//     ̕@́Acnt TCY  Ɨpobt@Kv
//*****************************************************************************

//int
//D_VECTOR::Sort()
//{
//    long i, j, ii ;

//    long   n_Chunk ;//chunk 
//    long   n_Elm ;//chunk element 
//    char * w ;

//    n_Chunk = dv_Count ;
//    n_Elm   = 1 ;

//    for( ; ; n_Chunk = n_Chunk / 2 + ( n_Chunk % 2), n_Elm *= 2 )
//    {
//        for( ii = 0 ; ii < n_Chunk ; ii += n_Elm )
//        {
//            i = ii * n_Elm ;
//            j = i + n_Elm ;

//            for( ; ; )
//            {
//                ret = Compare( dv_Vector[ i ], dv_Vector[ j ] ) ;

//                if( ret > 0 )
//                {      //dv_Vector[ i ] > dv_Vector[ j ]
//                    w  = dv_Vector[ i ] ;
//                    dv_Vector[ i ] = dv_Vector[ j ] ;
//                    dv_Vector[ j ] = dv_Vector[ w ] ;
//                    j ++ ;
//                    continue ;
//                }
//                else if( ret < 0 )
//                {
//                    i ++ ;
//                }
//                else
//                {
//                    i ++ ;
//                    j ++ ;
//                }
//            }
#endif  //300
