#include  <stdlib.h>
#include  "wx/wx.h"
#include  "wx/dir.h"
#include  "wx/filename.h"
#include  "wx/file.h"
#include  "wx/filefn.h"
#include  "MyThread.h"
#include  "TopFrame.h"

extern wxChar  RC_Log_Folder_Deleting[] ;
extern wxChar  RC_Log_File_Deleting[] ;
extern wxChar  RC_Log_Ok[] ;
extern wxChar  RC_Log_Error[] ;
extern int     Set_File_Removable( wxString & fNam );

//===============================================================================
//
//===============================================================================

DelFiles_THREAD::DelFiles_THREAD
(
    const TopFRAME         * frame,
    const DualTreeCtl_NODE * pNod_Root,
    int                      flag_delete[] 
)       : MyThread_BASE( MyThread_BASE::T_Delete, frame )
{
    m_pNod_Root    = (DualTreeCtl_NODE *)pNod_Root ;
    m_Del_Folder_F = flag_delete[0] ;
    m_Del_ReadOnly = flag_delete[1] ;
}

//===============================================================================
// destination root folder  Ctl-Tree ȉASĂ̊KwŁA@
//          IĂ鍀ڂSč폜
//
//   (1) Ctl-Tree ̑SĂ Kw  IĂ file Sč폜B
//   (2) Ctl-Tree ̑SĂ Kw  IĂ folder Sč폜B
// 
//   SĂ̊Kw files ɍ폜̂́A Iꂽ Folder 폜ꂽ
//    ƁẢKw file 폜悤ƂƁAError ɂȂ邽
//       tree  fille Afile-system Ŋɍ폜ς݂ǂcheck 
//       Ȃłނ悤ɂ邽
//
//===============================================================================
//virtual
wxThread::ExitCode 
DelFiles_THREAD::Entry()
{
//    int  other_Stat ;
    long lRet ;

    lRet = Delete_Child_Files( m_pNod_Root );

            ::wxLogDebug( wxT("DelFiles_THREAD::Entry() lRet =%ld"), lRet );

    lRet |= Delete_Child_Folders( m_pNod_Root );
        
    MyThreadEVENT event( thread_Evt_Delete_Finished );

    event.SetInt( lRet ) ;

    ::wxPostEvent( m_Frame, event );

    return( NULL );
}

//===============================================================================
// Ctl-Tree őIĂtH_
//      폜BċAIɏ
//
//    Ctl-Tree  folder ̂ check  폜
//
//===============================================================================
long
DelFiles_THREAD::Delete_Child_Folders
(
    DualTreeCtl_NODE * pNod_Mother
)
{
        DualTreeBASE_ITEM * pItemBase ;
        DualTreeCtl_ITEM  * pCtlItem ;
        wxString   fNam ;
        long  ii, ret ;
        long  cnt_err ;
        bool  bRet ;

    cnt_err = 0 ;

    for( ii = 0 ; ; ii ++ )
    {
        if( ii >= pNod_Mother->m_Count_Children )  break ;
        if( m_GoOn_Flag == 0 )   goto  Quited ;

        pItemBase = pNod_Mother->Item_Ptr( ii ) ;
        pCtlItem  = (DualTreeCtl_ITEM *) pItemBase->m_pCustomData ;

//for Debug   if( wxString( pItemBase->m_Name_L[0] ) == wxT("GDB") )
//for Debug      ret = ret ;

        if( pItemBase->m_Is_Valid_L[ 1 ] == 0 )  continue ;

        if( ! pItemBase->Is_Node() )    continue ;  //Node(Folder) łȂ

        if( ( pCtlItem->i_State & DualTreeCtl_ITEM::st_SELECTED ) == 0 )
        {                //  child (=: pCtlItem)  IĂȂ
            //--{Kw𒲂ׂ 100
            cnt_err += Delete_Child_Folders( (DualTreeCtl_NODE *) pItemBase ) ;
            //--}  100
            continue ;
        }
                    // ::wxLogDebug( wxT("    %ld: Name= [%s]"), ii, pItemBase->m_Name_L[0] ) ;

        fNam = pCtlItem->Get_Full_Path( 1 ) ;//destination side fullname
                     ::wxLogDebug( wxT("Delete_Child_Folders() :%ld : fNam= [%s]"), ii, fNam ) ;
        if( m_Del_Folder_F )
        {             //Node tree ɗ炸Aۂ file-system folder 폜
            cnt_err += Delete_Folder_Forcedly( fNam ) ;
        }

        LogPut_Format( RC_Log_Folder_Deleting, fNam );

        if( m_Del_ReadOnly )
            ret = Set_File_Removable( fNam ) ;
 
        bRet = ::wxRmdir( fNam ) ;

        if( bRet )
        {
            pItemBase->m_Is_Valid_L[ 1 ] = 0 ;
            LogPut_Msg( RC_Log_Ok ) ;
        }
        else
        {
            cnt_err ++ ;
            LogPut_Msg( RC_Log_Error ) ;
        }
    }

 EXIT :

    return( cnt_err ) ;

 Quited :

    cnt_err = -1 ;
    goto  EXIT ;
}

//===============================================================================
// Ctl-Tree őIĂt@C
//      폜BċAIɏ
//
//    Ctl-Tree  file ̂ check  폜
//===============================================================================
long
DelFiles_THREAD::Delete_Child_Files
(
    DualTreeCtl_NODE * pNod_Mother
)
{
        DualTreeBASE_ITEM * pItemBase ;
        DualTreeCtl_ITEM  * pCtlItem ;
        wxString   fNam ;
        long  ii ;
        long  cnt_err ;
        bool  bRet ;
        int   ret ;

    cnt_err = 0 ;

    for( ii = 0 ; ; ii ++ )
    {
        if( ii >= pNod_Mother->m_Count_Children )  break ;
        if( m_GoOn_Flag == 0 )   goto  Quited ;

        pItemBase = pNod_Mother->Item_Ptr( ii ) ;
        pCtlItem  = (DualTreeCtl_ITEM *) pItemBase->m_pCustomData ;
                    ::wxLogDebug( wxT("    %ld: Name= [%s]"), ii, pItemBase->m_Name_L[0] ) ;

///        if( wxString( pItemBase->m_Name_L[0] ) == wxT("gcc.help") )
///            ret = ret ;
 
        if( pItemBase->m_Is_Valid_L[ 1 ] == 0 )  continue ;

        if( pItemBase->Is_Node() )
        {      // item(=: pItemBase)  Folder Ȃ̂, Kw
            cnt_err += Delete_Child_Files( (DualTreeCtl_NODE *)pCtlItem ) ;

            continue ;
        }

        // --- ȉAitem(=: pItemBase)   File ł

        if( ( pCtlItem->i_State & DualTreeCtl_ITEM::st_SELECTED ) == 0 )
        {      // item(=: file)  IĂȂ
            continue ; 
        }

        fNam = pCtlItem->Get_Full_Path( 1 ) ;//destination side fullname

        LogPut_Format( RC_Log_File_Deleting, fNam );

        if( m_Del_ReadOnly )
            ret = Set_File_Removable( fNam ) ;

        bRet = ::wxRemoveFile( fNam ) ;

        if( bRet )
        {
            pItemBase->m_Is_Valid_L[ 1 ] = 0 ;

            LogPut_Msg( RC_Log_Ok );
        }
        else
        {
            cnt_err ++ ;

            LogPut_Msg( RC_Log_Error );
        }
    }

 EXIT :

    return( cnt_err ) ;

 Quited :

    cnt_err = -1 ;
    goto  EXIT ;
}

//===============================================================================
//w肳ꂽfolder   children Sč폜
//    ߂l : 0 = Sɍ폜B
//             ȊOA폜łĂȂ̂B
//===============================================================================
long
DelFiles_THREAD::Delete_Folder_Forcedly
(
    const wxString & folder_Mother_Path    //children 폜ׂefolder full-fPathName
)                                          //  Ōɂ́A'/' 鎖B
{
        wxDir       folder_Mother ;
        wxFileName  fn_Child ;
        wxString    fname, fPathName ;
        bool        bRet, b_HasChild;
        long        cnt, lRet, lReslt ;
        int         ret ;

    lReslt = 0 ;

    bRet = folder_Mother.Open( folder_Mother_Path ) ; // folder_Mother_Path ̍Ō '/' ȂƑʖ

            ::wxLogDebug( wxT("  Delete_Folder_Forcedly(): bRet=%d, folder_Mother_Path= <%s>\n"), bRet, folder_Mother_Path );
    if( ! bRet)                     goto  ERR_NoDir ;

  //={ /100/ first check child files

    b_HasChild = folder_Mother.GetFirst( & fname, wxEmptyString, wxDIR_FILES | wxDIR_HIDDEN ) ; //get folders

    for( cnt = 0 ; ; b_HasChild = folder_Mother.GetNext( & fname ), cnt ++ )
    {
        if( ! b_HasChild )  break ;

        if( m_GoOn_Flag == 0 )  goto  QUITTED ;

        fn_Child.Assign( folder_Mother_Path + fname );

        fPathName = fn_Child.GetFullPath() ;

        LogPut_Format( RC_Log_File_Deleting, fPathName );

        if( m_Del_ReadOnly )
            ret = Set_File_Removable( fPathName ) ;

        bRet = ::wxRemoveFile( fPathName ) ;

        if( bRet )
        {
            LogPut_Msg( RC_Log_Ok ) ;
        }
        else
        {
            lReslt ++ ;
            LogPut_Msg( RC_Log_Error ) ;
        }
    }
  //=} /100/ first check child files

  //={ /200/ first check child folders

    b_HasChild = folder_Mother.GetFirst( & fname, wxEmptyString, wxDIR_DIRS | wxDIR_HIDDEN ) ; //get folders

    for( cnt = 0 ; ; b_HasChild = folder_Mother.GetNext( & fname ), cnt ++ )
    {
        if( ! b_HasChild )  break ;

        if( m_GoOn_Flag == 0 )  goto  QUITTED ;

        fn_Child.Assign( folder_Mother_Path + fname + wxT("/") );

        fPathName = fn_Child.GetFullPath();

        lRet = Delete_Folder_Forcedly( fPathName ) ;

        lReslt += lRet ;
        if( lRet )  continue ;

        LogPut_Format( RC_Log_Folder_Deleting, fPathName ) ;

        if( m_Del_ReadOnly )
            ret = Set_File_Removable( fPathName ) ;

        bRet = ::wxRmdir( fPathName ) ; //upper Delete_Folder_Forcedly() call has error. 
                    ::wxLogDebug( wxT(" Delete_Folder_Forcedly(): wxRmdir(%s) --> %d"), fPathName, bRet );

        if( bRet )
        {
            LogPut_Msg( RC_Log_Ok ) ;
        }
        else
        {
            lReslt ++ ;  //error

            LogPut_Msg( RC_Log_Error ) ;
        }
    }

  //=} /200/ first check child folders

 EXIT :
            //::wxLogDebug( wxT("     --> Delete_Folder_Forcedly(): exit : lReslt= %d"), lReslt );
    return( lReslt ) ;

 QUITTED :
    lReslt |= 0x80000000 ;
    goto  EXIT ;

 ERR_NoDir :
    lReslt = -1 ;
    goto  EXIT ;
}
