#include  <stdlib.h>
#include  <wx/wx.h>
#include  <wx/dir.h>
#include  <wx/filename.h>
#include  <wx/file.h>
#include  <wx/filefn.h>
#include  <wx/dynarray.h>
#include  "Proc_Space.h"
#include  "MyThread.h"
#include  "TopFrame.h"

extern time_t   g_FileTime_DeadBand ;
extern wxChar   RC_Log_DiffChk_Start[] ;
extern wxChar   RC_Log_DiffChk_End[]   ;

extern int
File_Compare_TStamp
(
    const wxString & path_Src,   //source-file fullpath 
    const wxString & path_Dst,   //destination-file fullpath 
    time_t  sec_Dead_Band 
) ;

//*****************************************************************************
//
//*****************************************************************************

int
TopFRAME::KickOff_Diff_Check()
{
    if( ! Should_Diff_Check() )  return( 1 ) ;

    if( m_DTreeCtrl->m_pRoot_Node->m_Is_Valid_L[ 0 ] != 1 )  return( 1 ) ;
    if( m_DTreeCtrl->m_pRoot_Node->m_Is_Valid_L[ 1 ] != 1 )  return( 1 ) ;

    MyThread_BASE * pThread ;

    pThread = new Diff_Chk_THREAD( this, m_DTreeCtrl->m_pRoot_Node ) ;

    Append_Thread_Queue( pThread ) ;

    return( 0 );
}

//*****************************************************************************
//
//*****************************************************************************

int
TopFRAME::Quit_Diff_Check()
{
        MyThread_BASE * pThread ;

    if( m_Idx_Thread_Work < 0 )     return( 0 ) ;

              //diff_check ׂ
    pThread = m_Thread_L[ m_Idx_Thread_Work ] ;
    if( pThread->m_Type != MyThread_BASE::T_DiffChek ) return( 0 ) ;

    pThread->m_GoOn_Flag = 0 ;

    return( 1 );
}

//*****************************************************************************
//
//*****************************************************************************

Diff_Chk_THREAD::Diff_Chk_THREAD
(
    const TopFRAME * frame, 
    const DualTreeCtl_NODE * pNod_Root
)        : MyThread_BASE( MyThread_BASE::T_DiffChek, frame )
{
    m_pNod_Root = (DualTreeCtl_NODE *) pNod_Root ;
}

//*****************************************************************************
//
//*****************************************************************************
//virtual
wxThread::ExitCode 
Diff_Chk_THREAD::Entry()
{    
    int ret ;
                ::wxLogDebug( wxT("Diff_Chk_THREAD::Entry() Start") );

    LogPut_Msg( RC_Log_DiffChk_Start ) ;

    ret = Diff_Check_Children_OnTree( m_pNod_Root ) ;

    MyThreadEVENT event( thread_Evt_Chk_Diff_Finished );

    ::wxPostEvent( m_Frame, event );
                ::wxLogDebug( wxT("Diff_Chk_THREAD::Entry() end") );

    LogPut_Msg( RC_Log_DiffChk_End ) ;

    return( NULL );
}

//*****************************************************************************
//@@Proc_SPACE::Diff_Check_Children_OnMedia() łSort 
//*****************************************************************************
static 
int 
CompareString( const wxString & first, const wxString & second )
{
    int  ret ;
//    ret = first - second ;
    ret = first.Cmp( second ) ;
       //::wxLogDebug( wxT("CompareString( [%s], [%s] ) --> %d"), first, second, ret );

    return( ret );
}

//*****************************************************************************
//  Proc_SPACE::Diff_Check_Children_OnMedia()  My_DIR::Enumerate() Ŏgp
//*****************************************************************************

DiffChk_TRVRSR::DiffChk_TRVRSR( const Proc_SPACE * pPrc_Space  ) 
{
    m_pPrc_Space = (Proc_SPACE *) pPrc_Space ;
}

//*****************************************************************************
//
//*****************************************************************************

void
 DiffChk_TRVRSR::Set( const wxArrayString * fileNam_L, 
                      const wxArrayString * foldrNam_L )
{
    m_FileNam_L  = (wxArrayString *) fileNam_L ;
    m_FoldrNam_L = (wxArrayString *) foldrNam_L ;
}

//*****************************************************************************
//
//*****************************************************************************

//virtual 
int
DiffChk_TRVRSR::OnFile( const wxString & filename )
{
        //::wxLogDebug( wxT("DiffChk_TRVRSR::OnFile( %s ) flg=%hd\n"), filename, m_pPrc_Space->m_GoOn_Flag ) ;
    if( m_pPrc_Space->m_GoOn_Flag == 0 )
        return( 1 ) ;

    m_FileNam_L->Add( filename );

    return( 0 );
}

//*****************************************************************************
//
//*****************************************************************************

//virtual
int
DiffChk_TRVRSR::OnDir( const wxString & dirname )
{
        //::wxLogDebug( wxT("DiffChk_TRVRSR::OnDir( %s ) flg=%hd\n"), dirname, m_pPrc_Space->m_GoOn_Flag ) ;
    if( m_pPrc_Space->m_GoOn_Flag == 0 )
        return( 1 ) ;

    m_FoldrNam_L->Add( dirname );

    return( 0 );
}

//*****************************************************************************
//  ߂l :: class <DualTreeCtl_NODE> ̃o[ <m_Flag_Diff> ƓӖ
//                          
//    :
//       Ⴂ𒲂ׂƋɁA*** Node-item ͍쐬Ă.***
//                           data-Item ͍Ȃ
//*****************************************************************************

int
Proc_SPACE::Diff_Check_Children_OnMedia
(
    DualTreeCtl_NODE * pNod_Root
)
{
    static int f_getPah = wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR ;
    wxArrayString  nam_Arry ; //source   destination fileAFolder̖O
                              //i[BSort() āÂAĕׂ
                              //  source   destination ɓ݂̂鎖ɂȂ

    DiffChk_TRVRSR travrsr( this ) ;

    wxString  srcFoldr_Path = pNod_Root->Get_Full_Path( 0 ) ; //source  Folder path
    wxString  dstFoldr_Path = pNod_Root->Get_Full_Path( 1 ) ; //destination  Folder path

    DualTreeCtl_NODE * pNode_Child ;

    bool    bRet_1, bRet_2;
    int     ret, result ;
    size_t  cnt_Src, cnt_Dst, ii, jj ;
    wxString    fileName,  srcFullPath, dstFullPath ;
    wxDateTime  time_Src, time_Dst ;
    wxULongLong size_Src, size_Dst ;
    wxFileName  wFN_src, wFN_dst ;
    My_DIR      dirSrc, dirDst ; 

    wxArrayString  src_File_L, src_Foldr_L;
    wxArrayString  dst_File_L, dst_Foldr_L;

    result = 0 ;

    if( pNod_Root->m_Is_Valid_L[ 0 ] != 1 )   goto  Err_01 ;
    if( pNod_Root->m_Is_Valid_L[ 1 ] != 1 )   goto  Err_01 ;

#if 0 //check-090722/-- speed tune up ׂ̈ɁAcheck Ȃ
    //wxDir::Open()  folder ݂̑check ĂȂ̂ŁAA
    bRet_1 = ::wxDirExists( srcFoldr_Path );

    bRet_2 = ::wxDirExists( dstFoldr_Path );
    if( (! bRet_1) || (! bRet_2) )              goto  Err_02 ;
    //wxDirExists() g
#endif //check-090722/

    bRet_1 = dirSrc.Open( srcFoldr_Path );

    bRet_2 = dirDst.Open( dstFoldr_Path );
                //::wxLogDebug( wxT("Diff_Check_Children_OnMedia():Start: bRet=(%d, %d), path= <%s>, <%s>"), 
                //                                          bRet_1, bRet_2, srcFoldr_Path, dstFoldr_Path ) ;
    if( (! bRet_1) || (! bRet_2) )              goto  Err_02 ;

    travrsr.Set( & src_File_L, & src_Foldr_L ) ;
    dirSrc.Enumerate( travrsr, wxT(""), wxDIR_DEFAULT ) ;

    travrsr.Set( & dst_File_L, & dst_Foldr_L ) ;
    dirDst.Enumerate( travrsr, wxT(""), wxDIR_DEFAULT ) ;

    if( m_GoOn_Flag == 0 )                      goto  Exit_Canceled ;

   //
   //-- 100 -- check <<Files>> of source and destination
   //

    src_File_L.Sort( CompareString ) ;
    dst_File_L.Sort( CompareString ) ;

    cnt_Src = src_File_L.GetCount() ;
    cnt_Dst = dst_File_L.GetCount() ;

#if 0  //------------------------------------
                    for( ii=0 ; ii < cnt_Src ; ii++ )
                        ::wxLogDebug( wxT("  SrcFile[%d]=<%s>"), ii, src_File_L[ ii ] ) ;
                    for( ii=0 ; ii < cnt_Dst ; ii++ )
                        ::wxLogDebug( wxT("  DstFile[%d]=<%s>"), ii, dst_File_L[ ii ] ) ;
#endif //------------------------------------
    if( cnt_Src == cnt_Dst )
    {
        for( ii = 0 ; ii < cnt_Src ; ii ++ )
        {
            if( m_GoOn_Flag == 0 )  goto  Exit_Canceled ;
                        //::wxLogDebug( wxT("  FileCompare[%d] :<%s> <%s>"), ii, src_File_L[ ii ], dst_File_L[ ii ] ) ;

            if( src_File_L[ ii ] != dst_File_L[ ii ] )
            {
                result |= 0x01 ;   break ;  //unmatched file name
            }

            //tsizecheck
            ret = File_Compare_TStamp( srcFoldr_Path + src_File_L[ ii ],
                                       dstFoldr_Path + src_File_L[ ii ],
                                                   g_FileTime_DeadBand ) ;
                         //::wxLogDebug( wxT("  FileCompare[%d] : TStamp()-->%d"), ii, ret ) ;
            if( ret < 0 )
            {
                result |= 0x04 ;
            }
            else if( ret > 0x01 )
            {
                result |= 0x08 ;   break ;
            }
        }
    }
    else
    {
        result |= 0x01 ;  //file name unmatched
    }

   //-- 100 -- end  file-comparison

   //
   //-- 200 -- check <<Folders>> of source and destination
   //

    src_Foldr_L.Sort( CompareString ) ;
    dst_Foldr_L.Sort( CompareString ) ;

    cnt_Src = src_Foldr_L.GetCount() ;
    cnt_Dst = dst_Foldr_L.GetCount() ;

    if( cnt_Src != cnt_Dst )
        result |= 0x01 ;  //folder name unmatched

#if 0  //------------------------------------
                ::wxLogDebug( wxT("  Diff_Check_Children_OnMedia(): <<Folder>> : cnt=(%d, %d)\n"), cnt_Src, cnt_Dst ) ;
                    for( ii=0 ; ii < cnt_Src ; ii++ )
                        ::wxLogDebug( wxT("  SrcFolder[%d]=<%s>"), ii, src_Foldr_L[ ii ] ) ;
                    for( ii=0 ; ii < cnt_Dst ; ii++ )
                        ::wxLogDebug( wxT("  DstFolder[%d]=<%s>"), ii, dst_Foldr_L[ ii ] ) ;
#endif //------------------------------------

    jj = 0 ;

    for( ii = 0 ; ii < cnt_Src ; )
    {
        if( jj >= cnt_Dst )  break ;
                        //::wxLogDebug( wxT("  FolderCompare : ii=%d, jj=%d, src=<%s> dst=<%s>"), ii,jj, src_Foldr_L[ ii ], dst_Foldr_L[ jj ] ) ;

        if( m_GoOn_Flag == 0 )  goto  Exit_Canceled ;

        if( src_Foldr_L[ ii ] == dst_Foldr_L[ jj ] )
        {    //OvĂ̂ŁAside  Node ǉBAɗ܂͕Е̂ݑ݂邱Ƃ(OK)
            ret = pNod_Root->Add_Child_Item_Both( 1, src_Foldr_L[ ii ], 
                                                    (DualTreeBASE_ITEM **)& pNode_Child ) ;
            if( ret < 0 )
            {
                result |= 0x04  ;       continue ;
            }

            ret = Diff_Check_Children_OnMedia( pNode_Child );

            result |= ret ;

            ii ++ ; jj ++ ;
        }
        else if( src_Foldr_L[ ii ] < dst_Foldr_L[ jj ] )
        {
            ret = pNod_Root->Add_Child_Item( 1, 0, src_Foldr_L[ ii ], 
                                               (DualTreeBASE_ITEM **)& pNode_Child ) ;
            if( ret < 0 )
            {
                result |= 0x04 ;
            }
            ii ++ ;
        }
        else   //if( src_Foldr_L[ ii ] > dst_Foldr_L[ jj ] )
        {
            ret = pNod_Root->Add_Child_Item( 1, 1, dst_Foldr_L[ jj ], 
                                               (DualTreeBASE_ITEM **)& pNode_Child ) ;
            if( ret < 0 )
            {
                result |= 0x04 ;
            }
            jj ++ ;
        }
    }
                        //::wxLogDebug( wxT("  FolderCompare : ii=%d, jj=%d"), ii,jj ) ;

    //source-side  Ԃꂽ̏
    for( ; ii < cnt_Src ; ii ++ )
    {
        ret = pNod_Root->Add_Child_Item( 1, 0, src_Foldr_L[ ii ], 
                                               (DualTreeBASE_ITEM **)& pNode_Child ) ;
        if( ret < 0 )
        {
            result |= 0x04 ;
        }
    }

    //destination-side  Ԃꂽ̏
    for( ; jj < cnt_Dst ; jj ++ )
    {
        ret = pNod_Root->Add_Child_Item( 1, 1, dst_Foldr_L[ jj ], 
                                               (DualTreeBASE_ITEM **)& pNode_Child ) ;
        if( ret < 0 )
        {
            result |= 0x04 ;
        }
    }

   //-- 200 -- end. folder comparison

 EXIT_10 :

    pNod_Root->m_Flag_Diff = result ;

    pNod_Root->m_State_Load_L[ 0 ] = -1 ;
    pNod_Root->m_State_Load_L[ 1 ] = -1 ;

 EXIT :
                //::wxLogDebug( wxT("Diff_Check_Children_OnMedia():End : result=%ld : src= <%s>"), result, srcFoldr_Path ) ;
    return( result );

 Exit_Canceled :

    result |= 0x02 ;
    goto EXIT_10 ;

 Err_01 :

    result = 0x01 ;
    goto EXIT ;

 Err_02 :

    result = 0x04 ;
    goto EXIT ;
}

//*****************************************************************************
//  ߂l :: == 0  : S check 
//            == 1  : cancel ꂽ 
//            == -1 : check łȂ child 
//              
//*****************************************************************************

int
Proc_SPACE::Diff_Check_Children_OnTree( DualTreeCtl_NODE * pNod_Root )
{
   static int f_getPah = wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR ;

        DualTreeBASE_ITEM * pItemBase ;
        DualTreeCtl_ITEM    * pCtlItem ;
        DualTreeCtl_NODE    * pNod ;
//        wxString * dstNam ;
        wxString   srcPath, dstPath ;
//        bool  bRet ;
        long  ii, flg_Diff ;
        long  diff_cntr, lRet ;
        int   ret, result ;
                ::wxLogDebug( wxT("Diff_Check_Children_OnTree():Start: pNod_Root= $%p[%s], Flag_Diff=%ld"), 
                               pNod_Root, pNod_Root->m_Name_L[0], pNod_Root->m_Flag_Diff ) ;
    result = 0 ;

    ii = 0 ;

    diff_cntr = 0 ; //children ňႢ̂̂̐

    if( pNod_Root->m_Flag_Diff >= 0 )   goto  EXIT ;

    for( ii = 0 ; ; ii ++, diff_cntr += flg_Diff )
    {
        if( ii >= pNod_Root->m_Count_Children )  break ;
        if( m_GoOn_Flag == 0 )   goto  EXIT ;

        pItemBase = pNod_Root->Item_Ptr( ii ) ;
        pCtlItem  = (DualTreeCtl_ITEM *) pItemBase->m_pCustomData ;

                    // ::wxLogDebug( wxT("    %ld: Name= [%s]"), ii, pItemBase->m_Name_L[0] ) ;
        flg_Diff = 0 ;

        if( ! pCtlItem->Backup_Option() )
        {
            continue ; //backup-target łȂ̂ check ̑ΏۂłȂ
        }

        flg_Diff  = 1 ;

        if( pItemBase->m_Is_Valid_L[ 0 ] != 1 )  continue ;//item  source ͖

        if( pItemBase->m_Is_Valid_L[ 1 ] != 1 )  continue ; //item  destination ͖

                     //::wxLogDebug( wxT("      -->Diff_Check") ) ;

        if( ! pItemBase->Is_Node() )
        {           //file check
            ret = pCtlItem->Compare_TStamp( g_FileTime_DeadBand ) ;
            if( ret < 0  ||  01 < ret  )  continue ; //Ⴂ
        }
        else
        {           //folder 
            pNod = (DualTreeCtl_NODE *) pItemBase ;

            if( pNod->m_State_Load_L[ 0 ] == 1 )
            {           // source-side ͊S LoadĂ
                if( pNod->State_Load_Coh(1) != 1 )
                {
                    //̃P[X́Asource-side Load ĂāA<<>>ɑ݂ destination-side 
                    //     Folder Load ĂȂԂłB̏Ԃ Logical-Errorł
                    //
                    LogPut_Msg( wxT("Backup_THREAD::Diff_Check_Children_OnTree()  *** Fatal-Error *** 100") );
                    result = -1 ;
                    goto  Exit_Error ;
                }

                lRet = Diff_Check_Children_OnTree( pNod ) ;
            }
            else
            {      //Load ܂͔񊮑S Load
                lRet = Diff_Check_Children_OnMedia( pNod ) ;
            }

            if( ((DualTreeCtl_NODE *)pNod->m_pMother_L[0])->Is_Expanded() || 
                ((DualTreeCtl_NODE *)pNod->m_pMother_L[1])->Is_Expanded()    )
            {
                m_Frame->m_DTreeCtrl->Refresh() ;
                    //::wxPostEvent( m_Frame, wxCommandEvent( thread_Evt_Refresh_Tree ) );
                    ::wxLogDebug( wxT("m_Frame->m_DTreeCtrl->Refresh()") );
            }

            pNod->m_Flag_Diff = lRet ;

            if( lRet )  continue ; 
        }

        flg_Diff = 0 ;
    }

    pNod_Root->m_Flag_Diff = diff_cntr ;

 EXIT :
                ::wxLogDebug( wxT("Diff_Check_Children_OnTree():End  : pNod_Root= $%p: ii=%d"), pNod_Root, ii ) ;

    return( diff_cntr ) ;

 Exit_Canceled :

    result = 1 ;
    goto EXIT ;

 Exit_Error :

    result = -1 ;
    goto EXIT ;
}
