#include  <stdlib.h>
#include  <time.h>
#include  "wx/wx.h"
#include  "wx/dir.h"
#include  "wx/fileName.h"
#include  "wx/file.h"
#include  "wx/filefn.h"
#include  "wx/utils.h"
///#include  "DualTree_Ctl.h"
#include  "TopFrame.h"
#include  "MyThread.h"

extern time_t g_FileTime_DeadBand ;

extern int File_Compare_TStamp( const wxString & path_Src, 
                                const wxString & path_Dst,
                                time_t  sec_Dead_Band    ) ;
extern int Folder_Set_Times( const wxString & fullPath, 
                             const wxDateTime & dtAccess, 
                             const wxDateTime & dtMod    ) ;
extern wxChar RC_Log_Ok[] ;
extern wxChar RC_Log_Error[] ;
extern wxChar RC_Log_Quitted[] ;
extern wxChar RC_Log_Folder_Creating[] ;

//*****************************************************************************
//
//*****************************************************************************

int 
TopFRAME::Do_Backup()
{
    extern wxChar   RC_Log_Start_Backup[]  ;
    extern wxChar   RC_ErrM_Same_Root_Err[] ; 
    extern wxChar   RC_ErrM_Root_NotSet_Err[] ; 

    int  result ;
    MyThread_BASE * pThread ;

    DualTreeCtl_NODE * pNod = m_DTreeCtrl->m_pRoot_Node ;

    result = 0 ;
                     ::wxLogDebug( wxT("OnDo_Backup") );
    if( pNod->m_Is_Valid_L[0] != 1 )   result += 1 ;
    if( pNod->m_Is_Valid_L[1] != 1 )   result += 2 ;

    if( result )
    {
        LogPut_Msg( RC_ErrM_Root_NotSet_Err ) ;
        return( result ) ;
    }

    if( pNod->m_Name_L[0] == pNod->m_Name_L[1] )
    {
        LogPut_Msg( RC_ErrM_Same_Root_Err ) ;
        return( -1 );
    }

    Quit_Thread() ;

    LogPut_Msg( RC_Log_Start_Backup ) ;

    pThread = new Backup_THREAD( this ) ;

    Append_Thread_Queue( pThread ) ;

    return( result );
}

//*****************************************************************************
//
//*****************************************************************************

Backup_THREAD::Backup_THREAD
(
    const TopFRAME * frame
)    : MyThread_BASE( MyThread_BASE::T_Backup, frame )
{
}

//*****************************************************************************
//
//*****************************************************************************
//virtual
wxThread::ExitCode 
Backup_THREAD::Entry()
{
    static int flg = wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR ;
    int ret ;

    DualTreeCtl_NODE * pNod ;

    m_MaxSiz_IO_Buff = 4096 * 4 ;
    m_IO_Buff = new char[ m_MaxSiz_IO_Buff ] ;

    if( m_IO_Buff == 0 )   return( (wxThread::ExitCode) 1 );

    pNod = m_Frame->m_DTreeCtrl->m_pRoot_Node ;

    ret = Copy_Children_in_DTree( pNod, 
                                  wxFileName( pNod->m_Name_L[0] + wxT("/") ).GetPath( flg ),
                                  wxFileName( pNod->m_Name_L[1] + wxT("/") ).GetPath( flg ) );
    delete[] m_IO_Buff ;

    MyThreadEVENT event( thread_Evt_Backup_Finished );

    ::wxPostEvent( m_Frame, event );

    return( NULL );
}

//*****************************************************************************
// Source   Tree  Load Ă鎞  Backup
//    Destination  Tree ɂȂƂB
//*****************************************************************************

int
Backup_THREAD::Copy_Children_in_DTree
( 
    const DualTreeCtl_NODE * pNod_Mother,
    const wxString & srcFoldr_Path,   //source  Folder path
    const wxString & dstFoldr_Path    //destination  Folder path. (݂͑邱)
                                      //  Apath ̍Ō '/' L鎖
)
{
    static int flg_getPah = wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR ;

        DualTreeBASE_ITEM * pItemBase ;
        DualTreeCtl_ITEM  * pCtlItem ;
        DualTreeCtl_NODE  * pNod ;
        wxDateTime          dtAccess, dtMod, dtCre ;
        wxString          * dstNam ;
        wxString            srcPath, dstPath ;
        bool  bRet ;
        int  ii, ret, reslt ;
                ::wxLogDebug( wxT("Copy_Children_in_DTree(): [%s] -> [%s]"),
                                    srcFoldr_Path, dstFoldr_Path );
    reslt = 0 ;

    for( ii = 0 ; ii < pNod_Mother->m_Count_Children ; ii ++ )
    {
        if( m_GoOn_Flag == 0 )   break ;

        pItemBase = pNod_Mother->Item_Ptr( ii ) ;
        pCtlItem  = (DualTreeCtl_ITEM *) pItemBase->m_pCustomData ;

                ::wxLogDebug( wxT("    Copy_Children_in_DTree(): valid=[%d,%d], name=[%s]"),
                                    (int)pItemBase->m_Is_Valid_L[ 0 ], (int)pItemBase->m_Is_Valid_L[ 1 ], pItemBase->m_Name_L[ 0 ] );

        if( pItemBase->m_Is_Valid_L[ 0 ] != 1 )
            continue ;        //item  source ͖

        if( ! pCtlItem->Backup_Option() )
            continue ;        //item  backup Ώۂł͂Ȃ

        if( pItemBase->m_Is_Valid_L[ 1 ] == -1 )
            continue ;        //item  destination ̓ANZXs

        if( ! pItemBase->Is_Node() )
        {    //file copy
          //make source fullPath Name

            ret = pCtlItem->Compare_TStamp( g_FileTime_DeadBand ) ;

            if( ret == 0   )    continue ;//Asize Ŝ copy Ȃ
            if( ret == 1   )    continue ;//size A镝œ̂ copy Ȃ
            if( ret == 10  )    continue ;//Source Â̂ copy Ȃ
            if( ret == 100 )    continue ;//source  File ݂Ȃ̂ copy Ȃ
            //destination-side  file ݂Ȃꍇ Copy 
 
///            wxFileName srcFn( srcFoldr_Path + wxT('/') + pItemBase->m_Name_L[0] ) ;
            wxFileName srcFn( srcFoldr_Path + pItemBase->m_Name_L[0] ) ;

          //make destination fullPath Name
            dstNam = & pItemBase->m_Name_L[ 1 ] ;
            if( dstNam->IsEmpty() )
                dstNam = & pItemBase->m_Name_L[ 0 ] ;
///            wxFileName dstFn( dstFoldr_Path + wxT('/') + *dstNam );
            wxFileName dstFn( dstFoldr_Path + *dstNam );

            srcPath = srcFn.GetFullPath() ;
            dstPath = dstFn.GetFullPath() ;

            LogPut_FileCopyBegin( srcPath, dstPath ) ;

//            bRet = ::wxCopyFile( srcPath, dstPath, true ) ;
//            if( ! bRet )  
            ret = Copy_Fle( srcPath, dstFn.GetFullPath() ) ;
            if( ret )
            {
                LogPut_Msg( RC_Log_Error ) ;
                if( ret > 0 )  break ;
                continue ;
            }

            LogPut_Msg( RC_Log_Ok ) ; // ȉ ʂ̕\
        }
        else
        {     //folder 
          //make source fullPath folder Name
///            wxFileName srcFn( srcFoldr_Path + wxT('/') +
///                               pItemBase->m_Name_L[0] + wxT('/') ) ;
            wxFileName srcFn( srcFoldr_Path + pItemBase->m_Name_L[0] + wxT('/') ) ;

          //make destination fullPath Name
            dstNam = & pItemBase->m_Name_L[ 1 ] ;
            if( dstNam->IsEmpty() )
                dstNam = & pItemBase->m_Name_L[ 0 ] ;
///            wxFileName dstFn( dstFoldr_Path + wxT('/') + *dstNam + wxT('/') ) ;
            wxFileName dstFn( dstFoldr_Path + *dstNam + wxT('/') ) ;

            if( ! dstFn.DirExists() )
            {
                LogPut_Format( RC_Log_Folder_Creating, dstFn.GetPath() );

                bRet = wxFileName::Mkdir( dstFn.GetPath(), 0777, wxPATH_MKDIR_FULL ) ;
                if( ! bRet )
                {
                    LogPut_Msg( RC_Log_Error );
                    continue ;
                }

                srcFn.GetTimes( & dtAccess, & dtMod, & dtCre ) ;
//                dstFn.SetTimes( & dtAccess, & dtMod, & dtCre ) ;//wxWidget not implemented
                Folder_Set_Times( srcFn.GetFullPath(), dtAccess, dtMod ) ;
                // ȉ ʂ̕\  

                LogPut_Msg( RC_Log_Ok );
            }

            pNod = (DualTreeCtl_NODE *) pItemBase;

            if( pNod->m_State_Load_L[0] == 1 )
            {          //Source side  Node  Load ĂꍇA
                if( pNod->State_Load_Coh(1) != 1 )
                {
                    //̃P[X́Asource-side Load ĂāA<<>>ɑ݂destination-side 
                    //     Folder Load ĂȂԂłB̏Ԃ Logical-Errorł
                    //
                    LogPut_Msg( wxT("Backup_THREAD::Copy_Children_in_DTree() *** Fatal-Error *** 100") );
                    reslt = -1 ;
                    break ;
                }

                ret = Copy_Children_in_DTree( (DualTreeCtl_NODE *) pItemBase, 
                                                srcFn.GetPath( flg_getPah ), 
                                                dstFn.GetPath( flg_getPah ) );
            }
            else
            {       //pNod  Source side  Load ĂȂB
                ret = Copy_Children_On_Media( srcFn.GetPath( flg_getPah ),
                                              dstFn.GetPath( flg_getPah ) );
            }

            reslt |= ret ;
        }
    }

    return( reslt ) ;
}

//#############################################################################
//  Used in Copy_Children_On_Media() 
//#############################################################################

class Copy_TRVRSR : public My_DirEnumerator
{
  public :

    Backup_THREAD    * m_pThred        ;
    wxString           m_SrcFoldr_Path ;
    wxString           m_DstFoldr_Path ;
    int                m_Result ;

    int                m_Flg_getPah    ;

  public :

    Copy_TRVRSR( const Backup_THREAD * pThred,
                     const wxString & srcFoldr_Path,
                     const wxString & dstFoldr_Path
               );

    virtual int OnFile( const wxString & fileName ) ;

    virtual int OnDir( const wxString & dirName ) ;
};


//*****************************************************************************
//  Called in Copy_Children_On_Media() 
//*****************************************************************************

Copy_TRVRSR::Copy_TRVRSR
( 
    const Backup_THREAD * pThred,
    const wxString & srcFoldr_Path,
    const wxString & dstFoldr_Path
)
{
    m_pThred = (Backup_THREAD *) pThred ;
    m_SrcFoldr_Path = srcFoldr_Path ;
    m_DstFoldr_Path = dstFoldr_Path ;
    m_Result        = 0 ;

    m_Flg_getPah    = wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR ;
}

//*****************************************************************************
//  Called in Copy_Children_On_Media() 
//*****************************************************************************
//virtual 
int 
Copy_TRVRSR::OnFile( const wxString & fullPath_File )
{
    wxString  fullPath_Src, fullPath_Dst ;
    wxString  fileName = wxFileName( fullPath_File ).GetFullName() ;
    int  ret ;
            ::wxLogDebug( wxT("Copy_TRVRSR::OnFile(%s) go_on= %hd"), fullPath_File, m_pThred->m_GoOn_Flag ) ;

    if( m_pThred->m_GoOn_Flag == 0 )
        return( 1 ) ;

    fullPath_Src = m_SrcFoldr_Path + fileName ;
    fullPath_Dst = m_DstFoldr_Path + fileName ;

    ret = File_Compare_TStamp( fullPath_Src, fullPath_Dst, g_FileTime_DeadBand ) ;
                //::wxLogDebug( wxT("File_Compare_TStamp() ->%d\n   src=<%s>\n   dst=<%s>\n"),
                //                                            ret,  fullPath_Src, fullPath_Dst ) ;
    if( ret == 0   )    return( 0 ) ;//Asize Ŝ copy Ȃ
    if( ret == 1   )    return( 0 ) ;//size A镝œ̂ copy Ȃ
    if( ret == 10  )    return( 0 ) ;//Source Â̂ copy Ȃ
    if( ret == 100 )    return( 0 ) ;//source  File ݂Ȃ̂ copy Ȃ

    m_pThred->LogPut_FileCopyBegin( fullPath_Src, fullPath_Dst ) ;

    ret = m_pThred->Copy_Fle( fullPath_Src, fullPath_Dst ) ;
    if( ret == 2 )
    {
        m_pThred->LogPut_Msg( RC_Log_Quitted ) ;  return( 1 ) ;
    }

    if( ret )
    {
        m_pThred->LogPut_Msg( RC_Log_Error ) ;

        return( 0 ) ;
    }

    m_pThred->LogPut_Msg( RC_Log_Ok ) ; // ȉ ʂ̕\

    return( 0 ) ;
}

//*****************************************************************************
//  Called in Copy_Children_On_Media() 
//*****************************************************************************
//virtual 
int 
Copy_TRVRSR::OnDir( const wxString & fullPath_Dir )
{
    wxFileName   wFN_src, wFN_dst ;
    wxString     fullPath_Src ;
    wxDateTime  dtAccess, dtMod, dtCre ;
    wxString    dirName = wxFileName( fullPath_Dir ).GetFullName() ;
    bool        bRet ;
    int         ret ;
            ::wxLogDebug( wxT("Copy_TRVRSR::OnDir(%s) ;go_on= %hd"), fullPath_Dir, m_pThred->m_GoOn_Flag ) ;

    if( m_pThred->m_GoOn_Flag == 0 )
        return( 1 ) ;

    fullPath_Src = m_SrcFoldr_Path + dirName ;

    wFN_src.Assign( fullPath_Src + wxT("/") );
    wFN_dst.Assign( m_DstFoldr_Path + dirName + wxT("/") );

    if( ! wFN_dst.DirExists() )
    {
        m_pThred->LogPut_Format( RC_Log_Folder_Creating, wFN_dst.GetPath() );

        bRet = ::wxMkdir( wFN_dst.GetPath(), 0777 );
        if( bRet )
        {
            m_pThred->LogPut_Msg( RC_Log_Ok );
        }
        else
        {
            m_pThred->LogPut_Msg( RC_Log_Error );
            return( 0 );
        }

        wFN_src.GetTimes( & dtAccess, & dtMod, & dtCre ) ;
///         dstFn.SetTimes( & dtAccess, & dtMod, & dtCre ) ;//wxWidget not implemented
        Folder_Set_Times( wFN_dst.GetFullPath(), dtAccess, dtMod ) ;

    }

    ret = m_pThred->Copy_Children_On_Media( wFN_src.GetPath( m_Flg_getPah ), 
                                            wFN_dst.GetPath( m_Flg_getPah ) );
    return( 0 );
}

//*****************************************************************************
//
//*****************************************************************************

int
Backup_THREAD::Copy_Children_On_Media
( 
    const wxString & srcFoldr_Path,  //source  Folder path
    const wxString & dstFoldr_Path   //destination  Folder path
                                     //  Apath ̍Ō '/' L鎖
)
{
                ::wxLogDebug( wxT("Copy_Children_On_Media(): [%s] -> [%s]"),
                                              srcFoldr_Path, dstFoldr_Path );
//if 0   /check-090722/speed tune upׂ̈ɁAcheck Ȃ
//-    if( ! ::wxDirExists( srcFoldr_Path ) )  return( -1 ) ;//check Kv
//endif  /check-090722

    My_DIR       dir_Src( srcFoldr_Path );
    Copy_TRVRSR  trvrs( this, srcFoldr_Path, dstFoldr_Path ) ;

    if( ! dir_Src.IsOpened() )              return( -1 ) ;

    dir_Src.Enumerate( trvrs ) ;

    return( trvrs.m_Result );
}


#if 0 //TopFRAME::Show_

//*****************************************************************************
//
//*****************************************************************************

//-void
//-TopFRAME::LogPut_FileCopying
//-( 
//-    const wxString & src_FullPath, 
//-    const wxString & dst_FullPath 
//-)
//-{
//-    extern wxChar * RCL_Side_Symbol[] ;
//-    int  ret1, ret2 ;

//-    wxString  src_RelPath ;
//-    wxString  dst_RelPath ; 

//-    ret1 = m_DTreeCtrl->Relative_Path( src_FullPath, 0, & src_RelPath ) ;
//-    ret2 = m_DTreeCtrl->Relative_Path( dst_FullPath, 1, & dst_RelPath ) ;

//-    m_textCtrl->AppendText( RCL_Side_Symbol[0] + src_RelPath + wxT(" ---> ") +
//-                            RCL_Side_Symbol[1] + dst_RelPath + wxT("\n")    ) ;
//-}
#endif //TopFRAME::Show_

#if 0  //090708/ Copy_Children_On_Media
//*****************************************************************************
//
//*****************************************************************************

//-int
//-Backup_THREAD::Copy_Children_On_Media
//-( 
//-    const wxString & srcFoldr_Path,  //source  Folder path
//-    const wxString & dstFoldr_Path   //destination  Folder path
//-                                     //  Apath ̍Ō '/' L鎖
//-)
//-{
//-   static int flg_getPah = wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR ;

//-    bool    b_HasChild, b_IsDir, bRet;
//-    int cnt, ret ;
//-    wxString   fileName,  fullPath_Src, fullPath_Dst ;
//-    wxDateTime  dtAccess, dtMod, dtCre ;

//-                ::wxLogDebug( wxT("Copy_Children_On_Media(): [%s] -> [%s]"),
                                              srcFoldr_Path, dstFoldr_Path );
//-    wxFileName wFN_src, wFN_dst ;
//-    wxDir      dir_Src( srcFoldr_Path );

//-    b_HasChild = dir_Src.GetFirst( & fileName, wxT("*") ) ; //get the file-name of the first child

//-    for( cnt = 0 ; ; cnt ++, b_HasChild = dir_Src.GetNext( & fileName ) )
//-    {
//-        if( m_GoOn_Flag == 0 )   break ;

//-        if( ! b_HasChild )  break ;

//-        fullPath_Src = srcFoldr_Path + fileName ;

//-        wFN_src.Assign( fullPath_Src + wxT("/") );
        //wFnam Adirectory ǂׂ̂ -->DirExists()
//        b_IsDir = wFnam.IsDir();//́APath name ̌`𒲂ׂ邾>Ō '/' 邩ǂ
//-        b_IsDir = wFN_src.DirExists();//炪.  Ō "/" ĂKv

            //::wxLogDebug( wxT("     --> Load_Children(): cnt= %d, b_IsDir=%d, fname= %s, path= %s"), cnt, b_IsDir, fname.c_str(), wFnam.GetFullPath().c_str() );

//-        if( b_IsDir )
//-        {
//-            wFN_dst.Assign( dstFoldr_Path + fileName + wxT("/") );

//-            if( ! wFN_dst.DirExists() )
//-            {
//-                LogPut_Format( RC_Log_Folder_Creating, wFN_dst.GetPath() ) ;

//-                bRet = ::wxMkdir( wFN_dst.GetPath(), 0777 );

//-                if( ! bRet )
//-                {
//-                    LogPut_Msg( RC_log_Error ) ;  continue ;
//-                }

//-                wFN_src.GetTimes( & dtAccess, & dtMod, & dtCre ) ;
///                dstFn.SetTimes( & dtAccess, & dtMod, & dtCre ) ;//wxWidget not implemented
//-                Folder_Set_Times( wFN_dst.GetFullPath(), dtAccess, dtMod ) ;

//-                LogPut_Msg( RC_log_Ok );
//-            }

//-            ret = Copy_Children_On_Media( wFN_src.GetPath( flg_getPah ), 
//-                                          wFN_dst.GetPath( flg_getPah ) );
//-        }
//-        else
//-        {
//-            fullPath_Dst = dstFoldr_Path + fileName ;

//-            ret = File_Compare_TStamp( fullPath_Src, fullPath_Dst, g_FileTime_DeadBand ) ;
                //::wxLogDebug( wxT("File_Compare_TStamp() ->%d\n   src=<%s>\n   dst=<%s>\n"),
                //                                            ret,  fullPath_Src, fullPath_Dst ) ;
//-            if( ret >= 0  &&  (ret % 10) == 0 )  continue ;

//-            LogPut_FileCopyBegin( fullPath_Src ) ;

//            bRet = ::wxCopyFile( fullPath_Src, dstPath, true ) ;
//            if( ! bRet )  
//-            ret = Copy_Fle( fullPath_Src, fullPath_Dst ) ;
//-            if( ret == 2 )
//-            {
//-                LogPut_FileCopyQuit() ;  break ;
//-            }

//-            if( ret )
//-            {
//-                LogPut_Msg( RC_Log_Error ) ;
//-                if( ret > 0 )  break ;
//-                continue ;
//-            }

//-            LogPut_FileCopyEnd( fullPath_Dst ) ; // ȉ ʂ̕\
//-        }
//-    }

//-    return( 0 );
//-}
#endif  //090708/ Copy_Children_On_Media
