//dualtreectl.h
/////////////////////////////////////////////////////////////////////////////
// Name:        wx/msw/treectrl.h
// Purpose:     DualTreeBASE_BODY class
// Author:      Julian Smart
// Modified by: Vadim Zeitlin to be less MSW-specific on 10/10/98
// Created:     01/02/97
// RCS-ID:      $Id: treectrl.h 49563 2007-10-31 20:46:21Z VZ $
// Copyright:   (c) Julian Smart
// Licence:     wxWindows licence
/////////////////////////////////////////////////////////////////////////////

#ifndef MY_DUALTREE_BODY_H_
#define MY_DUALTREE_BODY_H_

typedef unsigned short ushort ;
typedef unsigned long  ulong ;

#include <wx/string.h>

class DualTreeBASE_ITEM ;
class DualTreeBASE_BODY     ;
class DualTreeBASE_ItemNODE ;
class DualTreeBASE_ItemDATA ;

typedef char INT_8 ;

typedef DualTreeBASE_ITEM * myDualTree_ItemBasePTR ;

//#############################################################################
//
//#############################################################################

class DualTreeBASE_ITEM
{
  public:

    static const INT_8 ITEM_KIND_NODE ; //= 1;
    static const INT_8 ITEM_KIND_DATA ; //= 2;

  public:

    INT_8                 m_Item_Kind    ; //== ITEM_KIND_NODE( = 1 ) or
                                           //== ITEM_KIND_DATA( = 2 )
    INT_8                 m_Is_Valid_L[2] ;
                                  //== 0  ̎ATreeɑ݂Ȃ()ĂAȏ
                                  //== 1  ̎ATreeɑ݂āAaccess \
                                  //== -1 ̎ATreeɑ݂邪Aaccess s
                                  //[0] for A side
                                  //[1] for B side
    DualTreeBASE_BODY     * m_pMyBody       ;//must be set. 
    DualTreeBASE_ItemNODE * m_pMother_L[ 2 ];//eNode ւpointer
                                             //[ 0 ] = A-side ̐e , [ 1 ] = B-side ̐e
                                             //this Spec ? : A  B  ႤeƂ肤邩
                                             //    ɂƂÃOt̕\ł͕\Ȃ

    long        m_Sibl_Order ;//ibling order no.( 1,2,3,...)

    wxString    m_Name_L[2]  ;//m_Name_L[ 0 ] == A  O
                              //m_Name_L[ 1 ] == B  O
                              //A, B ͕ʂ͓OB(ɂ͈قȂ,ʂ̖O𓯈Ƃ݂Ȃꂽ)
    void     *  m_pCustomData ;

  public:

    DualTreeBASE_ITEM( int kind, const DualTreeBASE_BODY * pBody ) ;
    ~DualTreeBASE_ITEM() ;

    void   Init_Base( DualTreeBASE_ItemNODE * pMother, 
                      int which, long sibl_Order, const wxString & name ) ;
    int    Is_Node() const ;
    int    Depth() const ;
};

//#############################################################################
//
//#############################################################################

class DualTreeBASE_ItemNODE : public DualTreeBASE_ITEM
{
  public :

    static const long EXTENT_Capacity_CPArry ;

    long    m_Capacity_CPArry ; //Capacity of m_ChildPtr_Arry[]

    long    m_Count_Children  ; //count of children
                                //
    INT_8   m_State_Load_L[ 2 ] ; //[0]: source side, [1]: destination side
                 // = 0  : Loading Not Completed
                 // = 1  : S load ς. <SLoad>
                 // = -1 : Node ̂ݑSload ς

    DualTreeBASE_ITEM ** m_ChildPtr_Arry ; //child item pointer array
                   //A ABAchild ꏏcontain 
  public:

    DualTreeBASE_ItemNODE( const DualTreeBASE_BODY * pBody ) ;
    ~DualTreeBASE_ItemNODE() ;

    DualTreeBASE_ITEM * Item_Ptr( long index )  const ;// index = 0,1,2,3

    int        State_Load_Coh( int which ) const ;

    long       Cnt_Children() const ;

    long       Get_Index( DualTreeBASE_ITEM * pChildItem ) const ;

    DualTreeBASE_ITEM * 
               Search_Item_ByName( int is_Node, int which, 
                                   const wxString & name ) const ;
    DualTreeBASE_ITEM * 
               Search_Item_ByName_Both( int is_Node, 
                                        const wxString & name ) const ;

    int        Add_Child_Item( int is_Node, int which, const wxString & name,
                                 DualTreeBASE_ITEM ** ppData = 0, long idx = -1 );
    int        Add_Child_Item_Both( int is_Node, const wxString & name,
                                    DualTreeBASE_ITEM ** ppData = 0, long idx = -1 );
    void       MoveTo_All( DualTreeBASE_ItemNODE * pNod_Dst ) const ;

    long       Clear_OneSide( int which ) ;
    long       Clear_OneSide_R( int which ) ;
    int        Clear_Children() ;
    int        Set_Sibling_Order( int is_Recursive ) ;
    long       Shrink() ;

  protected :

    int        Insert_New_Child( DualTreeBASE_ITEM * pItem, long idx = -1 );
};

//#############################################################################
//
//#############################################################################

class DualTreeBASE_ItemDATA : public DualTreeBASE_ITEM
{
  public:

    DualTreeBASE_ItemDATA( const DualTreeBASE_BODY * pBody ) ;
    ~DualTreeBASE_ItemDATA() ;  
};

//#############################################################################
// DualTreeBASE_BODY
//   virtual ֐ Set_Item() , Create_Item() 
//       inheritted class of node & data Ŏgpł悤ɂׂ class
//#############################################################################

class DualTreeBASE_BODY
{
  public:

    DualTreeBASE_BODY() ;

    virtual ~DualTreeBASE_BODY();

    virtual int  Set_Item( DualTreeBASE_ITEM * pItem, int which, int flag ) ;

    virtual DualTreeBASE_ITEM * Create_Item( int is_Node,
                                               DualTreeBASE_ItemNODE * pMother,
                                               int which, 
                                               const wxString & name
                                           ) ;
};

//#############################################################################
//
//
//#############################################################################

class DualTreeBASE_ITERATE
{
  public:

    short                 m_stack_Depth ;
    long                  m_stack_Index_L [128] ;
    DualTreeBASE_ItemNODE * m_stack_NodPtr_L[128] ;

  public :

    DualTreeBASE_ITEM * First( const DualTreeBASE_ItemNODE * pMother,
                                                            long index = 0 ) ;
    DualTreeBASE_ITEM * Next() ;
};

#endif // MY_DUALTREE_BODY_H_
