#include  <stdlib.h>
#include  "wx/wx.h"
#include  "wx/filename.h"
#include  "DualTree_Ctl.h"
#include  "TopFrame.h"
#include  "MyThread.h"
#include  "Checked.xpm"
#include  "Check_Go.xpm"
#include  "Check_NoGo.xpm"
#include  "Check_Undef.xpm"
#include  "Check_Inhibit.xpm"
#include  "equal.xpm"
#include  "n_equal.xpm"
#include  "q_equal.xpm"
#include  "left_dir.xpm"
#include  "right_dir.xpm"
#include  "Diff_Ind_0.xpm"
#include  "Diff_Ind_1.xpm"
#include  "ExPanded_0.xpm"
#include  "ExPanded_1.xpm"
#include  "ExPanded_3.xpm"
#include  "empty.xpm"

//#include  "D_Vector.h"

BEGIN_EVENT_TABLE(DualTree_CTL, wxScrolledWindow)
//    EVT_PAINT  (DualTree_CTL::OnPaint)
    EVT_MOTION( DualTree_CTL::OnMouseMotion)
    EVT_LEFT_DOWN( DualTree_CTL::OnLMouseDown)
    EVT_RIGHT_DOWN( DualTree_CTL::OnRMouseDown)
    EVT_LEFT_UP( DualTree_CTL::OnLMouseUp)
    EVT_LEFT_DCLICK( DualTree_CTL::OnLDoubleClick )
    EVT_MOUSEWHEEL(  DualTree_CTL::OnMouseWheel )
    EVT_SCROLLWIN( DualTree_CTL::OnScroll )
    EVT_MENU( menu_ID_BackUp_Chk_NodeAll, OnBackUp_Chk_NodeAll )
    EVT_MENU( menu_ID_BackUp_UnChk_NodeAll, OnBackUp_UnChk_NodeAll )
    EVT_TIMER( wxID_ANY, DualTree_CTL::OnTimerEvent )
END_EVENT_TABLE()

//*****************************************************************************

const wxEventType  DualTree_CTL::EVTYP_Item_OnCursor = wxNewEventType() ;

const short DualTree_CTL::Max_Item_DrawInf = 512 ;

//={  /i_State mask
const long DualTreeCtl_ITEM::st_BACKUP_OPT  = 0x01 ;
//const long DualTreeCtl_ITEM::st_zTIME_STAMP = 0x02 ;
//const long DualTreeCtl_ITEM::st_TIME_STAMP  = 0x06 ;
const long DualTreeCtl_ITEM::st_HIDDEN      = 0x10 ;
//const long DualTreeCtl_ITEM::st_BACKUP_GO   = 0x20 ;
const long DualTreeCtl_ITEM::st_SELECTED    = 0x40 ;

const long DualTreeCtl_ITEM::st_EXPANDED    = 0x100 ;
const long DualTreeCtl_ITEM::st_EXPANDED_M  = 0x300 ;
// }=

short  DualTreeCtl_ITEM::s_Show_Bkup_Only = 0 ;//0 :l

//---

const int   DualTree_CTL::Band_Cursor_Select = 80 ;

//--
static int s_Radius_inCirc = 2 ;

//--

static wxBitmap bmp_Equal_Symb( equal_xpm ) ;
static wxBitmap bmp_Q_Equla_Symb( q_equal_xpm ) ;
static wxBitmap bmp_Left_Dir_Symb( left_dir_xpm ) ;
static wxBitmap bmp_Right_Dir_Symb( right_dir_xpm ) ;

extern int Residual_Str_UnMatched(
                            const wxString & test_Str, //in>  may contain 'base_Str'
                            const wxString & base_Str, //in
                            wxString * residual ) ;


//*****************************************************************************
//
//*****************************************************************************

DualTree_CTL::DualTree_CTL( void )
    : wxScrolledWindow(),
        m_Size_NodRoot( 15, 10 ),
        m_Size_NodChild( 10, 5 ),
        m_Size_DataItem( 10, 5 ),
        m_zPos_Top( -10, -5 )
{
    m_pRoot_Node = new DualTreeCtl_ROOT() ;

    m_Cnt_Item_DrawInf   = 0 ;
    m_Frame              = 0 ;
    m_pArry_Item_DrawInf = new Item_DrawINFO[ Max_Item_DrawInf ] ;
}

//*****************************************************************************
//
//*****************************************************************************

DualTree_CTL::DualTree_CTL
(
    wxWindow * parent,
    const TopFRAME * frame
)  : wxScrolledWindow( parent, wxID_ANY, wxDefaultPosition, wxDefaultSize,
                        wxHSCROLL | wxVSCROLL | wxNO_FULL_REPAINT_ON_RESIZE ),
        m_Size_NodRoot( 15, 20 ),
        m_Size_NodChild( 10, 5 ),
        m_Size_DataItem( 10, 5 ),
        m_zPos_Top( -10, -5 )
{
    m_pRoot_Node = new DualTreeCtl_ROOT() ;

    SetScrollbars( 10, 10, 100, 240 );
///    GetFont().SetPointSize( 8 ) ;
    SetFont( wxFont( 8, wxFONTFAMILY_MODERN,  wxFONTSTYLE_NORMAL,
                                              wxFONTWEIGHT_NORMAL ) );

    m_X_Siz_Item_L[0] = 34 ;
    m_X_Siz_Item_L[1] = bmp_Equal_Symb.GetWidth() * 2 + 8;
    m_Y_Siz_Item      = bmp_Equal_Symb.GetHeight() + 4 ;
    m_Ys_Inter_Item = 3 ;
    m_Offset_X      = m_X_Siz_Item_L[0] * 2 / 3;

    m_Pen_Leg[0]   = * wxLIGHT_GREY_PEN ;
    m_Pen_Leg[1]   = * wxLIGHT_GREY_PEN ;
    m_Pen_Leg[1].SetStyle( wxDOT ) ;

    m_Pen_LegShort = m_Pen_Leg[0] ;
    m_Pen_Default  = * wxBLACK_PEN  ;

    m_Brush_Fill     = * wxBLACK_BRUSH ;
    m_Brush_Default  = wxNullBrush ;

    wxBitmap bmap( Checked_xpm ) ;
    m_Bmp_Backup_Chked = wxBitmap( Checked_xpm ) ;
    m_Bmp_Backup_Undef = wxBitmap( check_undef_xpm ) ;
    m_Bmp_Backup_Go    = wxBitmap( check_go_xpm ) ;
    m_Bmp_Backup_NoGo  = wxBitmap( Check_NoGo_xpm ) ;
    m_Bmp_Backup_Inhibit = wxBitmap( Check_Inhibit_xpm ) ;
    m_Bmp_EmptySpace     = wxBitmap( empty_xpm ) ;
    m_Bmp_Node_Diff_Ind[ 0 ] = wxBitmap( Diff_Ind_0_xpm ) ;
    m_Bmp_Node_Diff_Ind[ 1 ] = wxBitmap( Diff_Ind_1_xpm ) ;
    m_Bmp_Node_Expanded[ 0 ] = wxBitmap( Expanded_0_xpm ) ;
    m_Bmp_Node_Expanded[ 1 ] = wxBitmap( Expanded_1_xpm ) ;
    m_Bmp_Node_Expanded[ 3 ] = wxBitmap( Expanded_3_xpm ) ;
    m_Bmp_Equal_Symb     = wxBitmap( equal_xpm ) ;
    m_Bmp_N_Equal_Symb   = wxBitmap( n_equal_xpm ) ;
    m_Bmp_Q_Equal_Symb   = wxBitmap( q_equal_xpm ) ;
    m_Bmp_Left_Dir_Symb  = wxBitmap( left_dir_xpm ) ;
    m_Bmp_Right_Dir_Symb = wxBitmap( right_dir_xpm ) ;

    ///m_Brush_BkupTarget.SetColour( * wxRED ) ; 
    ///m_Brush_BkupTarget.SetStyle( wxSOLID ) ; 
    m_Brush_BkupTarget.SetStipple( bmap ) ;

    m_Brush_BkupTarget_F.SetColour( wxColor( 255, 224, 224 ) ) ; 
//    m_Brush_BkupTarget_F.SetStyle( wxCROSS_HATCH  ) ;
    m_Brush_Node     = * wxLIGHT_GREY_BRUSH ;
    m_Brush_Selected = wxBrush( wxColour( 192, 255, 255, 128 ) ) ;

    m_Cnt_Item_DrawInf   = 0 ;
    m_pArry_Item_DrawInf = new Item_DrawINFO[ Max_Item_DrawInf ] ;

    m_Frame               = (TopFRAME *)frame ;

///    m_Idx_IRect_Cursor = -1 ;
    //m_Name_Root[0]() ;

///    m_Name_Root[0] = "Source" ;
///    m_Name_Root[1] = "Destnation" ;
    m_pDrawInf_Selecting = 0 ;
}

//*****************************************************************************
//
//*****************************************************************************

DualTree_CTL::~DualTree_CTL()
{
    delete m_pRoot_Node ;

    delete[] m_pArry_Item_DrawInf ;

    //::wxLogDebug( "DualTree_CTL::~DualTree_CTL() this = %p, %p", this, & m_Y2_View );
}

//*****************************************************************************
//
//*****************************************************************************

//static int cmp_y_client( const void * pElm1, const void * pElm2 )
//{
//    return( ((Item_DrawINFO *)pElm1)->position.y - ((Item_DrawINFO *)pElm2)->position.y );
//}

//*****************************************************************************
//
//*****************************************************************************

int
DualTree_CTL::Scroll_Item_Visible
(
    const DualTreeCtl_ITEM * pItem,  //Item  Visible ɂȂ悤ɁAy-scroll 
    int                      y_Cli   // pItem Ȃׂ̉ʈʒuɂȂ悤ɂ
)
{ 
    return( 0 ) ;                                               // 
}

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::Set_DrawInfo
(
    bool   to_Draw,
    int  * height   //<out>
)
{
    m_Cnt_Item_DrawInf = 0 ;
    m_pRoot_Node->m_DrawInf_Cursor.m_pItemBase = 0 ;

    m_To_DrawLegs = to_Draw ;

    Set_DrawInf_Children( m_pRoot_Node, m_zPos_Top, height ) ;
}

//*****************************************************************************
//
//*****************************************************************************

void
DualTree_CTL::Set_DrawInf_Children
(
    const DualTreeBASE_ItemNODE * pNodMothr, 
    const wxPoint & zPos_M,        //eNode rectangle 
    int * height_Out      //
)
{
        int idx ;
        wxRect  zRect_M( zPos_M.x, zPos_M.y, 
                          m_X_Siz_Item_L[ 0 ], m_Y_Siz_Item )   ;//eNode rectangle 
        DualTreeBASE_ITEM * pItem ;
        DualTreeCtl_NODE * pNod ;

        wxRect  zRect   ; //echild item  rectangle 
        wxRect  zRect_0 ; //ŏ child item  rectangle  
        int  y_End, x, y ;
        int  left_ZR, width_ZR ; 
        int  height_ZR, height_Children ;
                ::wxLogDebug( wxT("Set_DrawInf_Children() : dep=%d, name = <%s>, <%s>"), pNodMothr->Depth(),
                                pNodMothr->m_Name_L[0].c_str(),pNodMothr->m_Name_L[1].c_str());

    zRect_0 = zRect_M ;

    zRect_0.Offset( m_Offset_X, 0 ) ;

    left_ZR   = zRect_0.GetLeft() ;
    width_ZR  = zRect_0.GetWidth() ;

    zRect = zRect_0 ;

    height_ZR = zRect_M.height ;

    height_Children = 0 ;

    for( idx = 0 ; idx < pNodMothr->Cnt_Children() ; idx ++ )
    {
        pItem = pNodMothr->Item_Ptr( idx ) ;

        if( pItem == 0 )   break ;

        zRect.Offset( 0, height_ZR + height_Children + m_Ys_Inter_Item ) ;
              //::wxLogDebug( "        -- Set_DrawInf_Children() idx = %d, pItem= %p", idx, pItem ) ;

///        if( zRect.y >= m_Y2_View + 50 )   break ;//exceed visible range
///                                                 ///scroll-Bar total height Kv
        height_Children = 0 ;

        if( pItem->Is_Node() )
        {
            Set_DrawInf_Item( pItem, zRect.GetTopLeft(), & height_ZR ) ;

            pNod = (DualTreeCtl_NODE *) pItem ;

            if( pNod->Is_Expanded() >= 3 )
            {
                Set_DrawInf_Children( pNod, zRect.GetTopLeft(), & height_Children ) ;
            }
        }
        else
        {
            Set_DrawInf_Item( pItem, zRect.GetTopLeft(), & height_ZR ) ;
        }
    }

    if( ! m_To_DrawLegs )   goto  EXIT ;

    //-{̑`

    x = X_Left_Leg( zRect_0.GetTopLeft() ) ;
    y = zRect_M.GetBottom() ;
    y_End = zRect.GetBottom() ;
         //::wxLogDebug( wxT("Set_DrawInf_Children()  Leg y = %d, %d\n"), y, y_End );
    m_pDC->SetBrush( *wxBLACK_BRUSH ) ;
    m_pDC->SetPen( m_Pen_Leg[0] );
    m_pDC->DrawLine( x, y /*- m_Ys_Inter_Item*/, x, y_End ) ;
    m_pDC->SetPen( m_Pen_Default );
    //m_pDC->DrawRectangle( x - 1, y - 1, 2, 2 ) ;

    x = X_Right_Leg( zRect_0.GetTopLeft() ) ;
    m_pDC->SetPen( m_Pen_Leg[1] );
    m_pDC->DrawLine( x, y /*- m_Ys_Inter_Item*/, x, y_End ) ;
    //m_pDC->DrawRectangle( x - 1, y - 1, 2, 2 ) ;
    //-}̑`

 EXIT :

    if( height_Out )
    {
        * height_Out = zRect.GetBottom() - zRect_M.GetBottom() + height_Children ;
    }
}

//*****************************************************************************
// pItem@ ʕ\͈͂ɂ item Ȃ΁Am_pArry_Item_DrawInf[] Ɋi[
//*****************************************************************************

int
DualTree_CTL::Set_DrawInf_Item
(
    const DualTreeBASE_ITEM * pItem,
    const wxPoint & zPos_M,   //
    int * height_Out
)
{
        int     x0, y0, dx, w0, h0, y_Nam_C ;
        int     ht_Inc ;
        int     result ;

        short   flg_toDrawName = 0;
        wxRect zRect, wr ;  //
        wxPen  pen ;
        Item_DrawINFO    * pDrawInf ;
        DualTreeCtl_ITEM * pCtlItem ;

        wxRect  zRect_M( zPos_M.x, zPos_M.y, 
                         m_X_Siz_Item_L[ 0 ], m_Y_Siz_Item ) ;

    result = 0 ;
    ht_Inc = 0 ;

    pCtlItem = (DualTreeCtl_ITEM *) pItem->m_pCustomData ;

    zRect = zRect_M ;   //

    zRect.Offset( m_Offset_X, 0 ) ;

    //={ *** decide symbol-height

    y_Nam_C = 0 ;

    if( pItem->m_Is_Valid_L[0]  && 
        pItem->m_Is_Valid_L[1]     )
    {
        if( pItem->m_Name_L[0] == pItem->m_Name_L[1] )
        {
///            zRect.SetHeight( m_Y_Siz_Item ) ;
            flg_toDrawName = 1 ;
        }
        else
        {
///            zRect.SetHeight( m_Y_Siz_Item + ( m_Y_Siz_Item / 4 ) ) ;
            ht_Inc = m_Y_Siz_Item / 4  ;
            flg_toDrawName = 3 ;
        }
    }
    else if( pItem->m_Is_Valid_L[0] )
    {
///        zRect.SetHeight( m_Y_Siz_Item ) ;
        flg_toDrawName = 1 ;
    }
    else if( pItem->m_Is_Valid_L[1] )
    {
///        zRect.SetHeight( m_Y_Siz_Item ) ;
        flg_toDrawName = 2 ;
    }

    //}= decide symbol-height

    dx   = zRect.GetWidth() / 4 ;
    x0   = zRect.x ;
    y0   = zRect.y + ht_Inc ;
    w0   = zRect.width ;
    h0   = zRect.height ;

    if( y0 >= m_Y2_View + 50 )    goto  EXIT ;//exceed visible range

    if( m_Y1_View < y0 + h0  &&  y0 < m_Y2_View )
    {      //be in a view-ranage
///        CalcScrolledPosition( x0, y0, & xx, & yy ) ;//scrolled position 

        pDrawInf = & m_pArry_Item_DrawInf[ m_Cnt_Item_DrawInf ] ;
        pDrawInf->m_pItemBase  = (DualTreeBASE_ITEM *) pItem ;
        pDrawInf->m_position   = wxPoint( x0, y0 ) ;
        pDrawInf->m_f_Draw_Name = flg_toDrawName ;

            //::wxLogDebug( "Item_DrawInf[%hd].x =%d", m_Cnt_Item_DrawInf, zRect.x );
        m_Cnt_Item_DrawInf ++ ;

        result = 1 ;
    }

 EXIT :

    if( height_Out )
    {
        * height_Out = h0 + ht_Inc * 2 ;
        if( pItem->Is_Node() )
            * height_Out += 2 ;
    }

    return( result );
}

//*****************************************************************************
//
//*****************************************************************************

int
DualTree_CTL::Is_RootFolder_Specified( int which ) const
{
    return( ! m_pRoot_Node->m_Name_L[ which ].IsEmpty() );
}

//*****************************************************************************
//
//*****************************************************************************

int
DualTree_CTL::Get_Chk_Btn_Rect
(
    const wxRect & fRect,  //in
    wxRect * btnRect    //out
)  const
{
        int  x0, y0, w0, h0 ;

    x0 = fRect.x ;
    y0 = fRect.y ;
    w0 = fRect.width ;
    h0 = fRect.height ;

///    * btnRect = wxRect( x0 + (h0 / 4),  y0 + (h0 / 6), h0 / 2 + 2 , h0 - 2 * (h0 / 6) ) ;
    * btnRect = wxRect( x0 + (h0 / 4),  y0 + 1, h0 / 2 + 2 , h0 - 2 ) ;

    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
DualTree_CTL::X_Size_Item( const DualTreeBASE_ITEM * pItem ) const
{
    if( pItem->Is_Node() )  return  m_X_Siz_Item_L[ 0 ] ;
    return( m_X_Siz_Item_L[ 1 ] ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
DualTree_CTL::X_Left_Leg( const wxPoint & pos ) const
{
    return( pos.x + m_X_Siz_Item_L[0] / 5 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
DualTree_CTL::X_Right_Leg( const wxPoint & pos ) const
{
    return( pos.x + m_X_Siz_Item_L[0] / 3 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
DualTree_CTL::Height_Item( const Item_DrawINFO & drawInf ) const
{
    int h = m_Y_Siz_Item ;
    if( drawInf.m_f_Draw_Name == 3 )
        h += m_Y_Siz_Item / 4 ;

    return( h ) ;
}

//*****************************************************************************
//
//*****************************************************************************

//int
//DualTree_CTL::X_Item_Right( const wxRect & zRect )
//{
//    return( zRect.GetRight() + 2 * zRect.GetWidth() ) ;
//}

//*****************************************************************************
//  root-path ̈vȂ̒Ԃ
//      0 ȂAfullPath_Name ́A擪 root-path  SĊ܂
//*****************************************************************************

int
DualTree_CTL::Relative_Path
(
    const wxString & fullPath_Name, 
    int which,
    wxString * relPath // <out>
) 
{
    return
    ( 
        Residual_Str_UnMatched( fullPath_Name,
                                 m_pRoot_Node->m_Name_L[ which ],
                                 relPath )
    );
}


//*****************************************************************************
// (this) (=Foloder) ̉ children  load ĊJ
//*****************************************************************************

int  
DualTree_CTL::Begin_Load_Children_Th
(
    DualTreeCtl_NODE * pNod_Mother,
    int which 
)
{
        LoadTree_THREAD * pThread ;

    pThread = new LoadTree_THREAD( m_Frame, pNod_Mother, which );

    m_Frame->Append_Thread_Queue( pThread ) ;

    return( 0 ) ;
}

