//dualtreectl.h
/////////////////////////////////////////////////////////////////////////////
// Name:        wx/msw/treectrl.h
// Purpose:     DualTreeBASE_BODY class
// Author:      Julian Smart
// Modified by: Vadim Zeitlin to be less MSW-specific on 10/10/98
// Created:     01/02/97
// RCS-ID:      $Id: treectrl.h 49563 2007-10-31 20:46:21Z VZ $
// Copyright:   (c) Julian Smart
// Licence:     wxWindows licence
/////////////////////////////////////////////////////////////////////////////

#ifndef MY_DUALTREE_CTL_H_
#define MY_DUALTREE_CTL_H_

#include <wx/gdicmn.h>
#include <wx/scrolwin.h>
#include <wx/brush.h>
#include <wx/pen.h>
//#include <wx/dc.h>
#include <wx/event.h>
#include <wx/timer.h>
#include "D_Vector.h"
#include "DualTreeBase.h"

typedef unsigned char  BYTE ;

//#############################################################################
//
//#############################################################################

class Item_DrawINFO
{
  public :

    DualTreeBASE_ITEM  * m_pItemBase ;
    wxPoint              m_position ;//memorise coordinate
                                        //  in Scrolling Space
    short                m_f_Draw_Name ;//file-name Draw ׂǂflag
};

//#############################################################################
// Sort priority information
//#############################################################################

class DTree_SORT : public D_VECTOR
{
  public :

    short   m_Cnt_Priority ;//counts of priority. this is constant value = 6
    short   m_Priority_Lst[ 8 ] ;//Sort ̃vCIeB
                // index ̏vCIeB
                //   evf̒ĺA̒lBl̂ƂAÂƂ͍~
                //
                //m_Priority_Lst[ i ]  l͎̈Ӗ. 
                // 1 = file  folder ̈ႢɂĂǂ̏ʂ邩̔悤Ɏw;  
                // 2 = source-side  destination-side ̈ႢɂĂǂ̏ʂ邩̔
                // 3 = O ɂďʂ̔ ;  
                // 4 = file-type ɂďʂ̔   
                // 5 = t ɂďʂ̔ 
                // 6 = size ɂďʂ̔ 
    public :

        DTree_SORT();

        void Set_Priority( const short sort_Priority_Lst[] ) ;
        void Reverse_Priority() ;
        void Move_Priority( int idx_New, int idx ) ;

        int  Compare( void * e1, void * e2 );
};

//#############################################################################
//
//#############################################################################

class DualTreeCtl_ITEM
{
  public :
   //-{ i_State bit/ 'i_State' ɑ΂ bits Mask

    static const long  st_BACKUP_OPT ; //Back-up Ώۂɂ邩ǂtO
                          // source ɑ݂ item ݈̂Ӗ
                          //  = 0 : Back-up Ώۂł͂Ȃ
                          //  = 1 : Back-up Ώۂł.   AΏۂ
                          //            ĂAeΏۂłȂƁAbackup Ȃ
//={  /100/ ۂɂ͎gĂȂ
//    static const long  st_zTIME_STAMP ; //TIME_STAMP mask ̊Jnbit = 1 
//    static const long  st_TIME_STAMP ; //source  destination  XV̔r
//                          //=0: time-stamp ̔r܂ĂȂ
//                          //=1; source is newer than destination
//                          //=2: source is older than destination
//                          //=3: source is same with destination
//    static const long  st_BACKUP_GO   ; //ON: ۂBack-up t@Cł
//}= /100

    static const long  st_HIDDEN      ; //ON: \Ȃ
                                        //    AAst_BACKUP_GO = ON ̎́A\
    static const long  st_SELECTED    ; //ON: I\ꂽt@Cł

    //ȉ Node(=Folder)-Item ݈̂Ӗ

    static const long  st_EXPANDED    ; // Node Expand-status \ bits-pattern  LSB l
    static const long  st_EXPANDED_M  ; // Node Expand-status \ bits-pattern  Mask data
                                        //== b'00 --> Node ͕Ă
                                        //== b'01 --> Node JƂĂ(click action)
                                        //== b'11 --> Node ͊JĂB
                                        // AAON ̎As_Show_Bkup_Only = 1 ̎́A
                                        //    Backup Ώۃt@Ĉ \
///    static const long  ALREADY_LOADED ; //ON: Node children   Load Ă

    //-} i_State bit/ 

    static  short  s_Show_Bkup_Only ;//̃tO 0 łȂANode WJĂ
                                     // Backup Ώۃt@Ĉ \B
                                     // ̃tO͑SẴt@CɂēKpB
  public :

    DualTreeBASE_ITEM * i_pItemBase ; //DualTreeBASE_ITEM data ւ pointer
                                      //      ͕K{
    //------------------

    long         i_State ; //User operation ɂ̂ݐݒ肳łB
                           //   Xfile/folder Ă͊܂܂Ȃ
                           //L -{i_State bit/Q

///    int_8         m_Is_Valid_L[ 2 ] ; //DualTreeBASE_ITEM Œ`
                                  //== 0  ̎ATreeɑ݂Ȃ
                                  //== 1  ̎ATreeɑ݂āAaccess \
                                  //== -1 ̎ATreeɑ݂邪Aaccess s
                                  //[0] for Source side
                                  //[1] for Destination side
    wxDateTime   i_Upd_Date_L [ 2 ] ; //updated stamp time
                                      //[0] for Source side
                                      //[1] for Destination side
    wxULongLong  i_Data_Size_L[ 2 ] ;//  file-size in [BYTE]
                                     //[0] for Source side
                                     //[1] for Destination side
  public :

    DualTreeCtl_ITEM()  ;
    ~DualTreeCtl_ITEM() ;

    int      Backup_Option()     const ;
    bool     Is_Backup_Target()  const ;
    bool     Is_Hidden()         const ;
    int      Is_Expanded()       const ;
    int      Set_Backup_Option( int opt ) ;
    wxString Get_Full_Path( int which ) const ;
    wxString Get_Relative_Path( int which ) const ;
    int      Set_TStamp( int which ) ;
    int      Compare_TStamp( time_t sec_Dead_Band ) const ;
                                      //0: completely same, 
                                      //1 : source V 
                                      //-1 : destination V , 
                                      //10 : size ݈̂قȂ
                                      //100 : rłȂ
};

//#############################################################################
//
//#############################################################################

class DualTreeCtl_DATA : public DualTreeBASE_ItemDATA, public DualTreeCtl_ITEM
{
  public :

    DualTreeCtl_DATA( const DualTreeBASE_BODY * pBody,
                        DualTreeBASE_ItemNODE * pMother, 
                        int which, 
                        long sibl_Order, 
                        const wxString & name 
                    ) ;
};

//#############################################################################
//
//#############################################################################

class DualTreeCtl_NODE : public DualTreeBASE_ItemNODE, public DualTreeCtl_ITEM
{
  public :

///    long   m_Height_us ;//current height of us including all children
                            // < 0 ---> not calculated state 
                            //  this is not implemented yet
    short   m_Flag_Diff ;// Node  children  قtOł
                //                            == 0 ƁAɈvł
                // Q 2ibit\ <ABBC> ŕ\ƂBE[ LSB ł
                //
                // A  : قcheck ô̒ŁA
                //           ق邩ǂ\B(mask = 0x08)
                //      A = 0 : SĈv
                //      A = 1 : vȂ̂
                //
                // BB : G[̏Ԃ\    (mask = 0x06, 0x02)
                //      BB = 00 : S check         0x00
                //      BB = 01 : Cancel             0x02
                //      BB = 10 : G[             0x04
                //      BB = 11 : G[  Cancel   0x06
                //
                // C  : source destination ĂāA
                //           check\ǂ (mask = 0x01)
                //                                                       
                //      C = 0 ; source  destination ĂāAcheck 悤Ƃ
                //      C = 1 : S̖check ԁB܂ɂĂȂ A܂́A
                //              sourceAdestination̂ǂ炩ȂA
                //                    C=1 ̎́AA,BB rbg ͖ӖłB
  public :

    DualTreeCtl_NODE( const DualTreeBASE_BODY * pBody,
                      DualTreeBASE_ItemNODE * pMother = 0, 
                      int                     which = -1, 
                      long                    sibl_Order = 0, 
                      const                   wxString & name = wxT("") 
                    ) ;
    
    ~DualTreeCtl_NODE() ;

    int  Set_BackupOpt_Children( int opt ) ;

    long Count_Specific_State( long mask, long value ) const ;

    void Set_State_All( long mask, long value ) ;

    int  Reset_Diff_Flag() ;

    int  Begin_Load_Children( DTree_SORT & dTree_Sort, int which ) ;

    int  Sort_Children( DTree_SORT & dTree_Sort ) ;

    int  Refer_Other( DTree_SORT & dTree_Sort,
                      const DualTreeCtl_NODE & nodeOther ) ;
};

//#############################################################################
//  Item ̒ŁAz֐p邽߂ class
//#############################################################################

class DualTreeCtl_ROOT : public DualTreeCtl_NODE, public DualTreeBASE_BODY
{
  public :

    Item_DrawINFO  m_DrawInf_Cursor ;//Cursor ʒu  Item 

  public :

    DualTreeCtl_ROOT() ;
    virtual ~DualTreeCtl_ROOT() ;

    //inherit virtual function
    int  Set_Item( DualTreeBASE_ITEM * pData, int which, int flag ) ;

    DualTreeBASE_ITEM * Create_Item( int is_Node,
                                        DualTreeBASE_ItemNODE * pMother,
                                        int which, 
                                        const wxString & name
                                   ) ;
};

class TopFRAME ;
class wxDC ;

//#############################################################################
//
//#############################################################################

class DualTree_CTL : public wxScrolledWindow
{
  public :

    static const short Cnt_Sort_Priority ;
    static const short Max_Item_DrawInf ;
    static const int   Band_Cursor_Select ;

    static const wxEventType EVTYP_Item_OnCursor ;

  public :

    TopFRAME * m_Frame ;

    wxDC     * m_pDC ;

    DualTreeCtl_ROOT * m_pRoot_Node ;//̃m[h m_Name_L[] ɂ
                                     //   root full path set Ă邱
                                     //       AAŌ '/' ͂ĂȂ
                                     // object 𖄂ߍ(embeded) łȂ
                                     //    pointer Ŋmۂ̂,flexibility ̈
    //------------------------------
    short           m_Cnt_Item_DrawInf ;

    Item_DrawINFO * m_pArry_Item_DrawInf ;//Client ̈\f[^ i[z

    //------------------------------
    //temporary working variable

    Item_DrawINFO * m_pDrawInf_Selecting ; //Left ButtonDown   click point  Item_DrawINF
                                           // = 0 ȂAtimer over

    bool     m_To_DrawLegs ;//Set_DrawInf_Children() ł̂ݎQƂ

    int      m_Y1_View ;
    int      m_Y2_View ;

    wxTimer             m_Timer ;

    DualTreeBASE_ITEM * m_pItem_R_Clked  ; //Right clicked Item

    DTree_SORT          m_SortPrior_Tbl ;

    short    m_Diff_Check_Ind ; //<> 0 ̎̂݁ANode ɁAindicator \

   //={ 10/ constant for Item darwing metrics
    int      m_X_Siz_Item_L[ 2 ] ;//[0] = width of Node Rect
                                  //[1] = width of Data Rect
    int      m_Y_Siz_Item    ;//height of Item Rect
    int      m_Ys_Inter_Item ;//Verticla space between Items
    int      m_Offset_X      ;//right shifting amount for children position
   //}= 10/

    wxSize   m_Size_NodRoot ;
    wxSize   m_Size_NodChild ;
    wxSize   m_Size_DataItem ;

    wxPoint  m_zPos_Top ;

 ///   wxString m_Name_Root[2] ;

    wxPen    m_Pen_Leg[ 2 ] ;//m_LegPen[0] = A-side(left) Leg Line
                             //m_LegPen[1] = B-side(right) Leg Line
    wxPen    m_Pen_LegShort ;

    wxPen    m_Pen_Default ;

    wxBrush  m_Brush_Fill ;
    wxBrush  m_Brush_Default ;
    wxBrush  m_Brush_BkupTarget ;//backup Ώۂł鎖 brush-->͕sgp
    wxBrush  m_Brush_BkupTarget_F ;//em[hindicator Ɉˑ鎖 brush
    wxBrush  m_Brush_Selected ;
    wxBrush  m_Brush_Node ;

    //-{ BMP-rsrc/ ȉABacup option indicator (old :m_Brush_BkupTraget)
    wxBitmap m_Bmp_Backup_Chked ;
    wxBitmap m_Bmp_Backup_Undef ;//
    wxBitmap m_Bmp_Backup_Go    ;//
    wxBitmap m_Bmp_Backup_NoGo  ;//
    wxBitmap m_Bmp_Backup_Inhibit ;//
    wxBitmap m_Bmp_Equal_Symb     ;
    wxBitmap m_Bmp_N_Equal_Symb   ;
    wxBitmap m_Bmp_Q_Equal_Symb   ;
    wxBitmap m_Bmp_Left_Dir_Symb  ;
    wxBitmap m_Bmp_Right_Dir_Symb ;
    //
    wxBitmap m_Bmp_EmptySpace   ;//

    wxBitmap m_Bmp_Node_Diff_Ind[ 2 ] ;//
    wxBitmap m_Bmp_Node_Expanded[ 4 ] ;//
    //-} BMP-rsrc

  public :

    DualTree_CTL() ;

    DualTree_CTL( wxWindow *parent, const TopFRAME * frame );
    ~DualTree_CTL() ;

    int  X_Size_Item( const DualTreeBASE_ITEM * pItem ) const ;

    int  X_Left_Leg ( const wxPoint & pos )  const ;
    int  X_Right_Leg( const wxPoint & pos )  const ;

    int  Height_Item( const Item_DrawINFO & drawInf ) const ;

    int  Get_Chk_Btn_Rect( const wxRect & fRect, wxRect * btnRect ) const;

    int  Is_RootFolder_Specified( int which ) const ;

    int  Relative_Path( const wxString & fullPath_Name, 
                            int which, wxString * relPath );

    Item_DrawINFO * Get_Item_Y_Pos( int y_Pos, int * pIdx_DrInf )  const ;

    int  Scroll_Item_Visible( const DualTreeCtl_ITEM * pItem, int y_Cli ) ;

    int  Begin_Load_Children_Th( DualTreeCtl_NODE * pNod_Mother, int which ) ;//thread version

    void Set_DrawInfo( bool to_Draw, int * height ) ;

    void Set_DrawInf_Children( const DualTreeBASE_ItemNODE * pNodMothr, 
                               const wxPoint & z_PosM, int * height_Cell ) ;

    int  Set_DrawInf_Item( const DualTreeBASE_ITEM * pItem,
                                const wxPoint & zPos_M,   //
                                int * height_Out         );

    int  Copy_Children_in_DTree( const DualTreeCtl_NODE * pMother,
                                 const wxString & srcFoldr_Path,   //source  Folder path
                                 const wxString & dstFoldr_Path    //destination  Folder path. (݂͑邱)
                                );                                 //  Apath ̍Ō '/' 鎖

    long Check_Folder_Children( const wxString & srcFoldr_Path,  //source  Folder path
                                const wxString & dstFoldr_Path   //destination  Folder path
                              ) ;                                //  Apath ̍Ō '/' 鎖

    void Move_Sort_Priority( int idx_New, int idx ) ;

    void Draw_Item( const Item_DrawINFO & itm_DrawInf ) ;

    void Draw_Node_Item( const Item_DrawINFO & itm_DrawInf ) ;
    void Draw_Data_Item( const Item_DrawINFO & itm_DrawInf ) ;
    void Draw_Item_Text( const DualTreeBASE_ITEM * pItemBase,
                                int flg_toDrawName,
                                int x0, int y0, int w0, int h0 ) const ;
    void Draw_Item_Arms( const DualTreeCtl_ITEM * pItem,
                                const wxPoint & zPos_M,
                                int  x0, int y0, int h0, int w0 ) const;
    void Draw_Backup_Option( const DualTreeCtl_ITEM * pItem ,
                                      const wxRect & btnRect ) const ;
  public :

    void OnDraw( wxDC & dc );
    void OnMouseMotion( wxMouseEvent& event );
    void OnLMouseDown( wxMouseEvent& event );
    void OnRMouseDown( wxMouseEvent& event );
    void OnLMouseUp( wxMouseEvent& event );
    void OnLDoubleClick( wxMouseEvent& event );
    void OnMouseWheel( wxMouseEvent& event );
    void OnScroll( wxScrollWinEvent& event );
    void OnTimerEvent( wxTimerEvent & event );

    // Menu
    void OnBackUp_Chk_NodeAll( wxCommandEvent& event ) ;
    void OnBackUp_UnChk_NodeAll( wxCommandEvent& event ) ;

    DECLARE_EVENT_TABLE()
};

//#############################################################################
//
//#############################################################################

class DTree_Iterate_SELECTED : public DualTreeBASE_ITERATE
{
    DualTreeBASE_ITEM * Get_1st( DualTreeBASE_ItemNODE * pRoot_Node ) ;
    DualTreeBASE_ITEM * Get_Next() ;
};

//#############################################################################

enum menu_id_DTree
{
    menu_ID_BackUp_Chk_NodeAll = wxID_HIGHEST,
    menu_ID_BackUp_UnChk_NodeAll
};

#endif
