#include <wx/dcclient.h>
#include <wx/filename.h>
#include <wx/log.h>
#include "File_Info_Ctl.h"

BEGIN_EVENT_TABLE( File_Info_CTL, wxWindow )
    EVT_PAINT( File_Info_CTL::OnPaint )
    EVT_SIZE( File_Info_CTL::OnSize )
END_EVENT_TABLE()

extern wxString ULL_2_1000_Decimal( const wxULongLong & x0 );
//extern wxString ULL_2_Comma_ed_Digits( const wxULongLong & x0, 
//                                        unsigned int UNIT_NUM ) ;
extern wxString Comma_ed_Str( wxString & str, int interval ) ;

//*****************************************************************************
//
//*****************************************************************************

File_Info_CTL::File_Info_CTL
(
    wxWindow * parent,
    int  wid
)  : wxWindow( parent, wid,
               wxDefaultPosition, wxDefaultSize,
               wxBORDER_SIMPLE )
{
///    m_Which = which ;
    q_Is_Valid    = 0 ;
    q_Alignment   = 0 ;
    q_VLen_FSize  = 100 ;
    q_VLen_DateTime = 130 ;

    SetFont( wxFont( 8, wxFONTFAMILY_MODERN,  wxFONTSTYLE_NORMAL,
                                              wxFONTWEIGHT_NORMAL ) );
    q_Data_Size = wxInvalidSize ;
}

//*****************************************************************************
//
//*****************************************************************************

void
File_Info_CTL::Set
(
    short  is_Valid,
    const wxString    * pPath, 
    const wxULongLong * pData_Size, 
    const wxDateTime  * pUpd_Date
)
{
    q_Is_Valid = is_Valid ;

    if( pPath )
        q_Path_Str  = * pPath ;
    if( pData_Size )
        q_Data_Size = * pData_Size ;
    if( pUpd_Date )
        q_Upd_Date = * pUpd_Date ;

    Refresh() ;
}

//*****************************************************************************
//
//*****************************************************************************

void
File_Info_CTL::Reset()
{
    q_Is_Valid  = 0       ;
    q_Path_Str  = wxT("") ;
    q_Data_Size = wxInvalidSize ;
    q_Upd_Date  = wxDateTime() ;

    Refresh() ;
}

//*****************************************************************************
//
//*****************************************************************************

void
File_Info_CTL::OnPaint
(
    wxPaintEvent & WXUNUSED( event ) 
)
{
        int  w_Cli, h_Cli;
        int  x_TimeField, w_TimeField, x_FSizwField, w_FSizwField ;
        int  w_FNameField ;
        int  ws, hs ;
        wxString  s, s1, s2, t ;
///        wxULongLong wk ;

    wxPaintDC dc( this );
 
    GetClientSize( & w_Cli, & h_Cli ) ;

    PrepareDC( dc );

    dc.SetFont( GetFont() ) ;

    w_TimeField = q_VLen_DateTime ;
    x_TimeField = w_Cli - q_VLen_DateTime ;
    if( x_TimeField < 0 )
    {
        x_TimeField = 0 ;
        w_TimeField = w_Cli ;
    }

    w_FSizwField = q_VLen_FSize ;
    x_FSizwField = w_Cli - q_VLen_DateTime - q_VLen_FSize ;
    if( x_FSizwField < 0 )
    {
        x_FSizwField = 0 ;
        w_FSizwField = w_Cli - q_VLen_DateTime ;
    }

    w_FNameField = w_Cli - q_VLen_DateTime - q_VLen_FSize ;

    if( w_FNameField > 0 )
    {
        s = wxT("") ;
        if( q_Is_Valid )
            s = q_Path_Str ;

        dc.SetClippingRegion( 0, 0, w_FNameField - 2, h_Cli ) ;
        s.Replace( wxT(">"), wxT("") ) ;

        s.Replace( wxT("\\"), wxT("") ) ;

        dc.GetTextExtent( s, & ws, & hs ) ;

        dc.DrawText( s, w_FNameField - ws , 0 ) ;

        dc.DestroyClippingRegion() ;
    }

    if( w_FSizwField > 0 )
    {
        s = wxT( "" );

        if( q_Is_Valid )
        {
            if( q_Data_Size == wxInvalidSize )
            {
                s = wxT( "*" );
            }
            else
            {
//                s = Comma_ed_Str( q_Data_Size.ToString(), 3 );
                s = ULL_2_1000_Decimal( q_Data_Size );
            }
        }

        dc.SetClippingRegion( x_FSizwField, 0, w_FSizwField, h_Cli ) ;

        dc.SetPen( * ::wxGREY_PEN ) ;
        dc.DrawLine( x_FSizwField + 1, 0, x_FSizwField + 1, h_Cli ) ;

        dc.GetTextExtent( s, & ws, & hs ) ;

        dc.DrawText( s, x_FSizwField + w_FSizwField - ws - 4, 0 ) ;

        dc.DestroyClippingRegion() ;
    }

    if( w_TimeField > 0 )
    {
        t = wxT( "                   " ) ;

        if( q_Is_Valid )
        {
            t = wxT( "              * " ) ;

            if( q_Upd_Date.IsValid() )
            {
//               t = q_Upd_Date.FormatISODate()  ;
                t = q_Upd_Date.Format( wxT("%y/%m/%d") ) ;
                t = t + wxT(" ") + q_Upd_Date.FormatISOTime() ;
            }
        }

        dc.SetPen( * ::wxGREY_PEN ) ;
        dc.DrawLine( x_TimeField + 1, 0, x_TimeField + 1, h_Cli ) ;

        dc.DrawText( t, x_TimeField + 4, 0 ) ;
    }
}

//*****************************************************************************
//
//*****************************************************************************

void
File_Info_CTL::OnSize( wxSizeEvent & /*event*/ )
{
    Refresh() ;
}
