
#include "wx/wx.h"
#include "wx/sizer.h"
#include "wx/timer.h"
#include "wx/dialog.h"

//#######################################################
//
//#######################################################

class MyAboutDlg : public wxDialog
{
       wxStaticText   * m_MsgCtrl ;
       wxStaticBitmap * m_BmpCtrl ;
       wxStaticText   * m_TipCtrl ;

//        wx_Timer  m_Timer

    public :

        MyAboutDlg( wxWindow * parent,
                    int        wid,
                    const wxString & title,
                    const wxString & msg );
        void  OnTimerEvent( wxTimerEvent & event ) ;

        DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE( MyAboutDlg, wxDialog )
    EVT_TIMER( wxID_ANY, MyAboutDlg::OnTimerEvent )
END_EVENT_TABLE()

//*****************************************************************************
//
//*****************************************************************************

// Define my frame constructor
MyAboutDlg::MyAboutDlg
(
    wxWindow * parent, 
    int        wid,
    const wxString & title,
    const wxString & msg
)  : wxDialog( parent, wid, title,
                 wxDefaultPosition, wxDefaultSize )
{
//  wxPanel* p = new wxPanel(this, wxID_ANY);
//  wxDialog * p = this ;
  // we want to get a dialog that is stretchable because it
  // has a text ctrl in the middle. at the bottom, we have
  // two buttons which.

//    m_Timer.SetOwner( this, wxID_ANY ) ;
    extern wxBitmap g_Bmp_CopyDirection ;

    wxBoxSizer *topsizer = new wxBoxSizer( wxVERTICAL );
    wxBoxSizer *scndsizer = new wxBoxSizer( wxHORIZONTAL );

  // 1) top: create wxStaticText with minimum size equal to its default size
    m_MsgCtrl = new wxStaticText( this, wxID_ANY, msg );
    m_BmpCtrl = new wxStaticBitmap( this, wxID_ANY, g_Bmp_CopyDirection ) ;
    m_TipCtrl = new wxStaticText( this, wxID_ANY, wxT("<-- Menu Button") );

    topsizer->Add( m_MsgCtrl,
                    wxSizerFlags().Align(wxALIGN_RIGHT).Border(wxALL & ~wxBOTTOM, 5));
    topsizer->Add( scndsizer,
                    wxSizerFlags().Align(wxALIGN_LEFT).Border(wxALL & ~wxBOTTOM, 5));
    scndsizer->Add( m_BmpCtrl,
                    wxSizerFlags().Align(wxALIGN_LEFT).Border(wxALL & ~wxBOTTOM, 5));
    scndsizer->Add( m_TipCtrl,
                    wxSizerFlags().Align(wxALIGN_LEFT).Border(wxALL & ~wxBOTTOM, 5));

    SetSizer( topsizer );

  // don't allow frame to get smaller than what the sizers tell it and also set
  // the initial size as calculated by the sizers
    topsizer->SetSizeHints( this );
}

//*****************************************************************************
//
//*****************************************************************************

void 
MyAboutDlg::OnTimerEvent( wxTimerEvent & WXUNUSED(event) )
{
    EndModal( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

void
Show_AboutDlg(  wxWindow * parent,
                int        wid,
                const wxString & title,
                const wxString & msg,
                int  milli_Sec_Open 
              )
{
    MyAboutDlg  dlg( parent, wid, title, msg ) ;
    dlg.Centre() ;

    wxTimer timer( & dlg ) ;

    if( milli_Sec_Open > 0 )
        timer.Start( milli_Sec_Open ) ;

        ::wxLogDebug( wxT("Show_AboutDlg(): dlg:id=%d"), dlg.GetId() );

    dlg.ShowModal() ;
}
