#include "wx/wxprec.h"
#include "wx/wxchar.h"
#include "wx/datetime.h"
#include "wx/string.h"
#include "wx/log.h"
#include "wx/filename.h"
#include "wx/file.h"
#include "wx/longlong.h"
#include "wx/defs.h"
#include "sys/types.h"
#include "sys/stat.h"
#include  <sys/utime.h>
#include "MyThread.h"

typedef  char INT_8 ;

//*****************************************************************************
// ז popup error dialog   
//*****************************************************************************

void WXDLLEXPORT
wxLogSysError( const wxChar * /*formatString*/, ...)
{
    wxLogDebug( wxT("wxLogSysError()") );
}

//*****************************************************************************
//
//*****************************************************************************

int  
Cnt_Ptr_Array( const void ** ptrArry )
{
    for( int i = 0 ; ptrArry[ i ] ; i ++ ) ;

    return( i ) ;
}

//*****************************************************************************
//
//*****************************************************************************
int
Set_File_Removable( wxString & fNam )
{
    wxCharBuffer  path ;
    int     ret ;

    path = fNam.mb_str( wxConvLibc ) ;
    ret = chmod( path, 0777 ) ;
    return( ret ) ;
}

//*****************************************************************************
// '\r' (CR=carriage return) ƁAݎ\ (hh:mm:ss) ɒu
//*****************************************************************************

wxString
Embed_Time_onCR( const wxString & msg ) 
{
    wxString  time, str ;

    time = wxDateTime::Now().Format( wxT("%H:%M:%S ") ) ;
    str  = msg ;

    str.Replace( wxT("\r"), time );

    return( str ) ;
}

//*****************************************************************************
//
//*****************************************************************************

bool
Boolian_Eq( int p1, int p2 )
{
    if( p1 )
    {
        if( p2 )  return( true  ) ;
        else      return( false ) ;
    }
    else
    {
        if( p2 )  return( false ) ;
        else      return( true  ) ;
    }
}

//*****************************************************************************
// 10i
//*****************************************************************************

wxString
Comma_ed_Str( wxString & str, int interval )
{
    wxChar s[64] ;
    int len, icnt, i, j ;

    len = str.Len() ;

    icnt = 0 ;
    j    = len / 3 + len ;

    for( i = len - 1 ; i >= 0 ; i --, icnt -- )
    {
        if( icnt <= 0 )
        {
            s[ j ] = wxT(',') ;
            j -- ;
            icnt = interval ;
        }

        s[ j ] = str[ i ] ;
        j -- ;
    }

    s[ len / 3 + len ] = 0 ;
                    ::wxLogDebug( wxT("Comma_ed_Str( <%s>, %d ) --><%s>"), str, interval, s );

    return( wxString(s) );
}

//*****************************************************************************
//
//*****************************************************************************

int
Decimal_Digits_Len( unsigned int UNIT_NUM )
{
    int i ;
    unsigned int x = UNIT_NUM - 1 ;

    for( i = 0 ; ; i ++, x /= 10 )
        if( x <= 0 )  break ;

    return( i ) ;
}

//*****************************************************************************
//1024 i J}؂
//*****************************************************************************

wxString
ULL_2_1000_Decimal( const wxULongLong & x0 )
{
    unsigned int UNIT_NUM = 1000;

    if( x0 == wxULL(0) )
    {
        return( wxT("0") ) ;
    }

///    int len ;
    wxULongLong  x ;
    wxString  s, s1 ;

    for( x = x0 ; x > UNIT_NUM ; x /= UNIT_NUM )
    {
        s1 = wxString::Format( wxT("%03ld"), (x % UNIT_NUM).ToULong() ) ;
        s  = s1 + wxT(",") + s ;
    }

    if( x >= 0 )
    {
        s1 = wxString::Format( wxT("%ld"),  (x % UNIT_NUM).ToULong() ) ;
        s  = s1 + wxT(",") + s ;
    }

///    len = s.Len() ;

    s.Truncate( s.Len() - 1 ) ;
                    //::wxLogDebug( wxT("ULL_2_Comma_ed_Digits(%f) --> <%s>"), x0.ToDouble(), s );
    return( s ) ;
}

//*****************************************************************************
//1024 i J}؂
//*****************************************************************************

wxString
ULL_2_Comma_ed_Digits( const wxULongLong & x0, unsigned int UNIT_NUM )
{
    static wxChar * fmat_L[] = { wxT("%01ld"), wxT("%02ld"), wxT("%03ld"), wxT("%04ld") };

    if( x0 == wxULL(0) )
    {
        return( wxT("0") ) ;
    }

///    int len ;
    wxULongLong  x ;
    wxString  s, s1 ;
    int  k = Decimal_Digits_Len( UNIT_NUM ) ;

    wxChar * fmt = fmat_L[ k ] ;

    for( x = x0 ; x > UNIT_NUM ; x /= UNIT_NUM )
    {
        s1 = wxString::Format( fmt, (x % UNIT_NUM).ToULong() ) ;
        s  = s1 + wxT(",") + s ;
    }

    if( x >= 0 )
    {
        s1 = wxString::Format( wxT("%ld"),  (x % UNIT_NUM).ToULong() ) ;
        s  = s1 + wxT(",") + s ;
    }

///    len = s.Len() ;

    s.Truncate( s.Len() - 1 ) ;
                    ::wxLogDebug( wxT("ULL_2_Comma_ed_Digits(%f) --> <%s>"), x0.ToDouble(), s );
    return( s ) ;
}

//*****************************************************************************
// StrToken_Breaker()
//*****************************************************************************
static 
wxString * 
Close_Token( int max_Tokns, const wxString tokens_L[], int * cnt_Tokns, int * len_Tkn )
{
    static wxString d_token ;
    wxString * pStr ;

    if( *len_Tkn > 0 )
    {
        (*cnt_Tokns) ++ ;
        (*len_Tkn) = 0 ;
    }

    if( *cnt_Tokns < max_Tokns )
        pStr = (wxString *) & tokens_L[ *cnt_Tokns ] ;
    else
        pStr = & d_token  ;

    pStr->Empty() ;

    return( pStr );
}

//*****************************************************************************
// StrToken_Breaker()
//             str= "abc[ xy 1 ], q , (123{ xy z} pq) <>;"
//             delims = ",;"
//   ̎Atoken_L[] = { "abc", " xy 1 ", "," , "q", "123{ xy z} pq)", ";", "" }
//         tkTyp_L[] = {   0  ,    3    ,  0  ,  0 ,    1            ,  0 , 4 }
//
//*****************************************************************************

int
StrToken_Breaker
( 
    const wxString & str,      //͕
    const wxChar     delims[], //؂蕶Ƃēʈuv̏WB
                               //ǂꂩ1̕ƁA؂ƂA
                               //̕1token Ƃ݂Ȃ
                               //blank-char(p/Sp ) ́Adefault ̋؂蕶ł
    int      max_Tokens,
    wxString token_L[],        //<out> ꂽtokeni[
    INT_8    tkTyp_L[]         //<out> ꂽtoken ʓȂA̎ʂ 
                               //      () --> 1, {} --> 2, [] --> 3, <> --> 4
)
{
    static  wxChar BRACKET_S[] = wxT("({[<");
    static  wxChar BRACKET_E[] = wxT(")}]>");
    INT_8    tk_Typ_Z[ 128 ];
    INT_8  * pTk_Typ  ;

    wxString d_token ;
    size_t   len, ii ;
    short    i, j ;
    int      len_Tkn ;
    int      cnt_Tokns ;
    wxString * tokn ;
    wxChar     c ;
    INT_8      k_Bracket ;

    pTk_Typ = tkTyp_L ;
    if( pTk_Typ == 0 )
        pTk_Typ = tk_Typ_Z ;

    cnt_Tokns = 0 ;
    k_Bracket = 0 ;

    tokn      = & token_L[ cnt_Tokns ] ;
    tokn->Empty() ;

    len_Tkn = 0 ;
    len = str.Length() ;

    for( ii = 0 ; ii < len ; ii ++ )
    {
        c = str[ii] ;
                    //::wxLogDebug( wxT("str[%d]= %02X,  typ_Tokn[%d]=%d"), ii, (unsigned)c, cnt_Tokns, (int)pTk_Typ[cnt_Tokns] );

        if( k_Bracket == 0 )
        {      //bracket ̒ɂȂ 
            if( ( 0 <= c && c <= wxT(' ') )  ||  c == wxT('@') )
            {       //c A䕶   ̎ --> 
                pTk_Typ[ cnt_Tokns ] = 0 ;//܂łtokn 

                tokn = Close_Token( max_Tokens, token_L, & cnt_Tokns, & len_Tkn ) ;
                continue ;
            }

            // c  ʕǂׂ
            for( i = 0 ; BRACKET_S[ i ] ; i ++ )
            {
                if( c == BRACKET_S[ i ] )
                {        //c  ʕ̎n܂蕶ł
                    k_Bracket = i + 1 ;//ʕ̎ʂL
                    break ;
                }
            }

            if( k_Bracket )
            {       //c Aʂ̎n܂蕶 Ƃ
                pTk_Typ[ cnt_Tokns ] = 0 ;
                tokn = Close_Token( max_Tokens, token_L, & cnt_Tokns, & len_Tkn ) ;
                continue ;
            }

            //c A؂蕶ǂׂ
            for( j = 0 ; delims[j] ; j ++ )
            {      
                if( c == delims[j] )  break ;
            }

            if( c == delims[j] ) 
            {        //c ́A؂蕶
                pTk_Typ[ cnt_Tokns ] = 0 ;//܂łtokn 

                tokn = Close_Token( max_Tokens, token_L, & cnt_Tokns, & len_Tkn ) ;

                tokn->Append( c ) ;
                len_Tkn ++ ;

                pTk_Typ[ cnt_Tokns ] = 0 ;
                tokn = Close_Token( max_Tokens, token_L, & cnt_Tokns, & len_Tkn ) ;

                continue ;
            }
            //  ȏ̑̕ꍇAtoknɘA镶ł
            //݂ tokn ɒǉ
            tokn->Append( c ) ;

            len_Tkn ++ ;
        }
        else
        {     //ʂ̒ɂ
            if( c == BRACKET_E[ k_Bracket - 1 ] )
            {          //c  ݂̊ʂ ʕł--> tokn 𐶐
                pTk_Typ[ cnt_Tokns ] = k_Bracket ;

                cnt_Tokns ++ ;
                len_Tkn = 0 ;
                if( cnt_Tokns < max_Tokens )
                    tokn = & token_L[ cnt_Tokns ] ;
                else
                    tokn = & d_token ;

                tokn->Empty() ;
            }
            else
            {
                tokn->Append( c ) ;

                len_Tkn ++ ;
            }
        }
    }

    if( len_Tkn > 0 )
    {
        pTk_Typ[ cnt_Tokns ] = k_Bracket ;

        cnt_Tokns ++ ;
    }
            //::wxLogDebug( wxT("StrToken_Breaker()  exit:") );
            //for( i = 0 ; i < cnt_Tokns ; i ++ ) ::wxLogDebug( wxT("%d[%s]: %d"), i, token_L[i], (int)pTk_Typ[i] );
    return( cnt_Tokns );
}

//*****************************************************************************
//
//*****************************************************************************

wxString
Str_Trim_X( const wxString & a )
{
    wxChar c ;
    size_t  len, i;

    wxString aw ;
    len = a.Length() ;

    for( i = 0 ; i < len ; i ++ )
    {
        c = a[i] ;
        if( 0 <= c && c <= wxT(' ')  )  continue ;
        if( c == wxT('@') )  continue ;

        aw.Append( c );
    }

        ::wxLogDebug( wxT("a= [%s] [%s]"), a, aw );

    return( aw ) ;
}

//*****************************************************************************
//
//*****************************************************************************
//Subtract_String() Ŏgp}N
//    
#define NEXT_STATUS( ii_Patn, status, c_Patn, nxt_Patn ) \
    c_Patn   = pattern[ ii_Patn ];       /*pattern ̍̕*/ \
    nxt_Patn = pattern[ ii_Patn + 1 ];   /*pattern ̎̕*/ \
                                         /* status ߂*/ \
    status = 1 ; \
    if( c_Patn == C_SPACE ) \
        status = 2 ;                      /*space ̑҂*/ \
    else if( c_Patn == subt_Symb ) \
        status = 3 ;                      /*op^ ̏*/ \
    len_tkn = 0 ; 

//*****************************************************************************
//  ߂l  >= 0
//*****************************************************************************

int
Subtract_String
( 
    const wxString & text_in, 
    wxChar   subt_Symb,       //subtract-symbol///op^
    const wxString & pattern_0,  //may include 'subt_Symb'
    int      max_tokns,
    wxString tokns_L[],       //output
    int * cnt_Parsed          //output
)
{
    wxChar  c_in ;
    wxChar  c_Patn    ;//݂̃p^

    int    status ; // ݂̏
                    //= 3 : op^̏
                    //= 2 : Xy[X}b`̏
                    //= 1 : i}b`̏

    int    i, ii, ii_Patn, len_tkn, cnt_tokns ;
    int    len_Text_in, len_Pattern ;
    wxChar prv, nxt_Patn ;
    wxChar pattern[256] ;
    wxChar tkn[ 256 ];

    wxChar C_SPACE = wxT(' ');
    wxChar C_NULL = wxT('\0');

    len_Text_in = text_in.Len() ;
    len_Pattern = pattern_0.Len() ;

    cnt_tokns = 0 ;

            //::wxLogDebug( wxT("Subtract_String: text_in= <%s>\n   subt_Symb=$%02X,  pattern=<%s>"), (const wxChar *)text_in, (int)subt_Symb, (const wxChar *)pattern_0 );

  //={ start /pattern ̓KB op^̘AA󔒂̘A苎 --> pattern[]
    prv = wxT('\0');
    ii  = 0 ;
    for( i = 0 ; i < len_Pattern ; i ++ )
    {
        c_in = pattern_0.GetChar( i ) ;

        if( c_in == subt_Symb )
        {
            if( prv == subt_Symb )  continue ;
        }
        else if( c_in == C_SPACE )
        {
            if( prv == C_SPACE )  continue ;
        }

        pattern[ ii ] = c_in ;
        ii ++ ;
        prv = c_in ;
    }

    pattern[ ii ] = wxT('\0');
    len_Pattern   = ii ;
                // ::wxLogDebug( wxT("Subtract_String: pattern=<%s>"), (const wxChar *)wxString( pattern ) );
  //}= end /pattern ̓K

    c_Patn = pattern[ 0 ] ;

    ii_Patn = 0 ;

    NEXT_STATUS( ii_Patn, status, c_Patn, nxt_Patn );
    if( c_Patn == C_NULL )      goto  EXIT ;

    nxt_Patn = pattern[ ii_Patn + 1 ] ;

    for( ii = 0 ; ii < len_Text_in ; )
    {
        c_in = text_in.GetChar( ii ) ;
              // ::wxLogDebug( wxT("Subtract_String: c_in[%d]=<%c>$%02X, patn[%d]= $%02X, $%02X"), 
              //                      ii, (int) c_in, (int) c_in, ii_Patn, (int) c_Patn, (int)nxt_Patn );

        if( status == 3 )
        {            //݂ patn  ϐsymbol(%)ł
            //ϐsymbol̎patterno 

            if( c_in == nxt_Patn )
            {      //ϐsymbol̎̕ɈvĂ
                             //::wxLogDebug( wxT("100 : SUBTRACT-mode end")  );
                tkn[ len_tkn ] = wxT('\0') ;
                if( cnt_tokns < max_tokns )
                {
                    tokns_L[ cnt_tokns ] = tkn  ;
                }
                cnt_tokns ++ ;

                ii_Patn ++ ;

                NEXT_STATUS( ii_Patn, status, c_Patn, nxt_Patn );
                if( c_Patn == C_NULL )      goto  EXIT ;
            }
            else
            {      //ϐsymbol̎̕ɈvȂ̂ŁA̕(c_in)L
                            //::wxLogDebug( wxT("110  SUBTRACT-mode continue") );
                tkn[ len_tkn ] = c_in ;
                len_tkn ++ ;
                ii ++ ;
            }
        }
        else if( status == 2 )
        {       //݂ status  SPACEł
                //::wxLogDebug( wxT("200 : SPACE state") );
            if( c_in == C_SPACE )
            {       //::wxLogDebug( wxT("210 : SPACE state:  c_in is space") );
                ii ++ ;
                len_tkn ++ ;
                continue ;
            }

            //c_in  space łȂ
                    //::wxLogDebug( wxT("210 : c_in is not space") );
//            if( len_tkn <= 0 )          goto  EXIT ;//space 1\Ȃ( 1ȏspace mode)
            ii_Patn ++ ;

            NEXT_STATUS( ii_Patn, status, c_Patn, nxt_Patn );
            if( c_Patn == C_NULL )      goto  EXIT ;
        }
        else
        {       //other patn-char. strict matching
                        //::wxLogDebug( wxT("300 : strict matching") );
            if( c_in != c_Patn )            goto  EXIT ;
 
                    //::wxLogDebug( wxT("310 : strictly matched") );
            ii ++ ;
            ii_Patn ++ ;
            NEXT_STATUS( ii_Patn, status, c_Patn, nxt_Patn );
            if( c_Patn == C_NULL )          goto  EXIT ;
        }         
    }

 EXIT :

    if( len_tkn > 0 )
    {
        tkn[ len_tkn ] = wxT('\0') ;
        if( cnt_tokns < max_tokns )
        {
            tokns_L[ cnt_tokns ] = wxString( tkn ) ;
        }
        cnt_tokns ++ ;
    }

    if( cnt_Parsed )
        * cnt_Parsed = ii ;

        //::wxLogDebug( wxT("Subtract_String:End: cnt_tokns=%d, ii=%d : <%s>, <%s>, <%s>"), 
        //                    cnt_tokns, ii, (const wxChar *)tokns_L[0], (const wxChar *)tokns_L[1], (const wxChar *)tokns_L[2]);
    return( cnt_tokns ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
Residual_Str_UnMatched
(
    const wxString & test_Str, //in>  may contain 'base_Str'
    const wxString & base_Str, //in
    wxString * residual
)
{
    int  i ;
    int len_B = base_Str.Len() ;
    int len   = test_Str.Len() ;

    for( i = 0 ; i < len_B ; i ++ )
    {
        if( i >= len )   break ;
        if( base_Str[ i ] != test_Str[ i ] ) break ;
    }

    if( i <= len )
        *residual = test_Str( i, len ) ;

            ::wxLogDebug( wxT("Residual_Str_UnMatched() ret=%d, base=<%s> \n test=<%s>, \n  res=<%s> //"),
                                i - len_B, base_Str.c_str(), test_Str.c_str(), residual->c_str() );
    return( i - len_B ) ;
}

#if 0 //090629  --> MyCommon_Win.cpp
//*****************************************************************************
//  00 ; Update-time, size  
//  11 : destination Â
//  10 ; source Â
//  01 : Update-time Asize قȂ
// 100 : source       File ݂Ȃ
// 101 : destination  File ݂Ȃ
//  -1 : source  File̎Asize ȂA
//  -2 : destination  File̎Asize ȂA
//*****************************************************************************

//int
//File_Compare_TStamp
//(
//    const wxString & path_Src,
//    const wxString & path_Dst,
//    time_t           dead_band   //dead_band for modification-time comparing
//                                 //   >= 0: [second]
//)
//{
    wxDateTime  time_Src, time_Dst ;
    wxULongLong size_Src, size_Dst ;

    wxFileName wFN_Src( path_Src );
    wxFileName wFN_Dst( path_Dst );

    if( ! wFN_Src.FileExists() )  return( 100 ) ;
    if( ! wFN_Dst.FileExists() )  return( 101 ) ;

    if( ! wFN_Src.GetTimes( 0, & time_Src, 0 ) )  return( -1 ) ;

    if( ! wFN_Dst.GetTimes( 0, & time_Dst, 0 ) )  return( -2 ) ;

    size_Src = wFN_Src.GetSize() ;
    if( size_Src == wxInvalidSize )    return( -1 ) ;

    size_Dst = wFN_Dst.GetSize() ;
    if( size_Dst == wxInvalidSize )    return( -2 ) ;

    wxDateTime  dead_band_m ( dead_band ) ;

    if( time_Src > time_Dst + dead_band_m )   return( 11 ) ;
    if( time_Src < time_Dst - dead_band_m )   return( 10 ) ;
    if( size_Src != size_Dst )         return( 01 ) ;

    return( 00 ) ;
//}
#endif  //090629

