#include  "wx/wx.h"
#include  "wx/cursor.h"
#include  "wx/event.h"
#include  "wx/thread.h"
#include  "Proc_Space.h"

class  TopFRAME ;
class  DualTreeCtl_NODE ;
class  wxString ;
class  DualTree_CTL ;

//*****************************************************************************
//
//*****************************************************************************

class MyThreadEVENT : public wxCommandEvent
{
  public :

    int       m_Which ;
    wxString  m_Path_Str_Org ;

    MyThreadEVENT( int id ) ;
    wxEvent * Clone(void) const ;
};

//*****************************************************************************
//
//*****************************************************************************

class MyThread_BASE : public wxThread, public Proc_SPACE
{
  public :
    static  const int  T_LoadTree, T_DiffChek, T_Backup, T_Delete ;

    int       m_Type  ; //= 1 : LoadTree,  2 : Diff_Chk, 3 : Backup
//    TopFRAME * m_Frame ;
//    short     m_GoOn_Flag  ;//<> 0 ̎̂݁As: Check_Diff, ܂ Backup  

    MyThread_BASE( int type, const TopFRAME * frame ) ;

};

//*****************************************************************************
//
//*****************************************************************************

class LoadTree_THREAD : public MyThread_BASE
{
  public :

    DualTreeCtl_NODE * m_pNod_Root ;
    wxString       m_Path_Str_Org ;

  public :

    LoadTree_THREAD( const TopFRAME * frame, 
             DualTreeCtl_NODE * pMother,
             int   which );
    ExitCode Entry() ;
};

//*****************************************************************************
//
//*****************************************************************************

class Diff_Chk_THREAD : public MyThread_BASE
{
  public :

    DualTreeCtl_NODE * m_pNod_Root ;

  public :

    Diff_Chk_THREAD( const TopFRAME * frame, 
             const DualTreeCtl_NODE * pNod_Mother );
    ExitCode Entry() ;
};

//*****************************************************************************
//
//*****************************************************************************

class Backup_THREAD : public MyThread_BASE
{
  protected :

    size_t       m_MaxSiz_IO_Buff ;//file copy p buffer-size
    char       * m_IO_Buff ;  //file copy p buffer

  public :

    Backup_THREAD( const TopFRAME * frame );

    ExitCode Entry() ;

    int  Copy_Children_in_DTree( const DualTreeCtl_NODE * pMother,
                     const wxString & srcFoldr_Path,   //source  Folder path
                     const wxString & dstFoldr_Path    //destination  Folder path. (݂͑邱)
                   ) ;   //  Apath ̍Ō '/' 鎖
    int  Copy_Children_On_Media( const wxString & srcFoldr_Path,  //source  Folder path
                     const wxString & dstFoldr_Path   //destination  Folder path
                   );                 //  Apath ̍Ō '/' 鎖
    int  Copy_Fle( const wxString & fullPath_Src, 
               const wxString & fullPath_Dst ) ;
};

//*****************************************************************************
//  destination folder  ̍ڂ폜
//*****************************************************************************

class DelFiles_THREAD : public MyThread_BASE
{
    DualTreeCtl_NODE * m_pNod_Root ;
    short              m_Del_Folder_F ;//force to delete completely
    short              m_Del_ReadOnly ;//force to delete completely

  public :

    DelFiles_THREAD( const TopFRAME * frame,
                     const DualTreeCtl_NODE * pNod_Root,
                     int   flag_Delete[]
                   );

    ExitCode Entry() ;

    long  Delete_Child_Files( DualTreeCtl_NODE * pMother ) ;  
    long  Delete_Child_Folders( DualTreeCtl_NODE * pMother );
    long  Delete_Folder_Forcedly( const wxString & folder_Mother_Path );
};

//*****************************************************************************

enum
{
    thread_Evt_LoadTree_Finished  = 1,
    thread_Evt_Backup_Finished,
    thread_Evt_Chk_Diff_Finished,
    thread_Evt_Delete_Finished,
    thread_Evt_Refresh_Tree,
    thread_Evt_Logging
};
