#include  <wx/log.h>
#include  "My_Dir.h"

//*****************************************************************************
//
//*****************************************************************************

My_DIR::My_DIR()
        : wxDir()
{
}

//*****************************************************************************
//
//*****************************************************************************

My_DIR::My_DIR( const wxString & dir )
        : wxDir( dir )
{
}

//*****************************************************************************
//
//*****************************************************************************

size_t 
My_DIR::Enumerate
( 
    My_DirEnumerator & sink, 
    const wxString & fileSpec, 
    int flags 
)
{
    wxString  fname ;
    bool    b_HasChild ;
    size_t  cnt ;
    int     ret ;
            //::wxLogDebug( wxT("My_DIR::Enumerate(%s)"), fileSpec );

    b_HasChild = GetFirst( & fname, fileSpec, wxDIR_DIRS | (flags & wxDIR_HIDDEN ) ) ; //get folders

    for( cnt = 0 ; ; b_HasChild = GetNext( & fname ), cnt ++ )
    {
        if( ! b_HasChild )  break ;

        ret = sink.OnDir( fname ) ;
            //::wxLogDebug( wxT("     --> My_DIR::Enumerate() <DIR>: cnt= %d, ret=%d, fname= %s"), cnt, ret, fname );

        if( ret ) break ;
    }

    b_HasChild = GetFirst( & fname, fileSpec, wxDIR_FILES | (flags & wxDIR_HIDDEN ) ) ; //get files

    for( ; ; b_HasChild = GetNext( & fname ), cnt ++ )
    {
        if( ! b_HasChild )  break ;

        ret = sink.OnFile( fname ) ;
            //::wxLogDebug( wxT("     --> My_DIR::Enumerate() <FILE>: cnt= %d, ret=%d, fname= %s"), cnt, ret, fname );

        if( ret ) break ;
            //::wxLogDebug( wxT("     --> Load_Children(): cnt= %d, b_IsDir=%d, fname= %s, path= %s"), cnt, b_IsDir, fname.c_str(), wFnam.GetFullPath().c_str() );
    }
            //::wxLogDebug( wxT("My_DIR::Enumerate()  end" ) );

    return( cnt ) ;
}

