#include <wx/wx.h>
#include <wx/tipwin.h>
#include <wx/app.h>
#include <wx/filename.h>
#include <wx/dir.h>
#include <wx/dnd.h>
#include "Path_String_Ctl.h"

BEGIN_EVENT_TABLE( Path_String_CTL, wxWindow )
    EVT_MOTION( Path_String_CTL::OnMouseMotion )
    EVT_ENTER_WINDOW( Path_String_CTL::OnMouseEnter )
    EVT_LEAVE_WINDOW( Path_String_CTL::OnMouseLeave )
    EVT_LEFT_DOWN( Path_String_CTL::OnLMouseDown )
    EVT_PAINT( Path_String_CTL::OnPaint )
    EVT_TIMER( wxID_ANY, Path_String_CTL::OnTimerEvent )
    EVT_SIZE( Path_String_CTL::OnSize )
END_EVENT_TABLE()

//*****************************************************************************

///const wxEventType   Path_String_CTL::EVTYP_Folder_Specify = wxNewEventType() ;
const short Path_String_CTL::OPTION_RightAlign = 0x01 ;

///%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
///%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

class DnDFile : public wxFileDropTarget
{
  public:
    DnDFile(Path_String_CTL *pOwner) { m_pOwner = pOwner; }

    virtual bool OnDropFiles(wxCoord x, wxCoord y,
                             const wxArrayString & filenames );

  private:
    Path_String_CTL * m_pOwner;
};

//*****************************************************************************
//
//*****************************************************************************

//virtual 
bool 
DnDFile::OnDropFiles
(
    wxCoord WXUNUSED(x), wxCoord WXUNUSED(y),
    const wxArrayString & filenames 
)
{
    extern wxChar  RC_ErrM_FolderNotExists[] ;
    extern wxChar  RC_MainWin_Title[] ;
    extern wxChar* RCL_Guide_Word_Root_Setting[] ;

    size_t nFiles = filenames.GetCount();
//    wxChar * s ;
    bool   bRet ;

    if( nFiles < 1 )  return( true ) ;

    wxFileName  fPath( wxString( filenames[0] ) + wxT("/") ) ;
    bRet = fPath.DirExists() ;
                ::wxLogDebug( wxT("DnDFile::OnDropFiles() : bRet=%d, which=%d, path=<%s>"), bRet, m_pOwner->m_Which, fPath.GetFullPath() ) ;

///   Error message ͏oȂ. wxMessageBox() ͎gȂ
///   if( ! bRet )    
///    {            //Folder łȂڂdrag ꂽ
///        wxString  caption = wxString( RC_MainWin_Title ) + wxT(" : ") + 
///                            wxString( RCL_Guide_Word_Root_Setting[ m_pOwner->m_Which ] ) ;
///        ::wxMessageBox( wxString::Format( RC_ErrM_FolderNotExists, fPath.GetFullPath() ),
///                        caption, wxOK, m_pOwner->GetParent() ) ;
///        return( true ) ;
///    }

    m_pOwner->m_Path_String = fPath.GetFullPath() ;
    m_pOwner->Refresh() ;

    wxCommandEvent event( wxEVT_COMMAND_TEXT_ENTER, m_pOwner->GetId() );

    event.SetInt( m_pOwner->m_Which ) ;
    event.SetString( filenames[0] ) ;

    ::wxPostEvent( m_pOwner->GetParent(), event );

    return( true ) ;
}


//*****************************************************************************
//
//*****************************************************************************

Path_String_CTL::Path_String_CTL
(
    wxWindow * parent,
    int        wid,
    int        which,
    const wxString & str,
    const wxString & tipSTr
)  : wxWindow( parent, wid,
               wxDefaultPosition, wxDefaultSize,
               wxBORDER_RAISED )
{
///    m_Which = which ;
//    wxFont  font( 8, wxFONTFAMILY_MODERN, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_BOLD );
    wxFont  font( 8, wxFONTFAMILY_MODERN, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL );

    m_Which  = which ;
    m_Option = 0 ;
    SetFont( font ) ;
///    GetFont().SetPointSize( 8 ) ;
///    GetFont().SetWeight( wxFONTWEIGHT_BOLD ) ;
    m_MM_Timer.SetOwner( this, wxID_ANY ) ;
    m_Path_String = str ;
    m_TipStr_C = tipSTr ;
    m_TipWin = 0 ;

    SetDropTarget( new DnDFile( this ) );
}

//*****************************************************************************
//
//*****************************************************************************

int
Path_String_CTL::Set_PathStr
(
    const wxString & path_str
)
{
    m_Path_String = path_str ;
    Refresh() ;
    return( 0 );
}

//*****************************************************************************
//
//*****************************************************************************

void
Path_String_CTL::OnPaint
(
    wxPaintEvent & WXUNUSED( event ) 
)
{
        int  x, w, h, w_Box, h_Box ;
        wxString path ;

    wxPaintDC dc( this );
 
///    PrepareDC( dc );
    dc.Clear();
    dc.SetFont( GetFont() );

    path = wxFileName( m_Path_String + wxT("/") ).GetFullPath() ;

    x = 0 ;
    if( m_Option & OPTION_RightAlign )
    {
        GetClientSize( & w_Box, & h_Box ) ;
        dc.GetTextExtent( path, & w, & h ) ;
        x = w_Box - w - 2 ;
    }
        //::wxLogDebug( wxT("Path_String_CTL::OnPaint() m_Option= $%hX, x= %d"), m_Option, x );

    dc.DrawText( path, x, 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

void
Path_String_CTL::OnMouseMotion
(
    wxMouseEvent & event
)
{
    wxPoint pos = event.GetPosition() ;
    int  w, h, mp;

    GetClientSize( &w, &h ) ;
    mp = 1 ;
    if( pos.x < w/4 ) mp = 2 ;
    if( pos.x > w * 3/4 ) mp = 3 ;
   
        //::wxLogDebug( "Path_String_CTL::OnMouseMotion %d,%d, mp=%d(%d)", pos.x, pos.y, mp, m_Mouse_Pos );

    if( mp == m_Mouse_Pos )  return ;

    m_Mouse_Pos = mp ;

    if( m_MM_Timer.IsRunning() )
        m_MM_Timer.Stop() ;

    if( m_TipWin )
    {
        delete m_TipWin ;
        m_TipWin = 0 ;
    }

    m_MM_Timer.Start( 500, true ) ;//one time timer
}

//*****************************************************************************
//
//*****************************************************************************

void
Path_String_CTL::OnLMouseDown
(
    wxMouseEvent & event
)
{
    wxPoint pos = event.GetPosition() ;
    int  w, h;
    
    GetClientSize( &w, &h ) ;
    m_Mouse_Pos = 1 ;
    if( pos.x < w/4 ) m_Mouse_Pos = 2 ;
    if( pos.x > w * 3/4 ) m_Mouse_Pos = 3 ;

    if( m_TipWin )
    {
        delete m_TipWin ;
        m_TipWin = 0 ;
    }

    ::wxLogDebug( wxT("Path_String_CTL::OnLMouseDown %d,%d, m_Mouse_Pos=%d"), pos.x, pos.y, m_Mouse_Pos );

    if( m_Mouse_Pos == 1 )
    {
///        wxCommandEvent eventCustom( EVTYP_Folder_Specify, GetId() );
///        wxCommandEvent eventCustom( wxEVT_Folder_Specify, m_Which );
        wxCommandEvent event( wxEVT_COMMAND_BUTTON_CLICKED, GetId() );

        ::wxPostEvent( GetParent(), event );

        return ;
    }
    else if( m_Mouse_Pos == 2 )
    {
        m_Option = m_Option & ~OPTION_RightAlign ;
    }
    else if( m_Mouse_Pos == 3 )
    {
        m_Option = ( m_Option & ~OPTION_RightAlign ) | OPTION_RightAlign ;
    }
    else
    {
        return ;
    }

    Refresh() ;
}

//*****************************************************************************
//
//*****************************************************************************

void 
Path_String_CTL::OnTimerEvent( wxTimerEvent & WXUNUSED(event) )
{
///    static wxString Tip_String[2] = { wxT( "Specify Source Folder" ),
///                                      wxT( "Specify Destination Folder" ) };
    wxWindow * parent ;
//    bool stopTimer = false;
    wxString label ;
    int w, h, w_tip ;

    GetClientSize( &w, &h ) ;

    wxPoint pos( 0, h + 6 ) ;

    ::wxLogDebug( wxT("Path_String_CTL::OnTimerEvent: %d"), m_Mouse_Pos );

    if( m_TipWin )
    {
        delete m_TipWin ;
        m_TipWin = 0 ;
    }

    parent = GetParent() ;

    if( m_Mouse_Pos == 2 )
    {
        label = s_TipStr_L ;
    }
    else if( m_Mouse_Pos == 3 )
    {      //right-side
        label = s_TipStr_R ;
    }
    else
    {     //center
        label = m_TipStr_C ;
///        label = Tip_String[ m_Which ] ;

    }

    m_TipWin = new wxStaticText( parent, wxID_ANY, label, pos, wxDefaultSize, 
                                  wxST_NO_AUTORESIZE | wxBORDER_SIMPLE ) ;
//    m_TipWin->Hide() ;

    m_TipWin->GetSize( & w_tip, & h ) ;

    if( m_Mouse_Pos == 3 )
    {      //right-side
        pos.x = w - w_tip - 6 ;
    }
    else if( m_Mouse_Pos == 1 )
    {     //center
        pos.x = ( w - w_tip ) / 2  ; 
    }
        ::wxLogDebug( wxT("OnTimerEvent() : w= %d, w_tip= %d, pos.x= %d"), w, w_tip, pos.x ) ;
    pos = ClientToScreen( pos ) ;
    pos = parent->ScreenToClient( pos ) ;

        ::wxLogDebug( wxT("OnTimerEvent() : On Parent : pos.x= %d"), pos.x ) ;
    m_TipWin->Move( pos ) ;

    m_TipWin->Show() ;
}

//*****************************************************************************
//
//*****************************************************************************

void 
Path_String_CTL::OnMouseEnter( wxMouseEvent & WXUNUSED(event) )
{
    //::wxLogDebug( wxT("Path_String_CTL::OnMouseEnter") );
}

//*****************************************************************************
//
//*****************************************************************************

void 
Path_String_CTL::OnMouseLeave( wxMouseEvent & WXUNUSED(event) )
{
    //::wxLogDebug( wxT("Path_String_CTL::OnMouseLeave") );

    if( m_MM_Timer.IsRunning() )
        m_MM_Timer.Stop() ;

    if( m_TipWin )
    {
        delete m_TipWin ;
        m_TipWin = 0 ;
    }

    m_Mouse_Pos = 0 ;
}

//*****************************************************************************
//
//*****************************************************************************

void
Path_String_CTL::OnSize( wxSizeEvent & /*event*/ )
{
    Refresh() ;
}

