#include  <stdlib.h>
#include  <wx/wx.h>
//#include  <wx/folder_Mother.h>
#include  <wx/filename.h>
#include  <wx/file.h>
#include  <wx/filefn.h>
#include  <wx/dynarray.h>
#include  "MyThread.h"
#include  "TopFrame.h"

extern wxChar   RC_Log_Error[] ;
extern wxChar   RC_Log_Ok[] ;
extern wxChar   RC_ErrM_FolderNotExists[] ;

extern wxString Embed_Time_onCR( const wxString & msg ) ;

//*****************************************************************************
//
//*****************************************************************************

Proc_SPACE::Proc_SPACE()
{
    m_Frame = 0;
    m_Which = 0;
    m_GoOn_Flag = 0 ;
}

//*****************************************************************************
//
//*****************************************************************************

Proc_SPACE::Proc_SPACE( const TopFRAME * frame, int which )
{
    Set( frame, which ) ;
}

//*****************************************************************************
//
//*****************************************************************************
void
Proc_SPACE::Set( const TopFRAME * frame, int which )
{
    m_Frame = (TopFRAME *) frame ;
    m_Which = which ;
    m_GoOn_Flag = 1 ;
}

//#if 0 //090718/Load_Children
//#############################################################################
//
//#############################################################################

class Load_TRVRSR : public My_DirEnumerator
{
  public :

    Proc_SPACE       * m_pPrcSpace ;
    DualTreeCtl_NODE * m_pNod_Mother ;
    int                m_Result ;

  public :

    Load_TRVRSR( const Proc_SPACE       * m_pPrcSpace,
                 const DualTreeCtl_NODE * pNod_Mother );

    virtual int OnFile( const wxString & filename ) ;

    virtual int OnDir( const wxString & dirname ) ;
};

//*****************************************************************************
//
//*****************************************************************************
Load_TRVRSR::Load_TRVRSR
(
    const Proc_SPACE       * pPrcSpace,
    const DualTreeCtl_NODE * pNod_Mother
) 
{
    m_pPrcSpace   = (Proc_SPACE *) pPrcSpace ;
    m_pNod_Mother = (DualTreeCtl_NODE *) pNod_Mother ;
    m_Result      = 0 ;
};

//*****************************************************************************
//
//*****************************************************************************
//virtual 
int 
Load_TRVRSR::OnFile( const wxString & filename )
{
                //::wxLogDebug( wxT("Load_TRVRSR::OnFile( %s ) flg=%hd\n"), filename, m_pPrcSpace->m_GoOn_Flag ) ;
    int   ret ;

    if( m_pPrcSpace->m_GoOn_Flag == 0 )
    {
        m_Result = 2 ;
        return( 1 ) ;
    }

    DualTreeBASE_ITEM * pData_Child ;

    wxFileName fn( filename ) ;

    ret = m_pNod_Mother->Add_Child_Item( 0, m_pPrcSpace->m_Which, fn.GetFullName(), 
                                              (DualTreeBASE_ITEM **)& pData_Child ) ;
    if( ret < 0 )
    {
        m_Result |= (-ret) * 0x1000 ;
        return wxDIR_STOP ;
    }

    return( 0 );
}

//*****************************************************************************
//
//*****************************************************************************
//virtual 
int
Load_TRVRSR::OnDir( const wxString & dirname )
{
                //::wxLogDebug( wxT("Load_TRVRSR::OnDir( %s ) flg=%hd\n"), dirname, m_pPrcSpace->m_GoOn_Flag ) ;
    if( m_pPrcSpace->m_GoOn_Flag == 0 )
    {
        m_Result = 2 ;
        return( 1 ) ;
    }

    DualTreeCtl_NODE * pNode_Child ;
    int  ret, other ;

    wxFileName fn( dirname ) ;

    ret = m_pNod_Mother->Add_Child_Item( 1, m_pPrcSpace->m_Which, fn.GetFullName(), 
                                             (DualTreeBASE_ITEM **)& pNode_Child ) ;
    if( ret < 0 )
    {
        m_Result |= (-ret) * 0x1000 ;
        return( 1 ) ;
    }

    other = 1  - m_pPrcSpace->m_Which ;

    if( pNode_Child->m_State_Load_L[ other ] == 1 )
    {              //(side)Node ݂ĂāASLoad ς݂ȂAside Load ȂƂȂ
        Proc_SPACE  prc( m_pPrcSpace->m_Frame, other );

        ret = prc.Load_Children( pNode_Child );

        if( ret )
        {
            m_Result |= ret ;
        }
    }

    return( 0 );
}

//*****************************************************************************
//    wxTraverser using version 
//  result < 0  --> fatal error returned from Add_Child_Item()
//  result = 2  --> Quitted 
//  result = 1  --> directory not exists
//*****************************************************************************

int  
Proc_SPACE::Load_Children
(
    DualTreeCtl_NODE * pNod_Mother
)
{
    My_DIR  folder_Mother ;

    DualTreeCtl_NODE * pNod ;
    long   ii ;
    int    other, ret, result ;
    bool   bRet ;

    wxString  currFolder ;

    Load_TRVRSR travrsr( this, pNod_Mother ) ;

    result = 0 ;
             ::wxLogDebug( wxT("Load_Children( pMother= $%p ) Start: which=%d [%s]\n"), pNod_Mother, m_Which, pNod_Mother->m_Name_L[m_Which] );

   if( pNod_Mother->m_Is_Valid_L[ m_Which ] == 0 )  goto  ERR_NoDir ;

    currFolder = pNod_Mother->Get_Full_Path( m_Which ) ;
#if 0  //check-09072/speed tune up ׂ̈ check Ȃ
    bRet = ::wxDirExists( currFolder ) ;  // folder_Mother.Open() ̖߂l͂ĂɂȂȂ̂ŁAꂪKv
    if( ! bRet)                     goto  ERR_NoDir ;
#endif //check-09072/

    bRet = folder_Mother.Open( currFolder ) ; // currFolder ̍Ō '/' tȂƑʖ

            //::wxLogDebug( wxT("  Load_Children(): bRet=%d, currFolder= <%s>\n"), bRet, currFolder );
    if( ! bRet)                     goto  ERR_NoDir ;//wxWidget ͂check ͑SȎ

    folder_Mother.Enumerate( travrsr, wxT(""), wxDIR_DEFAULT ) ;//traverse no recursive

    if( travrsr.m_Result )
    {
        ret = travrsr.m_Result ;  goto  EXIT ;
    }

   //--- ŁA children  item ̐I

  //={ /200/ Expanded check
  //   JĂ Node item ΁AċAIɂ Load .
  //       Root  ĐݒɂċN肤

    other = 1 - m_Which ;

    for( ii = 0 ; ii < pNod_Mother->m_Count_Children ; ii ++ )
    {
        pNod = (DualTreeCtl_NODE *) pNod_Mother->Item_Ptr( ii ) ;

        if( ! pNod->Is_Node() )                  continue ;
                ::wxLogDebug( wxT("Load_Children: which=%d, stat=%d"), m_Which, (int)pNod->m_State_Load_L[other] );
        if( pNod->m_State_Load_L[other] != 1 )   continue ;//load ĂȂ

        // Node other-side load Ă̂ŁA Node ̎side  Load B
        ret = Load_Children( pNod ) ;
    }
  //}= /200

    ret = 0 ;

    pNod_Mother->m_State_Load_L[ m_Which ] = 1 ;//Load ς݂ł鎖\


    pNod_Mother->Shrink() ;

 EXIT :
             //::wxLogDebug( wxT("Load_Children() End: result= %d\n"), ret );
    return( ret ) ;

 ERR_NoDir :

    ret = 1 ;

    LogPut_Format( RC_ErrM_FolderNotExists, currFolder ) ;

    goto  EXIT ;
}

//#endif  //090718/Load_Children

#if 0  //090715/Load_Children

//*****************************************************************************
//  result < 0  --> fatal error returned from Add_Child_Node()
//  result = 2  --> Quitted 
//  result = 1  --> directory not exists
//*****************************************************************************

int  
Proc_SPACE::Load_Children
(
    DualTreeCtl_NODE * pNod_Mother
)
{
        DualTreeCtl_ITEM * pItem ;
        DualTreeCtl_NODE * pNode_Child ;
        DualTreeCtl_DATA * pData_Child ;
        wxString   fname,  fpath ;
        wxString   currFolder ; //full-path name of the current directory '/' Ōɂ
        bool    b_HasChild, b_IsDir, bRet;
        int     cnt, ret, other ;
        wxFileName wFnam  ;
        wxDir  folder_Mother ;

             ::wxLogDebug( wxT("\nLoad_Children( pMother= $%p ) Start: which=%d"), pNod_Mother, m_Which );

   if( pNod_Mother->m_Is_Valid_L[ m_Which ] == 0 )  goto  ERR_NoDir ;

    currFolder = pNod_Mother->Get_Full_Path( m_Which ) ;

    bRet = folder_Mother.Open( currFolder ) ; // currFolder ̍Ō '/' tȂƑʖ

            ::wxLogDebug( wxT("  Load_Children(): bRet=%d, currFolder= <%s>\n"), bRet, currFolder );
    if( ! bRet)                                     goto  ERR_NoDir ;

///    if( ! wFnam.DirExists() )       goto  ERR_NoDir ;

  //={ /100/ first check folders

    b_HasChild = folder_Mother.GetFirst( & fname, wxEmptyString, wxDIR_DIRS | wxDIR_HIDDEN ) ; //get folders

    for( cnt = 0 ; ; b_HasChild = folder_Mother.GetNext( & fname ), cnt ++ )
    {
        if( ! b_HasChild )  break ;

        if( m_GoOn_Flag == 0 )  goto  QUITTED ;
            //::wxLogDebug( wxT("     --> Load_Children(): cnt= %d, b_IsDir=%d, fname= %s, path= %s"), cnt, b_IsDir, fname.c_str(), wFnam.GetFullPath().c_str() );

        ret = pNod_Mother->Add_Child_Item( 1, m_Which, fname, (DualTreeBASE_ITEM **)& pNode_Child ) ;
        if( ret < 0 )  goto  ERR_EXIT ;

        other = 1  - m_Which ;

        if( pNode_Child->m_State_Load_L[ other ] == 1 )
        {              //(side)Node ݂ĂāALoad ς݂ȂAside Load ȂƂȂ
            Proc_SPACE  prc( m_Frame, other );

            ret = prc.Load_Children( pNode_Child );

            if( ret )   goto  EXIT ;
        }
    }

  //}=  /100/

  //={ /200/ next check files

    b_HasChild = folder_Mother.GetFirst( & fname, wxEmptyString, wxDIR_FILES | wxDIR_HIDDEN ) ; //get folders

    for( cnt = 0 ; ; b_HasChild = folder_Mother.GetNext( & fname ), cnt ++ )
    {
        if( ! b_HasChild )  break ;

        if( m_GoOn_Flag == 0 )  goto  QUITTED ;

            //::wxLogDebug( wxT("     --> Load_Children(): cnt= %d, b_IsDir=%d, fname= %s, path= %s"), cnt, b_IsDir, fname.c_str(), wFnam.GetFullPath().c_str() );

        ret = pNod_Mother->Add_Child_Item( 0, m_Which, fname, 
                                               (DualTreeBASE_ITEM **)& pData_Child ) ;
        if( ret < 0 )  goto  ERR_EXIT ;
    }

    ret = 0 ;

    pNod_Mother->m_State_Load_L[ m_Which ] = 1 ;

 EXIT :

    pNod_Mother->Shrink() ;

             ::wxLogDebug( wxT("Load_Children( pMother= $%p ) End:\n"), pNod_Mother );
    return( ret ) ;

QUITTED :

    ret = 2 ;
    goto  EXIT ;

ERR_NoDir :

    LogPut_Format( RC_ErrM_FolderNotExists, currFolder ) ;

    ret = 1 ;

ERR_EXIT :

    return( ret );
}

#endif  //090715/Load_Children

//*****************************************************************************
//
//*****************************************************************************

int
Proc_SPACE::LogPut_Msg
( 
    const wxString & msg
)  const
{
    wxCommandEvent event( TopFRAME::EVTYP_MyThread, thread_Evt_Logging );
    event.SetString( Embed_Time_onCR( msg ) ) ;

    ::wxPostEvent( m_Frame, event );
                ::wxLogDebug( wxT("LogPut_Msg() :msg=<%s>"), msg ) ;
    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
Proc_SPACE::LogPut_Format
( 
    const wxChar  format[],
    ...
)  const
{
        wxString  msg ;
        va_list   argPtr ;

    va_start( argPtr, format ) ;

    msg.PrintfV( format, argPtr ) ;

    LogPut_Msg( msg ) ;

    return( 0 ) ;
}


//*****************************************************************************
//
//*****************************************************************************

int
Proc_SPACE::LogPut_FileCopyBegin
( 
    const wxString & src_FullPath,
    const wxString & dst_FullPath 
)  const
{
    extern wxChar * RCL_Side_Symbol[] ;
    static wxChar form[] = wxT("\r%s[%s]\n          ===> %s[%s]") ;
    int  ret ;

    wxString  src_RelPath ;
    wxString  dst_RelPath ; 

    ret = m_Frame->m_DTreeCtrl->Relative_Path( src_FullPath, 0, & src_RelPath ) ;
    ret = m_Frame->m_DTreeCtrl->Relative_Path( dst_FullPath, 1, & dst_RelPath ) ;

    LogPut_Format( form, RCL_Side_Symbol[0], src_RelPath.Mid(1), 
                         RCL_Side_Symbol[1], dst_RelPath.Mid(1) ) ;

    return( 0 ) ;
}
