/////////////////////////////////////////////////////////////////////////////
// Name:        BackUp_Diff.cpp
/////////////////////////////////////////////////////////////////////////////

#define wxUSE_STREAMS 1

// For compilers that support precompilation, includes "wx/wx.h".
//#include "wx/wxprec.h"

//#ifdef __BORLANDC__
//    #pragma hdrstop
//#endif

//#ifndef WX_PRECOMP
    #include <wx/wx.h>
    #include <wx/log.h>
//#endif

///#include "wx/colordlg.h>
///#include "wx/numdlg.h>

#include  <time.h>
#include  <wx/gdicmn.h>
#include  <wx/icon.h>
#include  <wx/image.h>
///#include  <wx/imaglist.h>
//#include  <wx/treectrl.h>
#include  <wx/font.h>
#include  <wx/math.h>
#include  <wx/dirdlg.h>
#include  <wx/filedlg.h>
#include  <wx/dir.h>
#include  <wx/filename.h>
#include  <wx/txtstrm.h>
#include  <wx/wfstream.h>
#include  <wx/textfile.h>
#include  <wx/debug.h>
#include  <wx/stattext.h>
#include  <wx/event.h>
#include  <wx/strconv.h>
//#include  <wx/tokenzr.h>

#ifdef __WIN32__
    // this is not supported by native control
    #define NO_VARIABLE_HEIGHT
#endif

#include "TopFRAME.h"
#include "MyDirTraverser.h"
#include "MyThread.h"
#include "Backup_Diff.xpm"

#ifndef __WXMSW__
#endif

typedef  char INT_8 ;

extern int
StrToken_Breaker
( 
    const wxString & str, 
    const wxChar     delims[], 
    int      max_Tokens,
    wxString token_L[],
    INT_8    tkTyp_L[] = 0
) ;

#if 0

extern int Subtract_String
            ( 
                const wxString & text_in, 
                wxChar  subt_Symb,
                const wxString & pattern,
                int       max_tokns,
                wxString tokns_L[],         //output
                int     * cnt_Parsed        //output
            );
#endif


//extern wxChar   g_Recently_Used_Setting_List[] ;
extern wxChar    RC_TipStr_MenuBtn[] ;
extern wxBitmap  g_Bmp_CopyDirection ;
extern wxColour  g_Color_RootPath_BG ;


//*****************************************************************************
//
//*****************************************************************************

// My frame constructor
TopFRAME::TopFRAME(const wxString& title )
       : wxFrame((wxFrame *)NULL, wxID_ANY, title )
{
//    extern wxChar * RCL_Guide_Word_Root_Setting, RC_Help_Text[] ;
//    extern wxChar   RC_TipStr_RootDir_Specify[];

    m_X_Pos  = 10 ;
    m_Y_Pos  = 10 ;
    m_Width  = 600 ;
    m_Height = 400 ;
    m_Y_Splitter_Sash = 200 ;

///    wxMenuBar * menu_bar ;
    m_X_RootPath_Ctl = 18 ;
    m_H_RootPath_Ctl = 22 ;

    m_Rect_Root_Backup_Ind = wxRect( 0, 0, m_X_RootPath_Ctl, m_H_RootPath_Ctl ) ;
    m_Rect_Root_Backup_Ind.Inflate( -4, -4 ) ;

    SetBackgroundColour(wxColour(255, 255, 255));

///    m_MaxSiz_IO_Buff = 100000 ;
///    m_IO_Buff = new char[ m_MaxSiz_IO_Buff ] ;

    // Give it an icon
    wxIcon  icon( (const char**)Backup_Diff_xpm ) ;
    SetIcon( icon );

    m_Rect_HdView_Spcer = wxRect( 300, 0, 5, m_H_RootPath_Ctl * 2 - 1 ) ;
    m_X0_LMDown_Spcer   = -1 ;

    m_Cnt_Thread_Pend  = 0 ;
    m_Idx_Thread_Work  = -1 ;

    m_Opt_Auto_Backup = 0 ;

///    m_Diff_Check_Ind   = 1 ;
    m_MenuTip_Ctl      = 0 ;
}

/////extern int  Construct_Tree_Root( wxWindow *, DualTreeCtl_BODY &, int which ) ;

//*****************************************************************************
//
//*****************************************************************************

TopFRAME::~TopFRAME()
{
//    Save_SettingFile( m_Setting_FileName );

//    Add_Recently_Used_Setting_List( m_Setting_FileName ) ;

///    delete m_IO_Buff ;

    Save_Setting_Data() ;

#if wxUSE_LOG
    delete wxLog::SetActiveTarget(NULL);
#endif // wxUSE_LOG
}

//*****************************************************************************
//TopFRAME  GDI@child-windows  쐬
//  preferencefile input ĂAĂ΂B
//*****************************************************************************

// My frame constructor
TopFRAME::Build_GDI()
{
    extern wxChar * RCL_Guide_Word_Root_Setting[] ;
    extern wxChar   RC_TipStr_RootDir_Specify[] ;
    extern wxChar   RC_TipStr_MenuBtn[], RC_Help_Text[] ;
    extern wxChar   RC_TipStr_DiffChk[] ;

    wxString tip ;

    m_Font_Deflt = wxFont( 8, wxFONTFAMILY_MODERN, wxFONTSTYLE_NORMAL,
                                                   wxFONTWEIGHT_NORMAL ) ;    
    tip = wxString::Format( RC_TipStr_RootDir_Specify, 
                            RCL_Guide_Word_Root_Setting[0] );
    m_Src_RootPath_Ctl = new Path_String_CTL( this, ctrl_ID_Set_Root_S, 0, 
                                              RCL_Guide_Word_Root_Setting[0], tip );

    tip = wxString::Format( RC_TipStr_RootDir_Specify, 
                            RCL_Guide_Word_Root_Setting[1] );
    m_Dst_RootPath_Ctl = new Path_String_CTL( this, ctrl_ID_Set_Root_D, 1, 
                                              RCL_Guide_Word_Root_Setting[1], tip );

    m_Src_RootPath_Ctl->SetBackgroundColour( g_Color_RootPath_BG );
    m_Dst_RootPath_Ctl->SetBackgroundColour( g_Color_RootPath_BG );

    m_ArrowBtn    = new wxBitmapButton( this, ctrl_ID_Arrow, g_Bmp_CopyDirection ) ;

    m_SrcFileInfo = new File_Info_CTL( this, wxID_ANY ) ;
    m_DstFileInfo = new File_Info_CTL( this, wxID_ANY ) ;

    m_DiffChkBtn  = new wxCheckBox( this, ctrl_ID_DiffChk, wxT("") ) ;
    m_DiffChkBtn->SetValue( true ) ;

    m_SplitWin = new wxSplitterWindow( this );

    // create the controls

    m_textCtrl = new wxTextCtrl( m_SplitWin, wxID_ANY, RC_Help_Text,
                                wxDefaultPosition, wxDefaultSize,
                                wxTE_MULTILINE | wxSUNKEN_BORDER );
    m_textCtrl->SetFont( m_Font_Deflt ) ;

    m_DTreeCtrl = new DualTree_CTL( m_SplitWin, this );

    m_DTreeCtrl->SetWindowStyle( wxBORDER_RAISED );

    m_SplitWin->SplitHorizontally( m_DTreeCtrl, m_textCtrl, m_Y_Splitter_Sash ) ;
//    menu_bar->Check(TreeTest_ToggleImages, true);
    m_ArrowBtn->SetToolTip( RC_TipStr_MenuBtn ) ;
    m_DiffChkBtn->SetToolTip( RC_TipStr_DiffChk ) ;
///    CreateTreeWithDefStyle();

    // create a status bar
///    CreateStatusBar(2);

#if wxUSE_LOG
#ifdef __WXMOTIF__
    // For some reason, we get a memcpy crash in wxLogStream::DoLogStream
    // on gcc/wxMotif, if we use wxLogTextCtl. Maybe it's just gcc?
    delete wxLog::SetActiveTarget(new wxLogStderr);
#else
    // set our text control as the log target
//del/    wxLogTextCtrl *logWindow = new wxLogTextCtrl(m_textCtrl);
//    delete wxLog::SetActiveTarget(logWindow);
#endif
#endif // wxUSE_LOG

    return( 0 ) ;
}


//*****************************************************************************
//
//*****************************************************************************

int
TopFRAME::Is_Doing_Backup() const
{
    MyThread_BASE * pThread ;
    int  is_Backuping = 0 ;

    if( m_Idx_Thread_Work >= 0 )
    {
        pThread = m_Thread_L[ m_Idx_Thread_Work ];

        if( pThread->m_Type == MyThread_BASE::T_Backup )
            is_Backuping = 1 ;
    }

    return( is_Backuping );
}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::CreateTreeWithDefStyle()
{
#if 0
    long style = wxTR_DEFAULT_STYLE |
#ifndef NO_VARIABLE_HEIGHT
                 wxTR_HAS_VARIABLE_ROW_HEIGHT |
#endif
                 wxTR_EDIT_LABELS;

    CreateTree(style | wxSUNKEN_BORDER);

    // as we don't know what wxTR_DEFAULT_STYLE could contain, test for
    // everything
    wxMenuBar *mbar = GetMenuBar();
    mbar->Check(TreeTest_TogButtons, (style & wxTR_HAS_BUTTONS) != 0);
    mbar->Check(TreeTest_TogButtons, (style & wxTR_TWIST_BUTTONS) != 0);
    mbar->Check(TreeTest_TogLines, (style & wxTR_NO_LINES) == 0);
    mbar->Check(TreeTest_TogRootLines, (style & wxTR_LINES_AT_ROOT) != 0);
    mbar->Check(TreeTest_TogHideRoot, (style & wxTR_HIDE_ROOT) != 0);
    mbar->Check(TreeTest_TogEdit, (style & wxTR_EDIT_LABELS) != 0);
    mbar->Check(TreeTest_TogBorder, (style & wxTR_ROW_LINES) != 0);
    mbar->Check(TreeTest_TogFullHighlight, (style & wxTR_FULL_ROW_HIGHLIGHT) != 0);
#endif

    CreateTree( wxSUNKEN_BORDER );
}

//*****************************************************************************
//
//*****************************************************************************

int
TopFRAME::Max_Recent_Settings() const
{
    return( sizeof(m_Recent_Settings_L) / sizeof(m_Recent_Settings_L[0])
             - 1 );
}

//*****************************************************************************
//
//*****************************************************************************

int
TopFRAME::Max_Recent_Setting_Files() const
{
    return( sizeof(m_Recent_Setting_Files_L) / sizeof(m_Recent_Setting_Files_L[0])
             - 1 );
}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::CreateTree( long /*style*/ )
{
//    m_DTreeCtrl = new MyTreeCtrl( m_SplitWin, TreeTest_Ctrl,
//                                wxDefaultPosition, wxDefaultSize,
 //                               style);
    m_DTreeCtrl = new DualTree_CTL( m_SplitWin, this );

    Resize();
}

//*****************************************************************************
//
//*****************************************************************************
bool
TopFRAME::Should_Diff_Check()
{
    return( m_DiffChkBtn->GetValue() ) ;
}

//*****************************************************************************
//
//*****************************************************************************

bool
TopFRAME::Enable_Operations( bool flag )
{
    return( true ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
TopFRAME::Resize()
{
    int  w_Cli, h_Cli, ret, y ;

    GetClientSize( & w_Cli, & h_Cli );

    ret = Resize_HeadView() ;
    if( ret )  return( ret ) ;

    y = m_H_RootPath_Ctl * 2 ;
    m_SplitWin->SetSize( 0, y, w_Cli, h_Cli - y ) ;

    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

int
TopFRAME::Resize_HeadView()
{
    int  w_RootView ; //width
    int  h, xc, w ;
    int  w_Cli, h_Cli ;

    GetClientSize( & w_Cli, & h_Cli );

    if( w_Cli < 100 )   return( 1 ) ;

    w =  m_Rect_HdView_Spcer.GetRight() + 10 ;
    if( w > w_Cli )
       m_Rect_HdView_Spcer.Offset( w_Cli - w, 0 );

    w_RootView = m_Rect_HdView_Spcer.x - m_X_RootPath_Ctl ;

    h = m_Rect_HdView_Spcer.height / 2 ;
    xc = m_Rect_HdView_Spcer.GetRight() ;

    m_DiffChkBtn->SetSize( 0, 0, m_X_RootPath_Ctl, 20 ) ;
    m_ArrowBtn->SetSize( 0, h, m_X_RootPath_Ctl, 20 ) ;

    m_Src_RootPath_Ctl->SetSize( m_X_RootPath_Ctl, 0, w_RootView, h ) ;
    m_Dst_RootPath_Ctl->SetSize( m_X_RootPath_Ctl, h - 1, w_RootView, h ) ;
    w = w_Cli - xc ;

    m_SrcFileInfo->SetSize( xc, 0    , w, h ) ;
    m_DstFileInfo->SetSize( xc, h - 1, w, h ) ;

    return( 0 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::Select_RootFolder_OneSide
( 
    int which     // 0 or 1
)
{
    extern wxChar   RC_TipStr_RootDir_Specify[] ;
    extern wxChar * RCL_Guide_Word_Root_Setting[] ;
    int  ret ;
    wxString dirDef, str;

    dirDef = m_DTreeCtrl->m_pRoot_Node->m_Name_L[ which ] ;

    if( dirDef.IsEmpty() )
    {
//        wxGetHomeDir( & dirDef );// dialog̕\ɎԂ肷
        dirDef = wxFileName( wxT("/") ).GetFullPath() ;
    }
        ::wxLogDebug( wxT( "Select_RootFolder_OneSide( %d )" ), which ) ;

    str = wxString::Format( RC_TipStr_RootDir_Specify, 
                            RCL_Guide_Word_Root_Setting[ which ] );
    wxDirDialog dialog( this, str, dirDef, 
                          wxDD_DEFAULT_STYLE | wxDD_DIR_MUST_EXIST );
        ::wxLogDebug( wxT( "Select_RootFolder_OneSide()-10" ) ) ;

    ret = dialog.ShowModal() ;

        ::wxLogDebug( wxT("Select_RootFolder_OneSide :which=%d, ret= %d\n"), which, ret );

    if( ret != wxID_OK)  return ;

    //::wxLogMessage(_T("Selected path: %s"), dialog.GetPath().c_str());
    ret = Open_RootFolder_OneSide( dialog.GetPath(), which );

    Refresh() ;

    if( ret == 0 )
        KickOff_Diff_Check() ;//invoke diff_check thread  
}
