#include "wx/wx.h"
#include "TopFRAME.h"
#include "MyDirTraverser.h"
#include "Path_String_Ctl.h"

// verify that the item is ok and insult the user if it is not
#define CHECK_ITEM( item ) if ( !item.IsOk() ) {                                 \
                             wxMessageBox(wxT("Please select some item first!"), \
                                          wxT("Tree sample error"),              \
                                          wxOK | wxICON_EXCLAMATION,             \
                                          this);                                 \
                             return;                                             \
                           }

#define MENU_LINK(name) EVT_MENU(menu_ID_##name, TopFRAME::On##name)

BEGIN_EVENT_TABLE(TopFRAME, wxFrame)
///    EVT_COMMAND( 0, Path_String_CTL::EVTYP_Folder_Specify,
///                  TopFRAME::OnSelect_RootDir_A )
///    EVT_COMMAND( 1, Path_String_CTL::EVTYP_Folder_Specify,
///                  TopFRAME::OnSelect_RootDir_B )
    EVT_COMMAND( wxID_ANY, DualTree_CTL::EVTYP_Item_OnCursor,
                       TopFRAME::OnShow_FileInfo )
    EVT_COMMAND( wxID_ANY, TopFRAME::EVTYP_MyThread,
                       TopFRAME::OnEvent_Thread )
    EVT_COMMAND( wxID_ANY, wxEVT_COMMAND_TEXT_ENTER, TopFRAME::OnGet_RootPath ) 
    EVT_LEFT_DOWN( TopFRAME::OnLMouseDown )

    EVT_LEFT_UP( TopFRAME::OnLMouseUp )
    EVT_LEFT_DCLICK( TopFRAME::OnLDoubleClick )
    EVT_MOTION( TopFRAME::OnMouseMotion )
    EVT_LEAVE_WINDOW( TopFRAME::OnMouseLeave )

    EVT_PAINT( TopFRAME::OnPaint )

    MENU_LINK(Select_RootDir_S)
    MENU_LINK(Select_RootDir_D)

    EVT_IDLE(TopFRAME::OnIdle)
    EVT_SIZE(TopFRAME::OnSize)

///    EVT_COMMAND_RANGE( wxID_UP, wxID_DOWN, wxEVT_COMMAND_BUTTON_CLICKED, 
///                                 TopFRAME::OnButtonUp)
    EVT_BUTTON( ctrl_ID_Arrow, TopFRAME::OnShow_Menu )
    EVT_BUTTON( ctrl_ID_Set_Root_S, TopFRAME::OnSelect_RootDir_S )
    EVT_BUTTON( ctrl_ID_Set_Root_D, TopFRAME::OnSelect_RootDir_D )
    EVT_CHECKBOX( ctrl_ID_DiffChk, TopFRAME::OnToggle_Diff_Chk )
    MENU_LINK(About)
    MENU_LINK(Quit)
    MENU_LINK(HowToUse)
    MENU_LINK(Startup)
    MENU_LINK(Do_Backup)
    MENU_LINK(Quit_Thread)
    MENU_LINK(Select_RootDir_S)
    MENU_LINK(Select_RootDir_D)
    MENU_LINK(ReLoad_Tree)
    MENU_LINK(Reset_Tree)
//    MENU_LINK(Read_Recent_Set_Files)
    MENU_LINK(Read_Setting)
    MENU_LINK(Save_Setting)
    MENU_LINK(Del_Sel_Desti)
    MENU_LINK(Show_BackupOnly)
    MENU_LINK(Show_DestOnly_File)
    MENU_LINK(Logger)
    MENU_LINK(Logger_Copy)
    MENU_LINK(Logger_Record)
    MENU_LINK(Change_Sort_Order)
    MENU_LINK(BackUp_Check_All)
    MENU_LINK(BackUp_UnCheck_All)
    MENU_LINK(Set_Preference)
    MENU_LINK(Edit_Copy)
    MENU_LINK(Edit_SelAll)
    MENU_LINK(Edit_Erase)

#undef MENU_LINK

END_EVENT_TABLE()
