#include <wx/log.h>
#include <wx/app.h>
#include <wx/msgdlg.h>
#include <wx/cursor.h>
#include <wx/filename.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/filedlg.h>
#include "wx/menu.h"
#include "wx/aboutdlg.h"

#include "TopFRAME.h"
#include "MyThread.h"
#include "My_Menu.h"
#include "Dlg_Set_Preference.h"

//Menu Callbacks 

extern time_t    g_FileTime_DeadBand ;
extern bool      g_isCASE_SENSITIVE_FileName ;

extern wxChar   g_Setting_File_Type[] ;
extern wxChar   g_Recently_Used_Setting_List[] ;
extern wxChar * RCL_About[] ;
extern wxChar   RC_TipStr_MenuBtn[] ;

extern wxChar   g_HelpExec_Command[] ;

extern int Subtract_String
            ( 
                const wxString & text_in, 
                wxChar  subt_Symb,
                const wxString & pattern,
                int       max_tokns,
                wxString tokns_L[],         //output
                int     * cnt_Parsed        //output
            );

extern void Show_AboutDlg(  wxWindow * parent, 
                            int        wid,
                            const wxString & title,
                            const wxString & msg, int milliSec_Open );
extern int
Show_CB1_YesNo_Dlg
(  
    wxWindow * parent,
    const wxString & title,
    const wxString & msg,
    const wxChar   * txt_CkBox_L[],
    int              Is_Checked_L[]   //out
);

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::OnShow_Menu( wxCommandEvent & event )
{
    extern wxChar * RCL_Guide_Word_Root_Setting[] ;
    extern wxChar   RC_TipStr_RootDir_Specify[] ;
    extern wxChar * RCL_Sort_Name[] ;
    extern wxChar   RC_Menu_Chk_UnChk[];
    extern wxChar   RC_Menu_Do_DiffChk[] ;
    extern wxChar   RC_Menu_Chk_All[] ;
    extern wxChar   RC_Menu_UnChk_All[] ;
    extern wxChar   RC_Menu_Do_BackUp[] ;
    extern wxChar   RC_Menu_Quit_BackUp[] ;
    extern wxChar   RC_Menu_Selct_Recent_Setting[];
    extern wxChar   RC_Menu_Selct_Recent_Set_File[];
    extern wxChar   RC_Menu_ReLoad_Tree[];
    extern wxChar   RC_Menu_Reset_Tree[];

    extern wxChar   RC_Menu_Read_Setting[];
    extern wxChar   RC_Menu_Save_Setting[];
    extern wxChar   RC_Menu_Sort_Order[];
    extern wxChar   RC_Menu_Sort_Priority[];
    extern wxChar   RC_Menu_Edit[] ;
    extern wxChar   RC_Menu_Edit_Copy[] ;
    extern wxChar   RC_Menu_Edit_SelAll[] ; 
    extern wxChar   RC_Menu_Edit_Erase[]  ; 
    extern wxChar   RC_Menu_Quit_DiffChek[] ;
    extern wxChar   RC_Menu_Set_Preference[] ;
    extern wxChar   RC_Menu_Quit_LoadTree[] ; 
    extern wxChar   RC_Menu_HowToUse[] ; 
    extern wxChar   RC_Menu_Del_Sel_Desti[] ; 

        short  i, j;
        wxString  s;
        bool   bFlg ;

        SettDATA * pSetDat ;
        wxString   chkSym ;

//    wxChar  * pStr ;
//    bool      either ;
//    MyThread_BASE * pThread ;

    ::wxLogDebug( wxT("OnShow_Menu") );

    int  is_Backuping = Is_Doing_Backup() ;

    My_MENU  menu( is_Backuping ) ;
///    wxMenu * subMenu_Logger        = new wxMenu() ;
    My_MENU * subMenu_SR  = new My_MENU( is_Backuping ) ;
    My_MENU * subMenu_Selct_Recent_Set_File = new My_MENU( is_Backuping ) ;
    My_MENU * subMenu_Chek_Uncheck     = new My_MENU( is_Backuping ) ;
    My_MENU * subMenu_Sort             = new My_MENU( is_Backuping ) ;

    subMenu_Chek_Uncheck->Append_X( menu_ID_BackUp_Check_All, 
                                         RC_Menu_Chk_All );
    subMenu_Chek_Uncheck->Append_X( menu_ID_BackUp_UnCheck_All, 
                                         RC_Menu_UnChk_All );

    menu_ID_Sort_Prior            = the_Last_menu_ID ;

    menu_ID_Selct_Recent_Setting  = menu_ID_Sort_Prior + 1 +
                                    + m_DTreeCtrl->m_SortPrior_Tbl.m_Cnt_Priority  ;
    menu_ID_Selct_Recent_Set_File = menu_ID_Selct_Recent_Setting + 1 +
                                    + TopFRAME::m_Cnt_Recent_Settings  ;

    //append the menues for display-order priority
    for( i = 2 ; i < m_DTreeCtrl->m_SortPrior_Tbl.m_Cnt_Priority ; i ++ )
    {
        j = m_DTreeCtrl->m_SortPrior_Tbl.m_Priority_Lst[ i ] ;
        s = RCL_Sort_Name[ abs(j) - 1 ];
        if( j > 0 )
           s = wxT("+ ") + s ;
        else
           s = wxT("- ") + s ;
        subMenu_Sort->Append_X( menu_ID_Sort_Prior + 1 + i , s );
    }

    Connect( menu_ID_Sort_Prior + 3 ,
             menu_ID_Sort_Prior + m_DTreeCtrl->m_SortPrior_Tbl.m_Cnt_Priority,
                wxEVT_COMMAND_MENU_SELECTED,
                     wxCommandEventHandler( TopFRAME::OnChange_Sort_Priority ) );

    for( i = 0 ; i < m_Cnt_Recent_Settings ; i ++ )
    {
        pSetDat = & m_Recent_Settings_L[ i ] ;
        if( pSetDat->m_Opt_Auto_Diff_Chk >= 0 )  chkSym = wxT("+");
        else                                     chkSym = wxT("-");

        s.Printf( wxT("%d%s [%s] > [%s]"), i+1, chkSym,
                                            pSetDat->m_Src_FileName, 
                                            pSetDat->m_Dst_FileName );

        subMenu_SR->Append_X( menu_ID_Selct_Recent_Setting + 1 + i, s ) ;
    }

    Connect( menu_ID_Selct_Recent_Setting + 1 ,
             menu_ID_Selct_Recent_Setting + m_Cnt_Recent_Settings,
                wxEVT_COMMAND_MENU_SELECTED,
                     wxCommandEventHandler( TopFRAME::OnSelct_Settings ) );

    for( i = 0 ; i < m_Cnt_Recent_Setting_Files ; i ++ )
    {
        subMenu_Selct_Recent_Set_File->Append_X( menu_ID_Selct_Recent_Set_File + 1 + i, 
                                                         m_Recent_Setting_Files_L[ i ] );
    }

    //Dynamic  event procedure ނт
    Connect( menu_ID_Selct_Recent_Set_File + 1,
             menu_ID_Selct_Recent_Set_File + m_Cnt_Recent_Setting_Files,
                wxEVT_COMMAND_MENU_SELECTED,
                     wxCommandEventHandler( TopFRAME::OnSelct_SettingFile ) );

//    subMenu_Logger->Append( menu_ID_Logger_Copy, _T("&Copy Logging Buffer") );
//    subMenu_Logger->Append( menu_ID_Logger_Record, _T("&Put Tree Status to Logging Buffer") );
    s = wxString::Format( RC_TipStr_RootDir_Specify, RCL_Guide_Word_Root_Setting[0]) ;
    menu.Append_X( menu_ID_Select_RootDir_S, s );

    s = wxString::Format( RC_TipStr_RootDir_Specify, RCL_Guide_Word_Root_Setting[1]) ;
    menu.Append_X( menu_ID_Select_RootDir_D, s );
    menu.Append_X( menu_ID_ReLoad_Tree, RC_Menu_ReLoad_Tree );
    menu.Append_X( menu_ID_Reset_Tree, RC_Menu_Reset_Tree );

    menu.Append( menu_ID_Selct_Recent_Setting , RC_Menu_Selct_Recent_Setting, subMenu_SR  );
    menu.Append( menu_ID_Selct_Recent_Set_File, RC_Menu_Selct_Recent_Set_File, subMenu_Selct_Recent_Set_File );
    menu.Append_X( menu_ID_Save_Setting, RC_Menu_Save_Setting );
    menu.AppendSeparator();

    if( is_Backuping )
    {
        menu.Append( menu_ID_Quit_Thread, RC_Menu_Quit_BackUp );
    }
    else
    {
       menu.Append( menu_ID_Do_Backup, RC_Menu_Do_BackUp );
    }
    bFlg = false ;
    if( m_DTreeCtrl->m_pRoot_Node->Count_Specific_State( DualTreeCtl_ITEM::st_SELECTED, 
                                                       DualTreeCtl_ITEM::st_SELECTED ) )
    {
        bFlg = true ;
    }
    menu.AppendSeparator();
    menu.Append_X( menu_ID_Del_Sel_Desti, RC_Menu_Del_Sel_Desti )->Enable( bFlg ) ;

////    menu.Append( menu_ID_Do_Diff_Check, RC_Menu_Do_DiffChk );

    menu.AppendSeparator();
    menu.Append_X( menu_ID_Change_Sort_Order, RC_Menu_Sort_Order );
    menu.Append( menu_ID_Sort_Prior, RC_Menu_Sort_Priority, subMenu_Sort );
    menu.Append( menu_ID_Check_Uncheck, RC_Menu_Chk_UnChk, subMenu_Chek_Uncheck );
//    menu.AppendCheckItem( menu_ID_Do_Diff_Check, RC_Menu_Do_DiffChk );
//    either = false ;
//    if( m_DTreeCtrl->m_Diff_Check_Ind ) 
//        either = true ;
//    menu.Check( menu_ID_Do_Diff_Check, either ) ;
//edit/   menu.Append( menu_ID_Edit, RC_Menu_Edit, subMenu_Edit );

//    menu.Append( menu_ID_Show_BackupOnly, _T("&Show Backup files only" ));
//    menu.Append( menu_ID_Show_DestOnly_File, _T("&Show Destination Existing file only" ));
//    menu.Append( menu_ID_Logger, _T("&Logging Buffer"), subMenu_Logger );
    menu.AppendSeparator();
    menu.Append( menu_ID_Set_Preference, RC_Menu_Set_Preference );

    menu.AppendSeparator();

    menu.Append( menu_ID_HowToUse, RC_Menu_HowToUse );
    menu.Append( menu_ID_About, wxT("&About"));
    menu.Append( menu_ID_Quit, wxT("&Quit"));

    wxPoint pos = m_ArrowBtn->GetPosition() ;

    PopupMenu( & menu, pos.x, pos.y );

    event.Skip( false ) ;

    return ;
}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::OnDo_Backup( wxCommandEvent & WXUNUSED(event) )
{
    Do_Backup() ;
}

//*****************************************************************************
//
//*****************************************************************************

void TopFRAME::OnStartup( wxCommandEvent & event )
{
    wxPoint pos ;

//    m_ArrowBtn->GetPosition( & pos.x, & pos.y );
//    pos += wxPoint( 10, 20 );

//    m_MenuTip_Ctl = new wxStaticText( this, wxID_ANY, RC_TipStr_MenuBtn, pos );

//        ::wxLogDebug( wxT("MyApp::Show_Startup() m_MenuTip_Ctl= %p"), m_MenuTip_Ctl ); 
    //wxTheApp->Connect ͑SĂ window destruction 񍐂
     //wxWindow::Connect ͎g destruction 񍐂Ȃ
    wxTheApp->Connect( wxID_ANY, wxEVT_DESTROY,
                            wxWindowDestroyEventHandler( TopFRAME::OnDestroy ),
                             NULL, this );
    ///wxGetApp().

    Show_AboutDlg( this, ctrl_ID_About, RCL_About[1], RCL_About[0], 5000 ) ;
}

//*****************************************************************************
//
//*****************************************************************************

void TopFRAME::OnQuit( wxCommandEvent & WXUNUSED(event) )
{
    Close(true);
}

void TopFRAME::OnAbout( wxCommandEvent & event )
{
    extern  wxChar * RCL_About[] ;

    Show_AboutDlg( this, ctrl_ID_About, RCL_About[1], RCL_About[0], 0 ) ;
//    ::wxMessageBox( RCL_About[0], RCL_About[1],
//                     wxOK | wxICON_INFORMATION, this);

//    wxMessageDialog  dlg( this, RCL_About[0], RCL_About[1], wxOK ) ;
//    dlg.ShowModal() ;

//    wxAboutDialogInfo info ;

//    info.SetName(_T("Backup_Diff"));
//    info.SetVersion(wxVERSION_NUM_DOT_STRING_T);
//    info.SetDescription(_T("for Backup & showing differences"));
//    info.SetCopyright( wxT("(C) 2009-2010"));
//    info.AddDeveloper( wxT("Vadim Zeitlin"));

//    info.SetWebSite(_T("http://www.wxwidgets.org/"), _T("wxWidgets web site"));

//    ::wxAboutBox(info);
}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::OnHowToUse( wxCommandEvent & WXUNUSED(event)  )
{
    extern wxString Get_HelpExec_Command() ;

        ::wxLogDebug( wxT("TopFRAME::OnHowToUse() fullComd=<%s>"), Get_HelpExec_Command() ) ;
            
//    ::wxShell( Get_HelpExec_Command() );
    ::wxExecute( Get_HelpExec_Command(), wxEXEC_SYNC );
}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::OnSelect_RootDir_S( wxCommandEvent & WXUNUSED(event) )
{
    Select_RootFolder_OneSide( 0 ) ;
    return ;
}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::OnSelect_RootDir_D( wxCommandEvent & WXUNUSED(event) )
{
    Select_RootFolder_OneSide( 1 ) ;
    return ;
}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::OnReLoad_Tree( wxCommandEvent & WXUNUSED(event) )
{
    extern wxChar RC_Log_ReLoad_Tree[];

        Proc_SPACE  prc ;
        DualTreeCtl_ROOT * pRoot ;
        DualTreeCtl_ROOT * pRoot_New ;
        int  height, ret_1, ret_2 ;
        bool bRet ;

    pRoot = m_DTreeCtrl->m_pRoot_Node ;

    if( pRoot->m_Name_L[0].IsEmpty() )      return ;
    if( pRoot->m_Name_L[1].IsEmpty() )      return ;

    pRoot_New = new DualTreeCtl_ROOT() ;

    pRoot_New->m_Is_Valid_L[0] = 1 ;
    pRoot_New->m_Is_Valid_L[1] = 1 ;
    pRoot_New->m_Name_L[0] = pRoot->m_Name_L[0] ;
    pRoot_New->m_Name_L[1] = pRoot->m_Name_L[1] ;
                ::wxLogDebug( wxT("OnReLoad_Tree() pRoot=%p, pRoot_New=%p, <%s>, <%s>"), 
                              pRoot, pRoot_New, pRoot_New->m_Name_L[0], pRoot_New->m_Name_L[1] ) ;
    prc.Set( this, 0 ) ;
//    ret = prc.Load_Children( (DualTreeCtl_NODE *) & root ) ;
    ret_1 = prc.Load_Children( pRoot_New ) ;
    prc.Set( this, 1 ) ;
//    ret = prc.Load_Children( (DualTreeCtl_NODE *) & root ) ;
    ret_2 = prc.Load_Children( pRoot_New ) ;

    if( ret_1 || ret_2 )
    {
        delete pRoot_New ;                  return ;
    }

    pRoot_New->Refer_Other( m_DTreeCtrl->m_SortPrior_Tbl, * m_DTreeCtrl->m_pRoot_Node ) ;

    pRoot_New->m_DrawInf_Cursor.m_pItemBase = 0 ;

    m_DTreeCtrl->m_pRoot_Node = pRoot_New ;

    delete pRoot ;

    //pull-down menu Ƃ̊֌WŁAm_DTreeCtrl->OnDraw()̑OɁAm_DTreeCtrl mousemotion event Ă܂
    m_DTreeCtrl->Set_DrawInfo( false, & height ) ;

    Refresh() ;//reset m_pArry_Item_DrawInf[] & draw

    bRet = m_DiffChkBtn->GetValue() ;
                ::wxLogDebug( wxT("OnReLoad_Tree() -->%d"), bRet ) ;
    if( bRet )
    {
        KickOff_Diff_Check() ;
    }

    LogPut_Msg( RC_Log_ReLoad_Tree ) ;

    return ;
}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::OnReset_Tree( wxCommandEvent & WXUNUSED(event) )
{
    extern wxChar RC_Log_Reset_Tree[];
    extern wxChar * RCL_Guide_Word_Root_Setting[] ;

    delete m_DTreeCtrl->m_pRoot_Node ;
    m_DTreeCtrl->m_pRoot_Node = new DualTreeCtl_ROOT() ;

    m_DTreeCtrl->m_Cnt_Item_DrawInf = 0 ;
    m_DTreeCtrl->m_pRoot_Node->m_DrawInf_Cursor.m_pItemBase = 0 ;

    m_Path_Ctl[0]->Set_PathStr( RCL_Guide_Word_Root_Setting[0] ) ;
    m_Path_Ctl[1]->Set_PathStr( RCL_Guide_Word_Root_Setting[1] ) ;

    Refresh() ;//reset m_pArry_Item_DrawInf[] & draw

    LogPut_Msg( RC_Log_Reset_Tree ) ;
}

//*****************************************************************************
//   ̊֐͕̂̂sgp  --> TopFRAME::OnSelct_SettingFile()
//*****************************************************************************

//void TopFRAME::OnRead_Recent_Set_Files( wxCommandEvent & WXUNUSED(event))
//{
//    ::wxLogDebug( wxT("OnRead_Recentlyly_Used") );
//}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::OnRead_Setting( wxCommandEvent & WXUNUSED(event) )
{
    extern wxChar RC_Select_Setting_File[] ;

    int ret, ret1 ;

    wxString defDir = m_Setting_FileName ;

    if( defDir.IsEmpty() )
        wxGetHomeDir( & defDir );

    wxString  filter = wxString( wxT("*.") ) + wxString( g_Setting_File_Type ) ;

    wxFileDialog dialog( this, RC_Select_Setting_File, defDir, 
                          m_Setting_FileName, filter, 
                            wxFD_DEFAULT_STYLE | wxFD_OPEN );

    ret = dialog.ShowModal() ;

        ::wxLogDebug( wxT("OnRead_Setting() ret= %d\n"), ret );

    if( ret != wxID_OK)  return ;

    m_Setting_FileName = dialog.GetPath() ;

    ret1 = Read_SettingFile( m_Setting_FileName ) ;

    Add_Recently_Used_Setting_List( m_Setting_FileName ) ;
}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::OnSave_Setting( wxCommandEvent & WXUNUSED(event) )
{
    extern wxChar RC_Save_Setting_File[] ;
    int ret, ret1 ;
    ::wxLogDebug( wxT("OnSave_Setting") );

    wxString defDir = m_Setting_FileName ;

    if( defDir.IsEmpty() )
        defDir = m_Recent_Setting_Files_L[ 0 ] ;
    
    if( defDir.IsEmpty() )
        wxGetHomeDir( & defDir );

    wxString  filter = wxString( wxT("*.") ) + wxString( g_Setting_File_Type ) ;

    wxFileDialog dialog( this, RC_Save_Setting_File, defDir, 
                          m_Setting_FileName, filter, wxFD_SAVE );

    ret = dialog.ShowModal() ;

        ::wxLogDebug( wxT("OnRead_Setting() ret= %d\n"), ret );

    if( ret != wxID_OK)  return ;

    m_Setting_FileName = dialog.GetPath() ;

    ret1 = Save_SettingFile( m_Setting_FileName ) ;

    Add_Recently_Used_Setting_List( m_Setting_FileName ) ;
}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::OnShow_BackupOnly( wxCommandEvent & WXUNUSED(event) )
{
    ::wxLogDebug( wxT("OnShow_BackupOnly") );
}

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::OnShow_DestOnly_File( wxCommandEvent & WXUNUSED(event) )
{
    ::wxLogDebug( wxT("OnShow_DestOnly_File") );
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnBackUp_Check_All( wxCommandEvent & WXUNUSED(event) )
{
        ::wxLogDebug( wxT("OnBackUp_Check_All") );

    m_DTreeCtrl->m_pRoot_Node->Set_BackupOpt_Children( 1 ) ;

    Refresh() ;
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnBackUp_UnCheck_All( wxCommandEvent & WXUNUSED(event) )
{
        ::wxLogDebug( wxT("OnBackUp_UnCheck_All") );

    m_DTreeCtrl->m_pRoot_Node->Set_BackupOpt_Children( 0 ) ;

    Refresh() ;
}

#if 0 //090629
//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnDo_Diff_Check( wxCommandEvent & WXUNUSED(event) )
{
    ::wxLogDebug( wxT("OnDo_Diff_Check") );

    if( m_DTreeCtrl->m_pRoot_Node->m_Is_Valid_L[0] != 1 ) return ;
    if( m_DTreeCtrl->m_pRoot_Node->m_Is_Valid_L[1] != 1 ) return ;

    if( m_DTreeCtrl->m_Diff_Check_Ind )
    {
        m_DTreeCtrl->m_Diff_Check_Ind = 0 ;

        Refresh() ;
        return ;
    }

        MyThread_BASE * pThread ;

    m_DTreeCtrl->m_Diff_Check_Ind = 1 ;

    pThread = new Diff_Chk_THREAD( this, & m_DTreeCtrl->m_Root_Node );

    Append_Thread_Queue( pThread ) ;
}
#endif //090629

//*****************************************************************************
//
//*****************************************************************************

void 
TopFRAME::OnQuit_Thread( wxCommandEvent & WXUNUSED(event) )
{
    if( m_Idx_Thread_Work >= 0 )
    {
        m_Thread_L[ m_Idx_Thread_Work ]->m_GoOn_Flag = 0 ;
        return ;
    }
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnChange_Sort_Order( wxCommandEvent & WXUNUSED(event) )
{
    ::wxLogDebug( wxT("OnChange_Sort_Order") );

//    m_DTreeCtrl->m_pRoot_Node->Set_BackupOpt_Children( 0 ) ;

    m_DTreeCtrl->m_SortPrior_Tbl.Reverse_Priority() ;

            for( int i = 0 ; i < 6 ; i ++ )  ::wxLogDebug( wxT("-priority[%d]= %hd"), i, m_DTreeCtrl->m_SortPrior_Tbl.m_Priority_Lst[i] ) ;
    m_DTreeCtrl->m_pRoot_Node->Sort_Children( m_DTreeCtrl->m_SortPrior_Tbl );

    Refresh() ;
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnChange_Sort_Priority( wxCommandEvent & event )
{
    int idx = event.GetId() - menu_ID_Sort_Prior - 1 ;

    ::wxLogDebug( wxT("OnChange_Sort_Priority() idx = %d"), idx );

    if( idx == 2 )
    {
        m_DTreeCtrl->m_SortPrior_Tbl.m_Priority_Lst[ 2 ] = - m_DTreeCtrl->m_SortPrior_Tbl.m_Priority_Lst[ 2 ] ;
    }
    else
    {
        m_DTreeCtrl->m_SortPrior_Tbl.Move_Priority( 2, idx ) ;
    }

    m_DTreeCtrl->m_pRoot_Node->Sort_Children( m_DTreeCtrl->m_SortPrior_Tbl );

    Refresh() ;
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnLogger( wxCommandEvent & WXUNUSED(event) )
{
    ::wxLogDebug( wxT("OnLogging") );
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnLogger_Copy( wxCommandEvent & WXUNUSED(event) )
{
    ::wxLogDebug( wxT("OnLogger_Copy") );
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnLogger_Record( wxCommandEvent & WXUNUSED(event) )
{
    ::wxLogDebug( wxT("OnLogger_Record") );
}


//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnSelct_Settings( wxCommandEvent & event )
{
    SettDATA  * setData ;
    int  ret0, ret1 ;
    int idx = event.GetId() - menu_ID_Selct_Recent_Setting - 1 ;

    ::wxLogDebug( wxT("OnSelct_Settings: idx=%d"), idx );

    if( idx >= m_Cnt_Recent_Settings )  return ;

    setData = & m_Recent_Settings_L[idx] ;

    ret0 = Open_RootFolder_OneSide( setData->m_Src_FileName, 0 );
    ret1 = Open_RootFolder_OneSide( setData->m_Dst_FileName, 1 );

    if( ret0 && ret1 )  return ;

    if( setData->m_Opt_Auto_Diff_Chk < 0 )
        m_DiffChkBtn->SetValue( false ) ;
    else
        KickOff_Diff_Check() ;//invoke diff_check thread  

    Refresh() ;
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnSelct_SettingFile( wxCommandEvent & event )
{
    int idx = event.GetId() - menu_ID_Selct_Recent_Set_File - 1 ;

    ::wxLogDebug( wxT("OnSel_SettingFile idx=%d"), idx );

    if( idx >= m_Cnt_Recent_Setting_Files )  return ;

    m_Setting_FileName = m_Recent_Setting_Files_L[ idx ] ;

    Read_SettingFile( m_Setting_FileName );

    Add_Recently_Used_Setting_List( m_Setting_FileName ) ;

    Refresh() ;
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnEdit_Copy( wxCommandEvent & WXUNUSED(event) )
{
    ::wxLogDebug( wxT("OnEdit_Copy") );
    m_textCtrl->Copy();
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnEdit_SelAll( wxCommandEvent & WXUNUSED(event) )
{
    ::wxLogDebug( wxT("OnEdit_SelAll") );
    m_textCtrl->SetSelection( -1, -1 );
}

//*****************************************************************************
// destination side  file/folder ̍폜
//*****************************************************************************

void
TopFRAME::OnDel_Sel_Desti( wxCommandEvent & WXUNUSED(event) )
{
    extern  wxChar   RC_Msg_Del_Sel_Desti[] ;
    extern  wxChar   RC_Title_Del_Sel_Desti[] ;
    extern  wxChar   RC_Msg_Del_Folder_Children[] ;
    extern  wxChar   RC_Msg_Del_File_ReadOnly[] ;

    const wxChar * txt_CkBoxs[2] = { RC_Msg_Del_Folder_Children, 
                                     RC_Msg_Del_File_ReadOnly
                                   };
    int  ret, is_Checked[2] ;

            //::wxLogDebug( wxT("OnDel_Sel_Desti") );

    ret = Show_CB1_YesNo_Dlg( this, RC_Title_Del_Sel_Desti, RC_Msg_Del_Sel_Desti,
                                                           txt_CkBoxs, is_Checked );
#if 0
//    wxString str( RC_Msg_Del_Sel_Desti );

//    wxMessageDialog  msgDlg( this, str, RC_Title_Del_Sel_Desti, wxYES_NO | wxNO_DEFAULT ) ; 

//    ret = msgDlg.ShowModal() ;
#endif

    if( ret != wxID_YES )  return ;

    Delete_Selected_Destines( is_Checked ) ;
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnEdit_Erase( wxCommandEvent & WXUNUSED(event) )
{
    ::wxLogDebug( wxT("OnEdit_Erase") );
    m_textCtrl->Cut();
}

//*****************************************************************************
//
//*****************************************************************************

void
TopFRAME::OnSet_Preference( wxCommandEvent & WXUNUSED(event) )
{
    Set_Preference_DLG  dlg( this, g_FileTime_DeadBand, 0 ) ;
    int  ret ;

    ret = dlg.ShowModal() ;

    if( ret != 0 )  return ;

    g_FileTime_DeadBand = dlg.m_CTime_DeadBand ; 
    g_isCASE_SENSITIVE_FileName = dlg.m_isCaseSensitive ;
}
